systemheader:(SX    )#                                                  SX     1
####################################################################### SX     2
##      Copyright (C) 2000, The Xtal System, The University of        # SX     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SX     4
## Distributed under the GNU General Public Licence as published by   # SX     5
## the Free Software Foundation, in the hope that it will be useful   # SX     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SX     7
## for more details.                                                  # SX     8
##                                                                    # SX     9
##                           *** STARTX ***                           # SX    10
##                                                                    # SX    11
##   STARTX creates the initial archive bdf. It may also be used      # SX    12
##   in the UPDATE mode to add information to an existing bdf.        # SX    13
##                                                                    # SX    14
####################################################################### SX    15
#                                                                       SX    16
include:(XMACRO)#                                                       SX    17
#                                                                       SX    18
macro:(mxwd12c:,incr:(arith:(11,/,mxchwd:)))#                           SX    19
macro:(mxwd40c:,incr:(arith:(39,/,mxchwd:)))#                           SX    20
macro:(mxwdim:,incr:(arith:(decr:(mxchim:),/,mxchwd:)))#                SX    21
#                                                                       SX    22
extrude:(SXCOMN)#                                                       SX    23
flagon:(R)                                                                      
      INCLUDE  'ciftbx.cmn'                                                    
flagoff:(R)                                                                     
#                                                                       SX    38
INTEGER REQCIF#                        Require atomtype cif flag
INTEGER MARK2,STEP2,STOP2#             Atom type & scat fac data        SX    39
INTEGER MARK3,STEP3,STOP3,STOP3A#      Cromer mann & fox tables         SX    40
INTEGER MARK4,STEP4,STOP4#             Expl data items                  SX    41
INTEGER MARK5,STEP5,STOP5#             Dset data items                  SX    42
INTEGER ICNT#                          0=centro,1=non-centro            SX    43
INTEGER IRAD#                          Rad 1=neut;2=elec;3=xray         SX    44
INTEGER NEXPL#                         Number of expl items             SX    45
INTEGER NDSET#                         Number of dset items             SX    46
INTEGER NCRYS#                         Crystal system number            SX    47
INTEGER NSCAT#                         Number of atom types             SX    48
INTEGER ISCALE(25)#                    Scale groups for 25 data sets    SX    49
INTEGER IWNT(700)#                     Want list for indexpkt           SX    50
INTEGER IREL(701)#                     Relative packet pointers         SX    51
INTEGER LTYP#                          Lattice type                     SX    52
INTEGER NSFTB#                         Max scat f table size            SX    53
INTEGER NFF#                           Number of sf names               SX    54
INTEGER NSYM#                          Number of symops                 SX    55
INTEGER PSIZ#                          Packet size                      SX    56
INTEGER SMAT(16,200)#                  Symop array                      SX    57
INTEGER SGN#                           Sgname switch from latice line   SX    58
INTEGER UPD#                           Update mode flag                 SX    59
INTEGER LAX#                           Re-laxed symop checking          SX    60
INTEGER NREM#                          Count of remaining matrices      SX    61
INTEGER ICHR#                          Op character counter             SX    62
INTEGER IROT#                          Rotation code                    SX    63
INTEGER JROT#                          Rotation code retained           SX    64
INTEGER ITRN#                          Translation code                 SX    65
INTEGER SROT(6)#                       Save rotations from sgname       SX    66
INTEGER SAXS(6)#                       Save axes of sgname              SX    67
#                                                                       SX    68
REAL CELLP(9)#                         Cell parameters                  SX    69
REAL CELLS(9)#                         Cell sigmas                      SX    70
REAL CELMAS#                           Unit cell mass                   SX    71
REAL CELVOL#                           Unit cell volume                 SX    72
REAL SIGVOL#                           Unit cell volume sigma           SX    73
REAL SINT#                             Sin(t)/l interval                SX    74
REAL SMAX#                             Sin(t)/l maximum                 SX    75
REAL GS(9)#                            Metric tensor                    SX    76
REAL ZMOL#                             Moles/cell                       SX    77
REAL FN(9)#                            Transformation matrix            SX    78
REAL FNI(9)#                           Inverse transformation matrix    SX    79
REAL GSI(9)#                           Inverse metric tensor            SX    80
REAL RCELLP(9)#                        Recip cell constants             SX    81
REAL CAVAR(4)#                         Cell covariance corrections      SX    82
#                                                                       SX    83
string:(DSNAME,300)#                   Space for 25 dataset names       SX    84
string:(FFTAB,128)#                    Space for 16 ff names            SX    85
string:(STRG,40)#                      General string buffer            SX    86
string:(ITNM,40)#                      General string buffer            SX    87
string:(HALL,40)#                      Hall notation                    SX    88
string:(MAUG,40)#                      Herman-maugin notation           SX    89
string:(SHIFT,8)#                      For sgname shift string          SX    90
#                                                                       SX    91
COMMON/COMISX/MARK2,STEP2,STOP2,MARK3,STEP3,STOP3,MARK4,STEP4,STOP4,#   SX    92
MARK5,STEP5,STOP5,STOP3A,NCRYS,NREM,ICHR,IROT,JROT,ITRN,IREL,IWNT,#     SX    93
ICNT,NEXPL,NDSET,ISCALE,LTYP,SROT,SAXS,IRAD,#                           SX    94
NFF,NSFTB,NSCAT,NSYM,PSIZ,SMAT,UPD,LAX,SGN,REQCIF#
#                                                                       SX    96
COMMON/COMFSX/CELMAS,CELLP,CELLS,CELVOL,SINT,SMAX,GS,ZMOL,#             SX    97
SIGVOL,FN,FNI,GSI,RCELLP,CAVAR#                                         SX    98
#                                                                       SX    99
COMMON/COMCSX/DSNAME,FFTAB,STRG,SHIFT,HALL,MAUG,ITNM#                   SX   100
endext:#                                                                SX   101
#                                                                       SX   102
systemheader:(SX00)#                   Create xtal bdf shell            SX00   1
# ################################################################## #  SX00   2
#                                                                    #  SX00   3
#                               SX00                                 #  SX00   4
#                                                                    #  SX00   5
# ################################################################## #  SX00   6
SUBROUTINE SX00#                                                        SX00   7
include:(AACOMN)#                                                       SX00   8
include:(SXCOMN)#                                                       SX00   9
#                                                                       SX00  10
CALL SX10#                             Treat label, cell and cellsd     SX00  11
CALL SX11#                             Enter latice, symtry lines       SX00  12
CALL SX12#                             Build symmetry from sgname       SX00  13
CALL SX17#                             Check & write symops             SX00  14
CALL SX20#                             Input & treat atom type data     SX00  15
CALL SX30#                             Input data set information       SX00  16
CALL SX35#                             Find all default data
CALL SX40#                             Write out the bdf                SX00  18
#STOP
#                                                                       SX00  19
RETURN#                                                                 SX00  20
END#                                                                    SX00  21
systemheader:(SX10)#                   Records 1, lflabl, lfcell        SX10   1
# ################################################################## #  SX10   2
#                                                                    #  SX10   3
#                               SX10                                 #  SX10   4
#                                                                    #  SX10   5
# ################################################################## #  SX10   6
SUBROUTINE SX10#                                                        SX10   7
include:(AACOMN)#                                                       SX10   8
include:(SXCOMN)#                                                       SX10   9
#                                                                       SX10  10
REAL B(3)#                             Temp in matrix inversion         SX10  11
INTEGER I,K,J#                         Loop index                       SX10  12
INTEGER IP#                            Output packet pointer            SX10  13
#                                                                       SX10  14
string:(CH,8)#                                                          SX10  15
chardata:(SX010,AP UP SI SM XR NE EL LA )#                              SX10  16
chardata:(SX017, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY $#       SX10  17
CELMOL CELCON FORMFX FORMGN DATDEF END EXPER CELLDR ORIENT $#           SX10  18
PROTDT SCALE MAXHKL CELLDS CRYSTA )#                                    SX10  19
#                                                                       SX10  20
realdata:(DTOR,.017453293)#                                             SX10  21
datastuff:#                                                             SX10  22
#                                                                       SX10  23
# INITIALIZATION OF INFORMATION FLAGS                                   SX10  24
# -----------------------------------                                   SX10  25
#                                                                       SX10  26
REQCIF=no:#                            dont require
CELMAS=0.0#                            Set to calc xtal density         SX10  27
STRG=' '#                              Blank out sgname string          SX10  28
UPD=no:;      IRAD=no:#                Default is apriori mode          SX10  29
LAX=no:#                               Default is rigorous symmetry     SX10  30
SINT=0.02;    SMAX=2.#                 Default scatfac s interval       SX10  31
ZMOL=0.;  LTYP=0;  ICNT=-1#            Unset moles/cell & symmetry      SX10  32
DO I=1,9; CELLP(I)=0.#                 Zero cell array                  SX10  33
DO I=1,9; CELLS(I)=0.#                 Zero cell sigmas                 SX10  34
IOMARK(1)=QXSTR#                       Bdf input buffer                 SX10  35
IOMARK(2)=IOMARK(1)+bdfbuf:#           Bdf output buffer                SX10  36
incrqx:(MARK2,IOMARK(2)+bdfbuf:,SX1001)# Start of atom type data        SX10  37
#                                                                       SX10  38
#   PROCESS THE STARTX LINE                                             SX10  39
#   -----------------------                                             SX10  40
#                                                                       SX10  41
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over startx fields          SX10  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX10  43
stringlim:(K,I,J)#                     Get string limits                SX10  44
compchar:(CHRIN,I,SX010,1,2,3,NSX010,J)# Match string with options      SX10  45
IF(J==0) iquit:(SX1003)#               No match                         SX10  46
IF(J==2) UPD=yes:#                     Caller wants update run          SX10  47
ELSE IF(J==3)#                         Enter scatfac s interval         SX10  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX10  49
K=K+1;   SINT=BUFIN(K)#                Store input interval             SX10  50
SINT=.01*FLOAT(NINT(100.*AMAX1(.01,SINT)))# Make dstol n*0.01           SX10  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX10  52
ELSE IF(J==4)#                         Enter scatfac s maximum          SX10  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX10  54
K=K+1;   SMAX=MIN(6.,BUFIN(K))#        Store input s maximum            SX10  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX10  56
ELSE IF(J==5) IRAD=3#                  Radiation set as xray            SX10  57
ELSE IF(J==6) IRAD=1#                  Radiation set as neutron         SX10  58
ELSE IF(J==7) IRAD=2#                  Radiation set as electron        SX10  59
ELSE IF(J==8) LAX=yes:#                Relaxed symmetry checking        SX10  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX10  61
NSFTB=INT(SMAX/SINT)+1#                Number ff in scatfac table       SX10  62
IF(NSFTB>400) iquit:(SX1005)#          Max ff in table exceeded         SX10  63
#                                                                       SX10  64
#   WRITE HIST AND LABL RECORDS                                         SX10  65
#   ---------------------------                                         SX10  66
#                                                                       SX10  67
IF(UPD==yes:) copyfile:(1,2,lrhist:,lrlabl:)# If in update mode         SX10  68
ELSE#                                  Write out new records            SX10  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX10  70
writepkt:(2,1,3,IP)#                   Record 1: for prog, date, time   SX10  71
writepkt:(2,lrlabl:,mxwdim:,IP)#       Lrlabl: for date and time        SX10  72
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               SX10  73
movector:(TITLE,18,QX(IP+1),1,8,0)#    Insert current date              SX10  74
gettime:(CH)#                          Get current time                 SX10  75
movector:(CH,1,QX(IP+1),10,8,0)#       Insert current time              SX10  76
writepkt:(2,lrlabl:,mxwdim:,IP)#       **** writepkt ****               SX10  77
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               SX10  78
movector:(TITLE,59,QX(IP+1),1,72,0)#   Creation header line             SX10  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX10  80
#                                                                       SX10  81
#    READ INPUT LINES                                                   SX10  82
#    ================                                                   SX10  83
#                                                                       SX10  84
REPEAT#                                Loop over input lines            SX10  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX10  86
SYNTXF=1#                              Syntax checker off               SX10  87
readline:(SX017,NSX017)#               Read a line                      SX10  88
#                                                                       SX10  89
IF(LINID<4\LINID>5)#                   Not an =sgname= line             SX10  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX10  91
SYNTXF=0#                              Hence check syntax               SX10  92
dcodefld:#                             Rescan line                      SX10  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX10  94
#                                                                       SX10  95
IF(LINID>3) BREAK#                     Exit if not cell cellsd label    SX10  96
#                                                                       SX10  97
IF(LINID==1)#                          *********** label ***********    SX10  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX10  99
writepkt:(2,lrlabl:,mxwdim:,IP)#       **** writepkt ****               SX10 100
movector:(BLANK,1,QX(IP+1),1,mxchim:,1)# Blank out packet               SX10 101
movector:(CHRIN,1,QX(IP+1),1,CHRMAX,0)# Move in input image             SX10 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX10 103
#                                                                       SX10 104
ELSE IF(LINID==2)#                     *********** cell  ***********    SX10 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX10 106
DO I=1,3#                              Move to cellp array              SX10 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX10 108
CELLP(I)=BUFIN(I)#                     A,b,c                            SX10 109
CELLS(I)=CELLP(I)*0.0001#              Set default esd                  SX10 110
ifvo:(BUFIN(I+3)) BUFIN(I+3)=90.#      Set default angle                SX10 111
ELSE IF(BUFIN(I+3)<=1.0) BUFIN(I+3)=ACOS(BUFIN(I+3))/DTOR# Cos input    SX10 112
CELLP(I+6)=BUFIN(I+3)#                 Store angles directly            SX10 113
CELLS(I+6)=CELLP(I+6)*0.0001#          Set default esd                  SX10 114
ifeq:(CELLP(I+6),90.) CELLP(I+3)=0.0#  Cosine is 0.0                    SX10 115
ELSE                  CELLP(I+3)=COS(CELLP(I+6)*DTOR)# Cosines          SX10 116
ifeq:(CELLP(I+3),0.) CELLP(I+3)=0.#    Make very small zero             SX10 117
CELLS(I+3)=CELLP(I+3)*0.0001#          Set default esd                  SX10 118
ifeq:(CELLS(I+3),0.) CELLS(I+3)=0.#    Make very small zero             SX10 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX10 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX10 121
#                                                                       SX10 122
ELSE IF(LINID==3)#                     *********** cellsd **********    SX10 123
DO I=1,3#                              Loop over axes                   SX10 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX10 125
IF(BUFIN(I)>-.1) CELLS(I)=BUFIN(I)#    Sigma a,b,c                      SX10 126
ifvo:(BUFIN(I+3)) NEXT#                S.d. are present                 SX10 127
CELLS(I+3)=SIN(CELLP(I+6)*DTOR)*BUFIN(I+3)*DTOR# Sigma cosine           SX10 128
CELLS(I+6)=BUFIN(I+3)#                 S.d. of angles #                 SX10 129
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX10 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX10 131
IF(UPD==yes:)#                         If in update mode                SX10 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX10 133
readwpkt:(1,lrcell:,I,IP,0)#           Read cell data packet            SX10 134
ifeq:(CELLP(1),0.)#                    Test if input                    SX10 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX10 136
movereal:(QX,IP+1,CELLP,1,9,0)#        Store cell data                  SX10 137
DO I=7,9; CELLP(I)=CELLP(I)*360.#      Convert degrees                  SX10 138
DO I=4,6; CELLP(I)=COS(CELLP(I+3)*DTOR)# Cosines                        SX10 139
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX10 140
readwpkt:(1,lrcell:,I,IP,0)#           Read cell data packet            SX10 141
ifeq:(CELLS(1),0.)#                    Test if input                    SX10 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX10 143
movereal:(QX,IP+1,CELLS,1,9,0)#        Store cell esds                  SX10 144
DO I=7,9; CELLS(I)=CELLS(I)*360.#      Convert degrees                  SX10 145
DO I=4,6; CELLS(I)=SIN(CELLP(I+3)*DTOR)*CELLS(I+3)*DTOR# Esd cosine     SX10 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX10 147
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX10 148
ELSE ifeq:(CELLP(1),0.)iquit:(SX1002)# Quit if no cell data             SX10 149
#                                                                       SX10 150
#                                      Metric tensor                    SX10 151
GS(1)=CELLP(1)**2#                     A..2                             SX10 152
GS(2)=CELLP(1)*CELLP(2)*CELLP(6)#      A.b.cos(gamma)                   SX10 153
GS(3)=CELLP(1)*CELLP(3)*CELLP(5)#      A.c.cos(beta)                    SX10 154
GS(4)=GS(2)#                           A.b.cos(gamma)                   SX10 155
GS(5)=CELLP(2)**2#                     B..2                             SX10 156
GS(6)=CELLP(2)*CELLP(3)*CELLP(4)#      B.c.cos(alpha)                   SX10 157
GS(7)=GS(3)#                           A.c.cos(beta)                    SX10 158
GS(8)=GS(6)#                           B.c.cos(alpha)                   SX10 159
GS(9)=CELLP(3)**2#                     C..2                             SX10 160
DO I=1,9; GSI(I)=GS(I)#                Copy to inverse                  SX10 161
#                                                                       SX10 162
DO I=1,3#                              Invert the tensor                SX10 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX10 164
B(3)=1.0/GSI(1)#                                                        SX10 165
B(1)=GSI(2)*B(3)#                                                       SX10 166
B(2)=GSI(3)*B(3)#                                                       SX10 167
GSI(3)=-GSI(4)*B(3)#                                                    SX10 168
GSI(1)=GSI(5)-GSI(4)*B(1)#                                              SX10 169
GSI(2)=GSI(6)-GSI(4)*B(2)#                                              SX10 170
GSI(6)=-GSI(7)*B(3)#                                                    SX10 171
GSI(4)=GSI(8)-GSI(7)*B(1)#                                              SX10 172
GSI(5)=GSI(9)-GSI(7)*B(2)#                                              SX10 173
GSI(7)=B(1)#                                                            SX10 174
GSI(8)=B(2)#                                                            SX10 175
GSI(9)=B(3)#                                                            SX10 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX10 177
#                                      Reciprocal cell constants        SX10 178
RCELLP(1)=SQRT(GSI(1))#                A*                               SX10 179
RCELLP(2)=SQRT(GSI(5))#                B*                               SX10 180
RCELLP(3)=SQRT(GSI(9))#                C*                               SX10 181
RCELLP(4)=GSI(6)/(RCELLP(2)*RCELLP(3))# Cos(alpha*)                     SX10 182
RCELLP(5)=GSI(3)/(RCELLP(1)*RCELLP(3))# Cos(beta*)                      SX10 183
RCELLP(6)=GSI(2)/(RCELLP(1)*RCELLP(2))# Cos(gamma*)                     SX10 184
RCELLP(7)=ACOS(RCELLP(4))/DTOR#        Alpha*                           SX10 185
RCELLP(8)=ACOS(RCELLP(5))/DTOR#        Beta*                            SX10 186
RCELLP(9)=ACOS(RCELLP(6))/DTOR#        Gamma*                           SX10 187
#                                                                       SX10 188
FN(1)=CELLP(1)*SQRT(1.0-CELLP(5)**2)$#                                  SX10 189
              *SQRT(1.0-RCELLP(6)**2)# A.sin(beta).sin(gamma*)          SX10 190
FN(2)=-CELLP(1)*RCELLP(6)$#                                             SX10 191
               *SQRT(1.0-CELLP(5)**2)# -a.sin(beta).cos(gamma*)         SX10 192
FN(3)=CELLP(1)*CELLP(5)#               A.cos(beta)                      SX10 193
FN(4)=0.0#                                                              SX10 194
FN(5)=CELLP(2)*SQRT(1.0-CELLP(4)**2)#  B.sin(alpha)                     SX10 195
FN(6)=CELLP(2)*CELLP(4)#               B.cos(alpha)                     SX10 196
FN(7)=0.0#                                                              SX10 197
FN(8)=0.0#                                                              SX10 198
FN(9)=CELLP(3)#                        C                                SX10 199
#                                      Invert & transpose the matrix    SX10 200
FNI(3)=0.0;FNI(6)=0.0;FNI(9)=1.0/FN(9)# Third row                       SX10 201
FNI(2)=0.0#                            Middle row                       SX10 202
FNI(5)=1.0/FN(5)#                      Middle row                       SX10 203
FNI(8)=-FN(6)*FNI(9)*FNI(5)#           Middle row                       SX10 204
FNI(1)=1.0/FN(1)#                      Top row                          SX10 205
FNI(4)=-FN(2)*FNI(5)*FNI(1)#           Top row                          SX10 206
FNI(7)=(-FN(3)*FNI(9)-FN(2)*FNI(8))*FNI(1)# Top row                     SX10 207
#                                                                       SX10 208
RETURN#                                                                 SX10 209
END#                                                                    SX10 210
systemheader:(SX11)#                   Process latice & symtry lines    SX11   1
# ################################################################## #  SX11   2
#                                                                    #  SX11   3
#                               SX11                                 #  SX11   4
#                                                                    #  SX11   5
# ################################################################## #  SX11   6
SUBROUTINE SX11#                                                        SX11   7
include:(AACOMN)#                                                       SX11   8
include:(SXCOMN)#                                                       SX11   9
#                                                                       SX11  10
REAL A#                                                                 SX11  11
INTEGER DET#                           Determinant of rotation matr     SX11  12
INTEGER I,J,K#                         Loop index                       SX11  13
INTEGER KEY(arith:(mxchim:,+,1))#      Key to each symmetry char        SX11  14
INTEGER IPT,IP#                        Pointers                         SX11  15
INTEGER LINLEN#                        Effective line length            SX11  16
INTEGER NUM#                           Temporary number                 SX11  17
intdata:(IFIELD,0)#                    Flag x,y,z rotation              SX11  18
intdata:(SING,0)#                      Sign of rotation                 SX11  19
chardata:(SX021,PIRFABCN)#                                              SX11  20
chardata:(SX022, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY $#       SX11  21
CELMOL CELCON FORMFX FORMGN DATDEF END EXPER CELLDR ORIENT $#           SX11  22
PROTDT SCALE MAXHKL CELLDS CRYSTA )#                                    SX11  23
#CHARDATA:(SX023,[123456XYZ/,+- ])#                                     SX11  24
chardata:(SX023,[0123456789XYZ/,+- ])#                                  SX11  25
datastuff:#                                                             SX11  26
#                                                                       SX11  27
#                                                                       SX11  28
NSYM=0; SGN=yes:#                      Initialize count of symops.      SX11  29
DO J=1,200#                            Loop over symops                 SX11  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX11  31
SMAT(16,J)=12#                         (4,4) matrix element             SX11  32
DO I=1,15 ; SMAT(I,J)=0#               Others                           SX11  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX11  34
IF(LAX==yes:)$(ICNT=1;LTYP=1;SGN=no:$)# Initialize for absent latice    SX11  35
#                                                                       SX11  36
#   ENTER LATICE AND SYMTRY LINES                                       SX11  37
#   -----------------------------                                       SX11  38
#                                                                       SX11  39
IF(LINID==6\LINID==7)#                 If latice or symtry lines        SX11  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX11  41
REPEAT#                                Loop latice and symtry lines     SX11  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX11  43
#                                                                       SX11  44
IF(LINID==6)#                          *********** latice **********    SX11  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX11  46
DO I=1,2#                              Loop over fields 1-2             SX11  47
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX11  48
stringlim:(I,J,K)#                     Point to character               SX11  49
compchar:(CHRIN,J,SX021,1,1,1,NSX021,K)# Identify character             SX11  50
IF(I==1)#                              Centrosymmetricity field         SX11  51
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX11  52
IF     (K==8) ICNT=1#                  Non-centrosymmetric              SX11  53
ELSE IF(K==7) ICNT=0#                  Centrosymmetric                  SX11  54
ELSE iquit:(SX1101)#                   Bad character                    SX11  55
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX11  56
IF(I==2)#                              Lattice field                    SX11  57
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX11  58
IF(K==0\K==8) iquit:(SX1102)#          Bad character                    SX11  59
LTYP=K#                                Lattice type                     SX11  60
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX11  61
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX11  62
ifnv:(BUFIN(3)) SGN=no:#               Switch off sgname generation     SX11  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX11  64
#                                                                       SX11  65
ELSE IF(LINID==7)#                     ********* symtry **********      SX11  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX11  67
#                                                                       SX11  68
DO I=CHRCOL,CHRMAX#                    Loop over input image            SX11  69
compchar:(CHRIN,I,SX023,1,1,1,NSX023,KEY(I))# Identify all character    SX11  70
DO LINLEN=CHRMAX,CHRCOL,-1#            Begin at end of string           SX11  71
IF(CHRIN(LINLEN^LINLEN)!=' ')BREAK#    Find last non blank              SX11  72
FOR(I=CHRCOL+1;I<=LINLEN;I=I+1)#       Loop over input image            SX11  73
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX11  74
WHILE (LINLEN>I&KEY(I)==18)#           Strip multi and selctd blnks     SX11  75
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX11  76
IF(((KEY(I-1)>=14)&(KEY(I-1)<=19))\#   Was last char blk or operator    SX11  77
((KEY(I+1)==14)\(KEY(I+1)==15)\(KEY(I+1)==18)))# Is next /,blnk         SX11  78
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX11  79
DO J=I,LINLEN-1 ; CHRIN(J^J)=CHRIN(J+1^J+1)# Shift to left & erase      SX11  80
DO J=I,LINLEN-1 ; KEY(J)=KEY(J+1)#     Shift to left                    SX11  81
CHRIN(LINLEN^LINLEN)=' '#              Blank last char                  SX11  82
LINLEN=LINLEN-1#                       Decrement length                 SX11  83
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX11  84
ELSE BREAK#                                                             SX11  85
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX11  86
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX11  87
#                                      End of unrequired blnk strip     SX11  88
DO I=CHRCOL,CHRMAX#                    Loop over input image            SX11  89
compchar:(CHRIN,I,SX023,1,1,1,NSX023,KEY(I))# Identify all character    SX11  90
KEY(CHRMAX+1)=18#                      Store blank signal at last +     SX11  91
#                                                                       SX11  92
FOR(I=CHRCOL;I<=CHRMAX;I=I+1)#         Scan input image less one        SX11  93
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX11  94
IF(KEY(I)==0) iquit:(SX1109)#          Bad character                    SX11  95
ELSE IF(KEY(I)==18)#                   Blank                            SX11  96
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX11  97
IF(KEY(I+1)!=18)#                      Followed by non-blank            SX11  98
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX11  99
NSYM=NSYM+1#                           Signals start of symop           SX11 100
IFIELD=1#                              First of three parts             SX11 101
SING=1#                                Default sign positive            SX11 102
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX11 103
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX11 104
ELSE IF(KEY(I)==17) SING=-1#           Sign is negative                 SX11 105
ELSE IF(KEY(I)==16) SING=1#            Positive sign                    SX11 106
ELSE IF(KEY(I)<11)#                    A number                         SX11 107
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX11 108
IF(KEY(I+1)<11)#                       A second number                  SX11 109
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX11 110
NUM=(KEY(I)-1)*10+KEY(I+1)-1#          Encode                           SX11 111
I=I+1#                                 Pretend only one digit           SX11 112
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX11 113
ELSE NUM=KEY(I)-1#                     Encode <10                       SX11 114
IF(KEY(I+1)!=14) A=12.*FLOAT(NUM)#     No / after number (a=0)          SX11 115
ELSE#                                  There is a /                     SX11 116
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SX11 117
IF(KEY(I+2)-1>6)     iquit:(SX1104)#   No number after /                SX11 118
IF(KEY(I+2)-1==5)    iquit:(SX1105)#   Denominator is 5                 SX11 119
IF(KEY(I+2)==1)      iquit:(SX1108)#   Denominator is 0                 SX11 120
#IF(KEY(I)>KEY(I+2)) IQUIT:(SX1106)#   TRANSLATION > 1                  SX11 121
A=12.*FLOAT(NUM)/FLOAT(KEY(I+2)-1)#    Translation                      SX11 122
I=I+2#                                                                  SX11 123
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SX11 124
IF(LAX==no:)#                          Not relaxed                      SX11 125
SMAT(IFIELD+12,NSYM)=MOD(144+SING*INT(A),12)# Translation modulo 12     SX11 126
ELSE SMAT(IFIELD+12,NSYM)=SING*INT(A)# Raw input translations           SX11 127
#SMAT(IFIELD+12,NSYM)=12*SING*KEY(I)/KEY(I+2)# TRANSLATION - ORIGINAL   SX11 128
IF(KEY(I+1)!=16&KEY(I+1)!=17& $#       No rotation sign                 SX11 129
KEY(I+1)!=15&KEY(I+1)!=18)iquit:(SX1107)# Or comma or blank             SX11 130
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX11 131
ELSE IF((KEY(I)<14)&(KEY(I)>10))#      A letter                         SX11 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SX11 133
IPT=IFIELD+4*(KEY(I)-11)#              Point to its place               SX11 134
SMAT(IPT,NSYM)=12*SING#                Rotation element                 SX11 135
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SX11 136
ELSE IF(KEY(I)==15)#                   Comma                            SX11 137
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SX11 138
IFIELD=IFIELD+1#                       Go to next part                  SX11 139
SING=1#                                Default sign positive            SX11 140
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SX11 141
ELSE iquit:(SX1109)#                   Bad character                    SX11 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX11 143
#                                                                       SX11 144
DET=SMAT(1,NSYM)*SMAT(6,NSYM)*SMAT(11,NSYM)$#                           SX11 145
     -SMAT(2,NSYM)*SMAT(5,NSYM)*SMAT(11,NSYM)$#                         SX11 146
     -SMAT(1,NSYM)*SMAT(7,NSYM)*SMAT(10,NSYM)$#                         SX11 147
     -SMAT(3,NSYM)*SMAT(6,NSYM)*SMAT(9,NSYM)$#                          SX11 148
     +SMAT(3,NSYM)*SMAT(5,NSYM)*SMAT(10,NSYM)$#                         SX11 149
     +SMAT(2,NSYM)*SMAT(7,NSYM)*SMAT(9,NSYM)# Determinant               SX11 150
IF(IABS(DET)!=1728) iquit:(SX1111)#    Determinant not +1 or -1         SX11 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX11 152
#                                                                       SX11 153
ELSE  BREAK#                           All finished lines out of or     SX11 154
#                                                                       SX11 155
SYNTXF=1#                              Turn off syntax checker.         SX11 156
readline:(SX022,NSX022)#               Read a symop line                SX11 157
IF(LINID==7) NEXT#                     Skip if a symmtry line           SX11 158
SYNTXF=0#                              Reset the syntax check flag      SX11 159
dcodefld:#                             Rescan for syntax errors         SX11 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX11 161
IF(NSYM==0) iquit:(SX1112)#            No symops big trouble            SX11 162
IF(SGN==yes:) CALL SX14#               Convert to sgname                SX11 163
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX11 164
#                                                                       SX11 165
ELSE IF(UPD==yes:)#                    Try symmtry/latice from bdf      SX11 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SX11 167
readwpkt:(1,lrsymm:,K,IP,0)#           Packet 1 of lrsymm:              SX11 168
IF(IP>0)#                              If symmetry data present         SX11 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SX11 170
ifnv:(QX(IP+1)) LTYP=NINT(QX(IP+1))#   Get out the lattice type         SX11 171
LTYP=MOD(LTYP-1,7)+1#                  Take out centre flag             SX11 172
ifnv:(QX(IP+2)) ICNT=NINT(QX(IP+2))#   Centrosymmetricity               SX11 173
ifnv:(QX(IP+8)) ZMOL=QX(IP+8)#         Moles/cell                       SX11 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SX11 175
REPEAT#                                Loop over symops                 SX11 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SX11 177
readwpkt:(1,lrsymm:,K,IP,0)#           **** readwkpt ****               SX11 178
IF (IP<=0) BREAK#                                                       SX11 179
NSYM=NSYM+1#                           Count the symops                 SX11 180
DO I=1,3 ;   SMAT(I,NSYM)=12*NINT(QX(IP+I))# Read the symops and conv   SX11 181
DO I=4,6 ;   SMAT(I+1,NSYM)=12*NINT(QX(IP+I))#                          SX11 182
DO I=7,9 ;   SMAT(I+2,NSYM)=12*NINT(QX(IP+I))#                          SX11 183
DO I=10,12 ; SMAT(I+3,NSYM)=NINT(12.*QX(IP+I))#                         SX11 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SX11 185
IF(NSYM!=0) CALL SX14#                 Convert to sgname                SX11 186
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SX11 187
#                                                                       SX11 188
RETURN#                                                                 SX11 189
END#                                                                    SX11 190
systemheader:(SX12)#                   Symmetry from hall sgname        SX12   1
################################################################        SX12   2
#                                                                       SX12   3
#                         SX12                                          SX12   4
#                                                                       SX12   5
################################################################        SX12   6
SUBROUTINE SX12#                                                        SX12   7
include:(AACOMN)#                                                       SX12   8
include:(SXCOMN)#                                                       SX12   9
#                                                                       SX12  10
INTEGER I,J,K,L,M,N#                   Working integer varaibles        SX12  11
INTEGER IAXS#                          Current axis pointer to tab      SX12  12
INTEGER IEND#                          Pointer                          SX12  13
INTEGER ISGN#                          Matrix sign flag                 SX12  14
INTEGER JAXS#                          Previous axis pointer to tab     SX12  15
INTEGER NEQP#                          Number of equivalent positio     SX12  16
INTEGER NGEN#                          No. of generator seitz matri     SX12  17
INTEGER NROT#                          Current rot order (1,2,3,4,6     SX12  18
INTEGER NEW#                           Position of matrix product       SX12  19
INTEGER OLD#                           Matrix count before inner lo     SX12  20
INTEGER ROT(12,20)#                    Table of rotation matrices       SX12  21
INTEGER SVEC(3)#                       Temporary t-vector array         SX12  22
INTEGER ORSH(3)#                       Origin shift values              SX12  23
INTEGER ORAX#                          Origin shift axis count          SX12  24
#                                                                       SX12  25
string:(SNAME,80)#                                                      SX12  26
chardata:(CHARS,'123456prabcifnuvwd -xyz*q"(:)')#                       SX12  27
chardata:(NUMS,0123456)#                                                SX12  28
intdata:(RM1,[$#                                                        SX12  29
1,0,0,0,0,1,0,0,0,0,1,0,#              1-fold rotation on x,y,z         SX12  30
1,0,0,0,0,-1,0,0,0,0,-1,0,#            2-fold rotation on x             SX12  31
-1,0,0,0,0,1,0,0,0,0,-1,0,#            2-fold rotation on y             SX12  32
-1,0,0,0,0,-1,0,0,0,0,1,0,#            2-fold rotation on z             SX12  33
1,0,0,0,0,0,1,0,0,-1,-1,0,#            3-fold rotation on x             SX12  34
-1,0,-1,0,0,1,0,0,1,0,0,0,#            3-fold rotation on y             SX12  35
0,1,0,0,-1,-1,0,0,0,0,1,0,#            3-fold rotation on z             SX12  36
1,0,0,0,0,0,1,0,0,-1,0,0,#             4-fold rotation on x             SX12  37
0,0,-1,0,0,1,0,0,1,0,0,0,#             4-fold rotation on y             SX12  38
0,1,0,0,-1,0,0,0,0,0,1,0])#            4-fold rotation on z             SX12  39
intdata:(RM2,[$#                                                        SX12  40
1,0,0,0,0,1,1,0,0,-1,0,0,#             6-fold rotation on x             SX12  41
0,0,-1,0,0,1,0,0,1,0,1,0,#             6-fold rotation on y             SX12  42
1,1,0,0,-1,0,0,0,0,0,1,0,#             6-fold rotation on z             SX12  43
0,0,1,0,1,0,0,0,0,1,0,0,#              3-fold rotation on x+y+z         SX12  44
-1,0,0,0,0,0,-1,0,0,-1,0,0,#           2-fold rotation on y-z           SX12  45
0,0,-1,0,0,-1,0,0,-1,0,0,0,#           2-fold rotation on z-x           SX12  46
0,-1,0,0,-1,0,0,0,0,0,-1,0,#           2-fold rotation on x-y           SX12  47
-1,0,0,0,0,0,1,0,0,1,0,0,#             2-fold rotation on y+z           SX12  48
0,0,1,0,0,-1,0,0,1,0,0,0,#             2-fold rotation on z+x           SX12  49
0,1,0,0,1,0,0,0,0,0,-1,0])#            2-fold rotation on x+y           SX12  50
intdata:(TAB,[1,1,1,2,3,4,5,6,7,8,9,10,0,0,0,11,12,13,#                 SX12  51
14,14,14,15,16,17,18,19,20])#                                           SX12  52
intdata:(VEC,[6,0,0,0,6,0,0,0,6,6,6,6,3,0,0,0,3,0,0,0,3,3,3,3])#        SX12  53
datastuff:#                                                             SX12  54
#                                                                       SX12  55
IF(SGN==yes:)#                         If symops to be generated        SX12  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX12  57
CALL SX13#                             Extract sgname notation          SX12  58
SNAME=HALL;    STRG=HALL#              Transfer to local variable       SX12  59
DO I=1,40; IF(SNAME(I^I)=='_') SNAME(I^I)=' '# Convert '_' to blanks    SX12  60
#                                                                       SX12  61
#  DECODE SPACE GROUP NAME INTO GENERATOR MATRICES                      SX12  62
#  -----------------------------------------------                      SX12  63
#                                                                       SX12  64
N=0; DO J=1,20; DO I=1,12#             Loop over matrices               SX12  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX12  66
N=N+1#                                 Incr rot matrix pointer          SX12  67
IF(N<121) ROT(I,J)=RM1(N)#             Transfer first matrix            SX12  68
ELSE      ROT(I,J)=RM2(N-120)#         Transfer second matrix           SX12  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX12  70
NGEN=1; NEQP=1; ISGN=12#               Set initial symops               SX12  71
NROT=0; IROT=0; JROT=0; IAXS=0; JAXS=0# Zero axis settings              SX12  72
ICNT=1; LTYP=0; ORAX=0#                Start lattice and no centre      SX12  73
DO I=1,3;  SVEC(I)=0#                  Zeroize vector accumulator       SX12  74
DO I=1,3;  ORSH(I)=0#                  Zeroize origin shift values      SX12  75
DO I=1,6;  SROT(I)=0#                  Zeroize rotations                SX12  76
DO I=1,6;  SAXS(I)=0#                  Zeroize axes                     SX12  77
DO I=1,50#                             Loop over symop matrices         SX12  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX12  79
DO J=1,15; SMAT(J,I)=0#                Zero the symop matrices          SX12  80
SMAT(16,I)=12#                         Set the (4,4) element to 12      SX12  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX12  82
DO I=1,11,5; SMAT(I,1)=12#             Set identity rotations           SX12  83
#                                                                       SX12  84
#                                                                       SX12  85
DO N=1,40#                             ********* scan input buffer      SX12  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX12  87
M=INDEX(CHARS,SNAME(N^N))#             Identify character               SX12  88
IF(M==0) BREAK#                        Unidentified char                SX12  89
IF((M==19)&(NROT==0)) NEXT#            Skip inactive blanks             SX12  90
IF(LTYP==0)#                           ********** specify lattice       SX12  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX12  92
IF(M==20) ICNT=0#                      Initial-indicates centre         SX12  93
ELSE IF((M>6)&(M<14)) LTYP=M-6#        Extract lattice code             SX12  94
ELSE#                                  Illegal character                SX12  95
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX12  96
writeline:(1,SNAME,40,3,3)#            Output the offending code        SX12  97
iquit:(SX1201)#                        Quit on illegal char             SX12  98
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX12  99
#                                                                       SX12 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX12 101
ELSE IF(M==20) ISGN=-12#               Later neg indicates inversio     SX12 102
ELSE IF(M>27) BREAK#                   Exit if : or )                   SX12 103
#                                                                       SX12 104
ELSE IF(M==27)#                        Test for origin shift (          SX12 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX12 106
FOR(I=N+1;I<40;I=I+1)#                 Loop over remaining chars        SX12 107
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX12 108
M=INDEX(CHARS(28^29),SNAME(I+1^I+1))#  Is this ) or :                   SX12 109
IF(M>0)#                               End detected                     SX12 110
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX12 111
IEND=I+1; SNAME(I+1^80)=' '#           Blank off remainder              SX12 112
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX12 113
M=INDEX(NUMS,SNAME(I^I))#              Look for digits                  SX12 114
IF(M==0) NEXT#                         Skip until found                 SX12 115
ORAX=ORAX+1#                           Incr axis counter                SX12 116
ORSH(ORAX)=MOD((M-1)*2,12)#            Store as coord shift             SX12 117
IF(SNAME(I-1^I-1)=='-') ORSH(ORAX)=12-ORSH(ORAX)# Reverse shift         SX12 118
IF(ORAX==3) BREAK#                     Test if last axis                SX12 119
I=I+1#                                 Skip extra char                  SX12 120
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX12 121
IF(ORAX<3) iquit:(SX1202)#             Shift data missing               SX12 122
BREAK#                                 Must be all thru                 SX12 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX12 124
#                                                                       SX12 125
ELSE IF(NROT==0)#                      ********* specify rotation       SX12 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX12 127
IF(M>6) iquit:(SX1210)#                Quit on illegal char             SX12 128
SROT(NGEN)=M#                          Save rotation                    SX12 129
IF(M==1&ISGN<0) NEQP=NEQP*2#           Indicates -1 not at origin       SX12 130
ELSE IF(M==1) NEXT#                    Skip on +1                       SX12 131
NROT=M;   IROT=M#                      Set rotation order & pointer     SX12 132
NGEN=NGEN+1#                           Count as next generator matr     SX12 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX12 134
ELSE#                                  If the rot order is set          SX12 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX12 136
IF(M>20) IAXS=M-20#                    ********* specify direction      SX12 137
IF(IAXS==0)#                           Test if default axis require     SX12 138
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX12 139
IF((NGEN==2)\(IROT==1))       IAXS=3#  Rot1 or axis1 assumed z          SX12 140
ELSE IF((NROT==2)&(JROT==2))  IAXS=1#  Later axes assumed as x          SX12 141
ELSE IF((NROT==2)&(JROT==3))  IAXS=5#  Axis after 3,6 assumed as x-     SX12 142
ELSE IF(NROT==3)              IAXS=4#  Axis for later 3 must be x+y     SX12 143
ELSE iquit:(SX1203)#                   Quit on illegal char             SX12 144
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX12 145
IF(M>20) SAXS(NGEN)=IAXS#              Save axis pointer                SX12 146
IF(IAXS>3)#                            For non-principal axes           SX12 147
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX12 148
IROT=IAXS+3#                           Redefine order for table         SX12 149
IAXS=JAXS#                             Axis defined by prev rotatio     SX12 150
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX12 151
IF(M<6)#                               ********* specify translatio     SX12 152
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX12 153
IF(IROT>6) iquit:(SX1208)#             Only for x,y,z directions        SX12 154
SVEC(IAXS)=SVEC(IAXS)+M*12/NROT#       Calc translation in 12ths        SX12 155
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX12 156
IF(((M>8)&(M<12))\((M>13)&(M<19)))#    Test for a,b,c,n,u,v,w,d         SX12 157
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX12 158
IF(M<12) I=(M-9)*3;  ELSE I=(M-11)*3#  Point to vector array            SX12 159
DO J=1,3; SVEC(J)=SVEC(J)+VEC(J+I)#    Sum in vector translations       SX12 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX12 161
#                                                                       SX12 162
IF(M==19)#                             ******** construct generators    SX12 163
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX12 164
K=(IROT-1)*3;   K=TAB(IAXS+K)#         Point to rotation matrix         SX12 165
DO I=1,12#                             Loop over rotation partition     SX12 166
SMAT(I,NGEN)=ROT(I,K)*ISGN#                                             SX12 167
DO I=13,15#                            Loop over translation vector     SX12 168
SMAT(I,NGEN)=MOD(SVEC(I-12)+120,12)#   Deposit translation base 12      SX12 169
NEQP=NEQP*NROT#                        Calc the number of equiv. po     SX12 170
IF(NROT>3) NROT=NROT/2#                Reduce order to 2 or 3           SX12 171
JROT=NROT; NROT=0; IROT=0#             Reset order flags                SX12 172
JAXS=IAXS; IAXS=0; ISGN=12#            Reset axis flags                 SX12 173
DO I=1,3;   SVEC(I)=0#                 Zeroize vector accumulator       SX12 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX12 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX12 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX12 177
IF((NROT>0)\(LTYP==0)) iquit:(SX1204)# Error condition                  SX12 178
##                                                                      SX12 179
## add inversion and center matrices                                    SX12 180
##                                                                      SX12 181
#IF(ICNT==0)# IF INVERSION PRESENT                                      SX12 182
#$(#                                                                    SX12 183
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 184
#DO I=1,11,5; SMAT(I,NGEN)=-12#             SET INVERSION ROTATIONS     SX12 185
#NEQP=NEQP*2#                           INCR NUMBER OF EQUIV. POSNS     SX12 186
#$)#                                                                    SX12 187
#IF(LTYP==2)# IF AN R CENTRE                                            SX12 188
#$(#                                                                    SX12 189
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 190
#SMAT(13,NGEN)=8; SMAT(14,NGEN)=4; SMAT(15,NGEN)=4# SET 2/3,1/3,1/3     SX12 191
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 192
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 193
#SMAT(13,NGEN)=4; SMAT(14,NGEN)=8; SMAT(15,NGEN)=8# SET 1/3,2/3,2/3     SX12 194
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 195
#NEQP=NEQP*3#                           INCR NUMBER OF EQUIV. POSNS     SX12 196
#$)#                                                                    SX12 197
#IF(LTYP==3\LTYP==7)# IF A A OR F CENTRE                                SX12 198
#$(#                                                                    SX12 199
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 200
#SMAT(14,NGEN)=6; SMAT(15,NGEN)=6# SET 0,1/2,1/2 TRANSLATIONS           SX12 201
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 202
#NEQP=NEQP*2#                           INCR NUMBER OF EQUIV. POSNS     SX12 203
#$)#                                                                    SX12 204
#IF(LTYP==4\LTYP==7)# IF A B OR F CENTRE                                SX12 205
#$(#                                                                    SX12 206
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 207
#SMAT(13,NGEN)=6; SMAT(15,NGEN)=6# SET 1/2,0,1/2 TRANSLATIONS           SX12 208
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 209
#NEQP=NEQP*2#                           INCR NUMBER OF EQUIV. POSNS     SX12 210
#$)#                                                                    SX12 211
#IF(LTYP==5\LTYP==7)# IF A C OR F CENTRE                                SX12 212
#$(#                                                                    SX12 213
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 214
#SMAT(13,NGEN)=6; SMAT(14,NGEN)=6# SET 1/2,1/2,0 TRANSLATIONS           SX12 215
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 216
#NEQP=NEQP*2#                           INCR NUMBER OF EQUIV. POSNS     SX12 217
#$)#                                                                    SX12 218
#IF(LTYP==6)# IF AN I CENTRE                                            SX12 219
#$(#                                                                    SX12 220
#NGEN=NGEN+1# COUNT THE NEXT GENERATOR                                  SX12 221
#SMAT(13,NGEN)=6; SMAT(14,NGEN)=6; SMAT(15,NGEN)=6# SET 1/2,1/2,1/2     SX12 222
#DO I=1,11,5; SMAT(I,NGEN)=12#             SET IDENTITY ROTATIONS       SX12 223
#NEQP=NEQP*2#                           INCR NUMBER OF EQUIV. POSNS     SX12 224
#$)#                                                                    SX12 225
##LTYP=0; ICNT=-1# reset lattice and inversion    temp                  SX12 226
#                                                                       SX12 227
#                                                                       SX12 228
#    GENERATE MATRICES BY PROGRESSIVE BINARY PRODUCTS                   SX12 229
#    ------------------------------------------------                   SX12 230
#                                                                       SX12 231
IF(NGEN>1)#                            Skip generation if p1 or -p1     SX12 232
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX12 233
FOR(M=2;M<=NGEN;M=M+1)#                Outer generator loop             SX12 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SX12 235
OLD=NGEN#                              Save current matrix count        SX12 236
FOR(N=M;N<=NGEN;N=N+1)#                Inner generator loop             SX12 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SX12 238
NEW=NGEN+1#                            Point to generated matrix in     SX12 239
DO I=1,3#                              Loop over column elements        SX12 240
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SX12 241
DO J=1,13,4#                           Loop over row elements           SX12 242
SMAT(I+J-1,NEW)=(SMAT(I,   M)*SMAT(J,  N)$# Multiply (*,1) by (1,*)     SX12 243
+                SMAT(I+ 4,M)*SMAT(J+1,N)$# Multiply (*,2) by (2,*)     SX12 244
+                SMAT(I+ 8,M)*SMAT(J+2,N)$# Multiply (*,3) by (3,*)     SX12 245
+                SMAT(I+12,M)*SMAT(J+3,N))/12# Multiply (*,4) by (4,*   SX12 246
SMAT(I+12,NEW)=MOD(SMAT(I+12,NEW)+120,12)# Reduce vector to base 12     SX12 247
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SX12 248
#                                                                       SX12 249
FOR(L=1;L<=NGEN;L=L+1)#                ********** is matrix unique      SX12 250
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SX12 251
FOR(I=1;I<=12;I=I+1)#                  Loop over rotation partition     SX12 252
IF(SMAT(I,L)!=SMAT(I,NEW)) BREAK#      Exit loop if not equal           SX12 253
IF(I>12)#                              If rotation elements same        SX12 254
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SX12 255
IF(LTYP==1)#                           Test vectors if primitive sg     SX12 256
FOR(I=13;I<=16;I=I+1)#                 Check trans for primitive        SX12 257
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SX12 258
IF(SMAT(I,L)==SMAT(I,NEW)) NEXT#       Skip if translations agree       SX12 259
iquit:(SX1205)#                        Error condition                  SX12 260
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SX12 261
BREAK#                                 Not unique so skip               SX12 262
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SX12 263
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SX12 264
IF(L>NGEN) NGEN=NEW#                   Add unique matrix as gen.        SX12 265
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SX12 266
IF((NGEN==OLD)&(NGEN>=NEQP))BREAK#     Stop scan at expected max        SX12 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SX12 268
#                                                                       SX12 269
DO N=2,NGEN#                           ********** sort on zero patt     SX12 270
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SX12 271
DO L=N,NGEN#                           Inner sort loop                  SX12 272
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SX12 273
DO K=1,12#                             Loop over rotation partition     SX12 274
IF((SMAT(K,N-1)==0)&(SMAT(K,L)!=0)) BREAK# Exit on zero mismatch        SX12 275
IF(K>12) BREAK#                        Matrices match-exit inner        SX12 276
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SX12 277
IF(K>12)#                              If same pattern of zeros         SX12 278
DO K=1,16#                             Loop over all elements           SX12 279
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SX12 280
I=SMAT(K,L);SMAT(K,L)=SMAT(K,N);SMAT(K,N)=I# Exchange sorted elements   SX12 281
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SX12 282
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SX12 283
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX12 284
IF(NGEN>NEQP) iquit:(SX1207)#          Error condition                  SX12 285
#                                                                       SX12 286
#                                                                       SX12 287
#  TRANSLATE SYMMETRY MATRICES INTO EQUIVALENT POSITIONS                SX12 288
#  -----------------------------------------------------                SX12 289
#                                                                       SX12 290
DO M=1,NGEN#                           Loop over all matrices           SX12 291
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SX12 292
DO L=1,3; DO K=1,3#                    Loop over row elements           SX12 293
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SX12 294
J=L+(K-1)*4#                           Point to row element             SX12 295
IF(SMAT(J,M)>=0) NEXT#                 Skip positive elements           SX12 296
SMAT(K+12,M)=MOD(SMAT(K+12,M)+ORSH(K),12)# Apply coord shift            SX12 297
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SX12 298
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SX12 299
NSYM=NGEN#                             Store in common                  SX12 300
#                                                                       SX12 301
IF(LTYP==2)      LTYP=3#               Reset lattice codes from xray    SX12 302
ELSE IF(LTYP==6) LTYP=2#               Codes to xtal codes              SX12 303
ELSE IF(LTYP==7) LTYP=4#                                                SX12 304
ELSE IF(LTYP>2)  LTYP=LTYP+2#                                           SX12 305
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX12 306
##call sx14#                             convert to new hall symbol     SX12 307
#                                                                       SX12 308
#                                                                       SX12 309
RETURN#                                                                 SX12 310
END#                                                                    SX12 311
systemheader:(SX13)#                   Get symmetry notation            SX13   1
################################################################        SX13   2
#                                                                       SX13   3
#                         SX13                                          SX13   4
#                                                                       SX13   5
################################################################        SX13   6
SUBROUTINE SX13#                                                        SX13   7
include:(AACOMN)#                                                       SX13   8
include:(SXCOMN)#                                                       SX13   9
#                                                                       SX13  10
INTEGER       LNBLNK#                                                   SX13  11
LOGICAL       F1,F2,F3#                                                 SX13  12
CHARACTER*40  HALL1,HALL2,MAUG1,MAUG2#                                  SX13  13
INTEGER       I,IP,IR,J,K,MATCH,NH,NH1,NH2,NM,NM1,NM2,NN#               SX13  14
#LOGICAL   CHAR_#                                                        SX13  15
#LOGICAL   DATA_#                                                        SX13  16
#LOGICAL   INIT_#                                                        SX13  17
#LOGICAL   DICT_#                                                        SX13  18
#LOGICAL   OCIF_#                                                        SX13  19
#                                                                       SX13  20
string:(SNAME,60)#                                                      SX13  21
chardata:(SX130, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY $#       SX13  22
CELMOL CELCON FORMFX FORMGN DATDEF END EXPER CELLDR ORIENT $#           SX13  23
PROTDT SCALE MAXHKL CELLDS CRYSTA )#                                    SX13  24
chardata:(SX131,' WARNING: Input H-M symbol mismatch with Hall symbol')#SX13  25
datastuff:#                                                             SX13  26
#                                                                       SX13  27
#     PROCESS SGNAME/SPACEG LINES                                       SX13  28
#     ---------------------------                                       SX13  29
#                                                                       SX13  30
HALL=' ';  MAUG=' ';  NH=0;  NM=0#     Initiate as not found            SX13  31
WHILE(LINID==4\LINID==5)#              Loop sgname/spaceg lines         SX13  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX13  33
IF(LINID==4)#                          If sgname line entered           SX13  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX13  35
DO I=7,40; IF(CHRIN(I^I)!=' ') BREAK#  Find first non-blank             SX13  36
locase:(CHRIN(I^I+59),SNAME,60)#       Extract input string             SX13  37
DO I=1,60; IF(SNAME(I^I)==':') BREAK#  Stop at end of string            SX13  38
DO K=I-1,1,-1; IF(SNAME(K^K)!=' ') BREAK# Stop at end of hall string    SX13  39
IF(K>1)#                               Hall symbol detected             SX13  40
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX13  41
HALL=' '; J=0; DO I=1,K#               Loop over string                 SX13  42
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX13  43
IF(SNAME(I^I)==' '&SNAME(I+1^I+1)==' ') NEXT# Skip multiple blanks      SX13  44
J=J+1;  HALL(J^J)=SNAME(I^I)#          Store notation                   SX13  45
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX13  46
NH=J#                                  Store hall symbol only           SX13  47
DO K=1,NH; IF(HALL(K^K)==' ') HALL(K^K)='_'# Fill with underlines       SX13  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX13  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX13  50
#                                                                       SX13  51
ELSE IF(LINID==5)#                     If spaceg line entered           SX13  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX13  53
DO I=7,40; IF(CHRIN(I^I)!=' ') BREAK#  Find first non-blank             SX13  54
locase:(CHRIN(I^I+59),SNAME,60)#       Extract input string             SX13  55
SNAME(1^1)=CHRIN(I^I)#                 Make the first char uppercase    SX13  56
DO K=60,1,-1; IF(SNAME(K^K)!=' ') BREAK# Stop at end of hall string     SX13  57
IF(K>1)#                               H-m symbol detected              SX13  58
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX13  59
MAUG=SNAME(1^K);  NM=K#                Store h-m symbol only            SX13  60
DO K=1,NM; IF(MAUG(K^K)==' ') MAUG(K^K)='_'# Fill with underlines       SX13  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX13  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX13  63
readline:(SX130,NSX130)#               Get next input line              SX13  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX13  65
#                                                                       SX13  66
#     IF NOTATION NOT INPUT                                             SX13  67
#     ---------------------                                             SX13  68
#                                                                       SX13  69
IF(HALL(1^1)==' '&MAUG(1^1)==' ')#     Test if symbols entered          SX13  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX13  71
IF(ICHR>0)#                            Is hall symbol from symops       SX13  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX13  73
locase:(STRG,HALL,40); NH=ICHR#        Store for checking               SX13  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX13  75
ELSE#                                                                   SX13  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX13  77
IF(UPD==no:) iquit:(SX1315)#           No symmetry data entered         SX13  78
readwpkt:(1,lrsgnm:,I,IP,0)#           Read the sgname packet           SX13  79
IF(IP>0) movertoc:(QX(IP+1),1,STRG,1,40,0)# Transfer hall name          SX13  80
locase:(STRG,HALL,40)#                 Convert to lower case            SX13  81
DO NH=40,1,-1; IF(HALL(NH^NH)!=' ') BREAK# Find end of hall symbol      SX13  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX13  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX13  84
#                                                                       SX13  85
#       SCAN SYMMAP FILE FOR MATCH                                      SX13  86
#       --------------------------                                      SX13  87
#                                                                       SX13  88
F1=INIT_(iofm1:, 0, ioda1:, ioprt:)#   Set device numbers               SX13  89
F1=DICT_(' ','close')#                 Close any existing dictionarie   SX13  90
IF(!OCIF_(symmapp:)) iquit:(SX1305)#   Where is the map file?           SX13  91
IF(!DATA_(' '))      iquit:(SX1310)#   Data block missing!              SX13  92
#                                                                       SX13  93
DO IR=1,2#                             Loop for second match pass       SX13  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX13  95
REPEAT#                                Loop over notation               SX13  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX13  97
F1=CHAR_('_symmetry_space_group_name_Hall',HALL1)# Get hall symbol      SX13  98
NH1=LONG_#                             And its length                   SX13  99
F2=CHAR_('_symmetry_space_group_name_H-M',MAUG1)# Get h-m symbol        SX13 100
NM1=LONG_#                             And its length                   SX13 101
F3=CHAR_('_symmetry_space_group_id',ITNM)# Get space group id number    SX13 102
MATCH=yes:#                            Flag for match                   SX13 103
#                                                                       SX13 104
IF(NH>0)#                              Look for hall match              SX13 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX13 106
NH2=0#                                 Start notation length            SX13 107
DO J=1,NH1#                            Loop over table symbol           SX13 108
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX13 109
IF(HALL1(J^J)=='_') NEXT#              Skip underscores                 SX13 110
NH2=NH2+1#                             Count chars in notation          SX13 111
HALL2(NH2^NH2)=HALL1(J^J)#             Notation with no spacers         SX13 112
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX13 113
###write(6,'(3(i5,a))') NH,HALL,NH1,HALL1,NH2,HALL2                     SX13 114
IF(NH==NH1)#                           If lengths the same              SX13 115
IF(HALL(1^NH)==HALL1(1^NH)) BREAK#     Exit if match found              SX13 116
IF(NH==NH2)#                           If lengths the same              SX13 117
IF(HALL(1^NH)==HALL2(1^NH)) BREAK#     Exit if match found              SX13 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX13 119
#                                                                       SX13 120
ELSE#                                  Look for herm-maug match         SX13 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX13 122
NM2=0#                                 Start notation length            SX13 123
DO J=1,NM1#                            Loop over table symbol           SX13 124
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX13 125
IF(MAUG1(J^J)=='_') NEXT#              Skip underscores                 SX13 126
NM2=NM2+1#                             Count chars in notation          SX13 127
MAUG2(NM2^NM2)=MAUG1(J^J)#             Notation with no spacers         SX13 128
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX13 129
IF(NM==NM1)#                           If lengths the same              SX13 130
IF(MAUG(1^NM)==MAUG1(1^NM)) BREAK#     Exit if match found              SX13 131
IF(NM==NM2)#                           If lengths the same              SX13 132
IF(MAUG(1^NM)==MAUG2(1^NM)) BREAK#     Exit if match found              SX13 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX13 134
#                                                                       SX13 135
MATCH=no:#                             No match yet                     SX13 136
IF(!LOOP_) BREAK#                      Exit if notation finished        SX13 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX13 138
IF(MATCH==yes:)    BREAK#              Symbols matched                  SX13 139
IF(NH==0)          BREAK#              H-m name sought                  SX13 140
IF(HALL(1^1)!='-') BREAK#              If space group noncentro         SX13 141
SNAME='-'; NN=1#                       Start new hall symbol            SX13 142
DO I=2,NH#                             Loop over old symbol             SX13 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX13 144
SNAME(NN+1^NN+1)=HALL(I^I)#            Store symbol                     SX13 145
IF(HALL(I^I)!='-') NN=NN+1#            Count non-negative symbols       SX13 146
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX13 147
HALL=SNAME(1^NN); NH=NN#               Reset for new search             SX13 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX13 149
closedac:(ioda1:)#                     Close symmetry map file          SX13 150
#                                                                       SX13 151
IF(MATCH==yes:)#                       Symbols matched                  SX13 152
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX13 153
HALL=HALL1;  MAUG=MAUG1#               Transfer to global array         SX13 154
IF(NM>0)#                              Test if h-m symbol entered       SX13 155
IF(MAUG(1^NM)!=MAUG1(1^NM1))#          Test if symbols match            SX13 156
IF(MAUG(1^NM)!=MAUG2(1^NM2))#          Test if symbols match            SX13 157
writeline:(1,SX131,NSX131,3,3)#        Warn the user of mismatch        SX13 158
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX13 159
ELSE ITNM='0'#                         Blank out the it number          SX13 160
CALL PURGE_#                           Reset the cif toolbox            SX13 161
#                                                                       SX13 162
RETURN#                                                                 SX13 163
END#                                                                    SX13 164
systemheader:(SX14)#                   Convert symops to hall sgname    SX14   1
# ################################################################## #  SX14   2
#                                                                    #  SX14   3
#                               SX14                                 #  SX14   4
#                                                                    #  SX14   5
# ################################################################## #  SX14   6
SUBROUTINE SX14#                                                        SX14   7
include:(AACOMN)#                                                       SX14   8
include:(SXCOMN)#                                                       SX14   9
#                                                                       SX14  10
INTEGER I,J,NGEN#                                                       SX14  11
#                                                                       SX14  12
string:(TEMP,2)#                                                        SX14  13
string:(ORIGN,6)#                                                       SX14  14
#CHARDATA:(SX130, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY )# TEM  SX14  15
chardata:(CLAT,'iabcrr')#                                               SX14  16
chardata:(LAT,'pirfabc')#                                               SX14  17
##chardata:(ORIGN,'_     ')#                                            SX14  18
datastuff:#                                                             SX14  19
#                                                                       SX14  20
#   FIRST SORT THE SIETZ MATRICES                                       SX14  21
#                                                                       SX14  22
CALL SX18#                             Sort the matrices                SX14  23
#                                                                       SX14  24
#     USE LATTICE DATA IF AVAILABLE                                     SX14  25
#     -----------------------------                                     SX14  26
#                                                                       SX14  27
ICHR=0;   STRG=' '#                    Set initial op char pointer      SX14  28
NREM=NSYM;  NGEN=NSYM#                 Store total matrices             SX14  29
SHIFT='_(0_0_0)'#                      Default shift                    SX14  30
ORIGN='_     '#                        Default origin                   SX14  31
DO I=1,NSYM; SMAT(16,I)=-12#           Set "not used" flag              SX14  32
IF(ICNT==0) CALL SX16('-',1)#          Insert centro flag               SX14  33
IF(LTYP>0)  CALL SX16(LAT(LTYP^LTYP),1)# Latice has been determined     SX14  34
#                                                                       SX14  35
#    IDENTIFY LATTICE SYMBOL IF UNKNOWN                                 SX14  36
#    ----------------------------------                                 SX14  37
#                                                                       SX14  38
IF(LTYP==0)#                           Has lattice been determined      SX14  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX14  40
IF(ICHR>0) ICHR=ICHR-1#                Backoff op char pointer          SX14  41
J=ICHR#                                Save char pointer                SX14  42
CALL SX16('p',1)#                      Default is primitive             SX14  43
DO I=1,2#                              Search for centre twice          SX14  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX14  45
CALL SX15(1,1,1,1)#                    Search for identity matrix       SX14  46
IF(IROT==0) BREAK#                     Exit if no identity found        SX14  47
IF(ITRN==1)    iquit:(SX1401)#         Illegal translation of zero      SX14  48
IF(ITRN<=7) NGEN=NGEN/2#               I,a,b,c reduce generators        SX14  49
ICHR=J#                                Reset char pointer               SX14  50
IF(I==1\ ITRN>7) CALL SX16(CLAT(ITRN-3^ITRN-3),1)#                      SX14  51
IF(I==2&ITRN<=7) CALL SX16('f',1)#     Face centred                     SX14  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX14  53
IF(ITRN>7) NGEN=NGEN/3#                Must be rhombohedral centred     SX14  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX14  55
#                                                                       SX14  56
#    TEST IF INVERSION CENTRE                                           SX14  57
#    ------------------------                                           SX14  58
#                                                                       SX14  59
J=ICHR#                                Set op char pointer              SX14  60
CALL SX15(1,1,2,2)#                    Search for inversion             SX14  61
IF(ICNT<0)#                            If centro flag not set           SX14  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX14  63
IF(IROT==1&ITRN<=1)#                   Test if inversion at origin      SX14  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX14  65
TEMP='-'//STRG(1^1); STRG=TEMP; J=2#   Store centro flag                SX14  66
ICNT=0#                                Centrosymmetric set              SX14  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX14  68
ELSE  ICNT=1#                          Noncentrosymmetric set           SX14  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX14  70
IF(IROT==1) NGEN=NGEN/2#               Centro reduce generators         SX14  71
IF(ITRN>1) ORIGN(2^6)=STRG(J+2^J+5)#   Save shifted inversion symbol^   SX14  72
ICHR=J#                                Reset char pointer               SX14  73
#                                                                       SX14  74
#     TEST FOR DIFFERENT SYMMETRIES                                     SX14  75
#     -----------------------------                                     SX14  76
#                                                                       SX14  77
IF(NGEN==1)#                           ********* triclinic *******      SX14  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX14  79
CALL SX16('_1',2)#                     Store 1 fold symmetry            SX14  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX14  81
#                                                                       SX14  82
ELSE IF(NGEN==2)#                      ******** monoclinic *******      SX14  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX14  84
CALL SX15(4,2,1,2)#                    Test for 2z 2y 2x                SX14  85
IF(NREM!=1) iquit:(SX1405)#            Unknown monoclinic symmetry      SX14  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX14  87
#                                                                       SX14  88
ELSE IF(NGEN!=3&NGEN!=6&NGEN<9)#       ****** orth/tetr *******         SX14  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX14  90
CALL SX15(7,5,1,2)#                    Test for 4z 4y 4x                SX14  91
IF(IROT==0) CALL SX15(4,2,1,2)#        Test for 2z 2y 2x                SX14  92
CALL SX15(2,4,1,2)#                    Test for 2x 2y 2z                SX14  93
IF(NREM!=1) iquit:(SX1410)#            Unknown orth/tetr symmetry       SX14  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX14  95
#                                                                       SX14  96
ELSE#                                  ****** trig/cubic ******         SX14  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX14  98
IF(NGEN<=6) CALL SX15(20,20,1,2)#      Test for 3a+b+c                  SX14  99
CALL SX15(13,11,1,2)#                  Test for 6z 6y 6x                SX14 100
IF(IROT==0) CALL SX15(10, 8,1,2)#      Test for 3z 3y 3x                SX14 101
IF(IROT==0) CALL SX15( 7, 5,1,2)#      Test for 4z 4y 4z                SX14 102
IF(IROT==0) CALL SX15( 4, 2,1,2)#      Test for 2z 2y 2x                SX14 103
IF(JROT>=8)#                           Test if trig hex                 SX14 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX14 105
CALL SX15(16,14,1,2)#                  Test for 2a-b 2c-a 2b-c          SX14 106
IF(IROT==0) CALL SX15(19,17,1,2)#      Test for 2a+b 2c+a 2b+c          SX14 107
IF(NREM!=1) iquit:(SX1415)#            Unknown trig/hex symmetry        SX14 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX14 109
ELSE#                                  Else cubic                       SX14 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX14 111
CALL SX15(2,4,1,2)#                    Test for 2z 2y 2x                SX14 112
CALL SX15(20,20,1,2)#                  Test for 3a+b+c                  SX14 113
STRG(ICHR^ICHR)=' '#                   Remove the trailing '*'  <<      SX14 114
ICHR=ICHR-1#                           Adjust op pointer                SX14 115
IF(NREM!=1) iquit:(SX1420)#            Unknown cubic symmetry           SX14 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX14 117
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX14 118
#                                                                       SX14 119
IF(ORIGN!='_    ')    CALL SX16(ORIGN,5)# Insert origin shift           SX14 120
IF(SHIFT!='_(0_0_0)') CALL SX16(SHIFT,8)# Insert shift value            SX14 121
#                                                                       SX14 122
##if(hall==strg) write(55,'(a,1x,a)') chrip(1^35),strg(1^17)            SX14 123
##else           write(55,'(a,1x,a,a,a)') chrip(1^35),strg(1^17),$#     SX14 124
##hall(1^17),' *'                                                       SX14 125
##readline:(SX130,NSX130)#               Get next input line            SX14 126
RETURN#                                                                 SX14 127
END#                                                                    SX14 128
systemheader:(SX15)#                   Convert symops to hall sgname    SX15   1
# ################################################################## #  SX15   2
#                                                                    #  SX15   3
#                               SX15                                 #  SX15   4
#                                                                    #  SX15   5
# ################################################################## #  SX15   6
SUBROUTINE SX15(NROT1,NROT2,NSGN1,NSGN2)#                               SX15   7
include:(AACOMN)#                                                       SX15   8
include:(SXCOMN)#                                                       SX15   9
##-------------------------------------------------------------------   SX15  10
##    Search for the specified ROT(nrot1 to nrot2) symmetry operator(s) SX15  11
##    in SMAT(). If present, put the rotation symbol, the axis symbol   SX15  12
##    and the translation symbols into the output buffer.               SX15  13
##-------------------------------------------------------------------   SX15  14
#                                                                       SX15  15
INTEGER I,J,L,M,N#                                                      SX15  16
INTEGER NROT1,NROT2,NSGN1,NSGN2,MAT(16),LIND#                           SX15  17
INTEGER ROT(12,20),TRN1(3,18),TRN2(4),TRN3(4)#                          SX15  18
#                                                                       SX15  19
intdata:(ISGN,[+12,-12])#                                               SX15  20
chardata:(ROTC,'1 2x2y2z4x4y4z3x3y3z6x6y6z2 2 2 2"2"2"3*')#             SX15  21
chardata:(TRC1,'  d ndn bcacabr r udvdwdadbdcdnunvnw')#                 SX15  22
chardata:(TRC2,'      u v w a b c aubvcw')#                             SX15  23
chardata:(TRC3,'   111111111222222222444444   555555')#                 SX15  24
intdata:(LATES,[3,6,15,24,18,30,27])#                                   SX15  25
intdata:(LATSS,[1,1,7,13,13,25,22])#                                    SX15  26
intdata:(TLAT,[0,0,0,6,6,6,4,8,8,8,4,4,0,0,0,0,6,6,6,0,6,6,6,#          SX15  27
0,0,0,0,6,0,6])#                                                        SX15  28
datastuff:#                                                             SX15  29
DATA     TRN1 /0,0,0,3,3,3,9,9,9,6,6,6,0,6,6,6,0,6,6,6,0,4,8,8,#        SX15  30
8,4,4,6,3,3,3,6,3,3,3,6,9,3,3,3,9,3,3,3,9,9,6,6,6,9,6,6,6,9/#           SX15  31
DATA     TRN2 /0,3,6,9/#                                                SX15  32
DATA     TRN3 /2,4,8,10/#                                               SX15  33
DATA     ROT /$#                       4x3 rotation matrices            SX15  34
1,0,0,0,0,1,0,0,0,0,1,0,    1,0,0,0,0,-1,0,0,0,0,-1,0,# 1     2x        SX15  35
-1,0,0,0,0,1,0,0,0,0,-1,0,  -1,0,0,0,0,-1,0,0,0,0,1,0,# 2y    2z        SX15  36
1,0,0,0,0,0,1,0,0,-1,0,0,    0,0,-1,0,0,1,0,0,1,0,0,0,# 4x    4y        SX15  37
0,1,0,0,-1,0,0,0,0,0,1,0,   1,0,0,0,0,0,1,0,0,-1,-1,0,# 4z    3x        SX15  38
-1,0,-1,0,0,1,0,0,1,0,0,0,  0,1,0,0,-1,-1,0,0,0,0,1,0,# 3y    3z        SX15  39
1,0,0,0,0,1,1,0,0,-1,0,0,    0,0,-1,0,0,1,0,0,1,0,1,0,# 6x    6y        SX15  40
1,1,0,0,-1,0,0,0,0,0,1,0,  -1,0,0,0,0,0,-1,0,0,-1,0,0,# 6z    2b-c      SX15  41
0,0,-1,0,0,-1,0,0,-1,0,0,0,0,-1,0,0,-1,0,0,0,0,0,-1,0,# 2c-a  2a-b      SX15  42
-1,0,0,0,0,0,1,0,0,1,0,0,    0,0,1,0,0,-1,0,0,1,0,0,0,# 2b+c  2c+a      SX15  43
0,1,0,0,1,0,0,0,0,0,-1,0,     0,0,1,0,1,0,0,0,0,1,0,0/# 2a+b  3a+b+c    SX15  44
#                                                                       SX15  45
#     SEARCH FOR ROTATION                                               SX15  46
#     -------------------                                               SX15  47
#                                                                       SX15  48
N=1#                                                                    SX15  49
IF(NROT2<NROT1) N=-1#                                                   SX15  50
DO IROT=NROT1,NROT2,N; DO J=NSGN1,NSGN2# Loop rot matrices and signs    SX15  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX15  52
DO I=1,12; MAT(I)=ISGN(J)*ROT(I,IROT)#                                  SX15  53
DO M=2,NSYM#                                                            SX15  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX15  55
IF(SMAT(16,M)>0) NEXT#                                                  SX15  56
DO I=1,12; IF(SMAT(I,M)!=MAT(I)) GOTO 50#                               SX15  57
IF(ICHR>0) CALL SX16('_',1)#                                            SX15  58
IF(J==2)   CALL SX16('-',1)#                                            SX15  59
I=IROT*2-1#                                                             SX15  60
IF(IROT==NROT1&IROT<14) CALL SX16(ROTC(I^I)  ,1)#                       SX15  61
IF(IROT!=NROT1\IROT>=14)CALL SX16(ROTC(I^I+1),2)#                       SX15  62
NREM=NREM-1#                                                            SX15  63
SMAT(16,M)=12#                                                          SX15  64
GOTO 100#                                                               SX15  65
50 CONTINUE#                                                            SX15  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX15  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX15  68
IROT=0; ITRN=0; GOTO 600#                                               SX15  69
#                                                                       SX15  70
#     IDENTIFY TRANSLATION                                              SX15  71
#     --------------------                                              SX15  72
#                                                                       SX15  73
100 CONTINUE#                          Break point#                     SX15  74
DO ITRN=1,18#                                                           SX15  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX15  76
DO I=1,3; IF(SMAT(I+12,M)!=TRN1(I,ITRN)) GOTO 120#                      SX15  77
CALL SX16(TRC1(ITRN*2-1^ITRN*2),2)#                                     SX15  78
GOTO 200#                                                               SX15  79
120 CONTINUE#                                                           SX15  80
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX15  81
DO I=1,3#                                                               SX15  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX15  83
DO J=1,4; IF(SMAT(I+12,M)==TRN2(J)) GOTO 140#                           SX15  84
GOTO 160#                                                               SX15  85
140 J=(J-1)*6+I*2#                                                      SX15  86
CALL SX16(TRC2(J-1^J),2)#                                               SX15  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX15  88
ITRN=100#                                                               SX15  89
GOTO 200#                                                               SX15  90
#                                                                       SX15  91
160 CONTINUE#                                                           SX15  92
IF(IROT<8\IROT>16) iquit:(SX1501)#     Illegal translation              SX15  93
J=MOD(IROT-2,3)+1#                                                      SX15  94
DO I=1,4; IF(SMAT(J+12,M)==TRN3(I)) GOTO 190#                           SX15  95
iquit:(SX1501)#                        Illegal translation              SX15  96
190 I=(I-1)*9+IROT-7#                                                   SX15  97
IF(IROT<14) CALL SX16(TRC3(I^I),1)#                                     SX15  98
IF(IROT>=14) SHIFT(J*2+1^J*2+1)=TRC3(I^I)#                              SX15  99
ITRN=200#                                                               SX15 100
#                                                                       SX15 101
#     REMOVE SYMMETRY OPERATIONS                                        SX15 102
#     --------------------------                                        SX15 103
#                                                                       SX15 104
200 CONTINUE#                                                           SX15 105
IF(NREM>1)#                            Can matrices be removed          SX15 106
DO N=2,NSYM#                                                            SX15 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX15 108
IF(SMAT(16,N)<0) NEXT#                                                  SX15 109
DO M=N,NSYM#                                                            SX15 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX15 111
IF(SMAT(16,M)<0) NEXT#                                                  SX15 112
DO I=1,3#                                                               SX15 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX15 114
DO J=1,13,4#                                                            SX15 115
MAT(I+J-1)=(SMAT(I,M)*SMAT(J,N)+SMAT(I+4,M)*SMAT(J+1,N)$#               SX15 116
     +SMAT(I+8,M)*SMAT(J+2,N)+SMAT(I+12,M)*SMAT(J+3,N))/12#             SX15 117
MAT(I+12)=MOD(MAT(I+12)+1200,12)#                                       SX15 118
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX15 119
DO I=2,NSYM#                                                            SX15 120
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX15 121
IF(SMAT(16,I)>0) NEXT#                 Already checked                  SX15 122
DO J=1,12; IF(SMAT(J,I)!=MAT(J)) GOTO 280# Loop over rotation part      SX15 123
IF(LTYP!=0) LIND = LTYP#               We have a lattice type           SX15 124
ELSE LIND = 1#                         Assume primitive                 SX15 125
FOR(L=LATSS(LIND);L<LATES(LIND);L=L+3)# Loop over centering trans       SX15 126
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX15 127
DO J=13,15#                            Loop over translations           SX15 128
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX15 129
IF(SMAT(J,I)!= MOD(MAT(J)+ TLAT(L+J-13),12)) BREAK# Add centering tra   SX15 130
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX15 131
IF(J>15)#                              We matched                       SX15 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX15 133
NREM=NREM-1#                                                            SX15 134
SMAT(16,I)=12#                                                          SX15 135
GOTO 200#                                                               SX15 136
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX15 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX15 138
280 CONTINUE#                                                           SX15 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX15 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX15 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX15 142
#                                                                       SX15 143
600 CONTINUE#                                                           SX15 144
IF(IROT>0) JROT=IROT#                  Retain last matrix applied       SX15 145
##do i=1,nsym;WRITE(6,'(16i5)') (SMAT(J,I), J=1,16)# temp               SX15 146
#                                                                       SX15 147
RETURN#                                                                 SX15 148
END#                                                                    SX15 149
systemheader:(SX16)#                   Place chars in op string         SX16   1
# ################################################################## #  SX16   2
#                                                                    #  SX16   3
#                               SX16                                 #  SX16   4
#                                                                    #  SX16   5
# ################################################################## #  SX16   6
SUBROUTINE SX16(STRING,NCHR)#                                           SX16   7
include:(AACOMN)#                                                       SX16   8
include:(SXCOMN)#                                                       SX16   9
INTEGER NCHR#                                                           SX16  10
INTEGER I,J,K,L#                                                        SX16  11
string:(STRING,*); string:(ZZZ,1);string:(TEMP,50)#                     SX16  12
chardata:(CTRAN,'abcuvw')#                                              SX16  13
datastuff:#                                                             SX16  14
#                                                                       SX16  15
#WRITE(6,'(A)') STRG(1^ICHR)                                            SX16  16
DO I=1,NCHR#                                                            SX16  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX16  18
IF(STRING(I^I)==' ') NEXT#             Skip blanks                      SX16  19
ICHR=ICHR+1#                           Count the characters             SX16  20
STRG(ICHR^ICHR)=STRING(I^I)#           Transfer the character           SX16  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX16  22
DO I=1,ICHR#                                                            SX16  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX16  24
ZZZ=STRG(I^I)#                         Extract each character           SX16  25
DO J=1,6; IF(ZZZ==CTRAN(J^J)) BREAK#   Detect translation character     SX16  26
IF(J>6) NEXT#                          Skip if non-tran char            SX16  27
DO K=I+1,ICHR#                         Loop over remaining characters   SX16  28
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX16  29
IF(STRG(K^K)=='_') BREAK#              Exit if new matrix               SX16  30
DO L=1,J; IF(STRG(K^K)==CTRAN(L^L)) BREAK# Detect translation charact   SX16  31
IF(L>J) NEXT#                          Skip if non-tran char            SX16  32
STRG(I^I)=STRG(K^K); STRG(K^K)=ZZZ#    Swap characters                  SX16  33
BREAK#                                                                  SX16  34
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX16  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX16  36
DO I=1,ICHR#                                                            SX16  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX16  38
IF(STRG(I^I+2)=='abc')#                Look for this string             SX16  39
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX16  40
TEMP=STRG(1^ICHR)#                     Save current string              SX16  41
STRG(I^I)='n'#                         Substitute n for abc             SX16  42
STRG(I+1^ICHR-2)=TEMP(I+3^ICHR)#       Shuffle string forward           SX16  43
ICHR=ICHR-2#                                                            SX16  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX16  45
IF(STRG(I^I+2)=='uvw')#                Look for this string             SX16  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX16  47
TEMP=STRG(1^ICHR)#                     Save current string              SX16  48
STRG(I^I)='d'#                         Substitute d for uvw             SX16  49
STRG(I+1^ICHR-2)=TEMP(I+3^ICHR)#       Shuffle string forward           SX16  50
ICHR=ICHR-2#                                                            SX16  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX16  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX16  53
STRG(ICHR+1^40)=' '#                                                    SX16  54
###write(6,'(i5,5x,a)') ichr, strg(1^ichr)                              SX16  55
RETURN#                                                                 SX16  56
END#                                                                    SX16  57
systemheader:(SX17)#                   Check, sort and output symops    SX17   1
# ################################################################## #  SX17   2
#                                                                    #  SX17   3
#                               SX17                                 #  SX17   4
#                                                                    #  SX17   5
# ################################################################## #  SX17   6
SUBROUTINE SX17#                                                        SX17   7
include:(AACOMN)#                                                       SX17   8
include:(SXCOMN)#                                                       SX17   9
#                                                                       SX17  10
INTEGER N1,N2,N3,A1,A2,A3#                                              SX17  11
INTEGER GROUP(48)#                     Rotation group flags             SX17  12
INTEGER I,J,K,L,M,N,JJ,KK#             Loop indices                     SX17  13
INTEGER IDFLAG#                        Count of common elements         SX17  14
INTEGER IGROUP#                        Rotation group number            SX17  15
INTEGER IMATCH#                        Flag identical matrices          SX17  16
INTEGER INEW,IOLD#                                                      SX17  17
INTEGER IP#                            Packet pointer                   SX17  18
INTEGER KKK#                           Flag sign of trans. vector       SX17  19
INTEGER LATE#                                                           SX17  20
INTEGER LATS#                                                           SX17  21
INTEGER NROT1#                         No. elements 1st rot. group      SX17  22
INTEGER NROT2#                         Running count of symops          SX17  23
INTEGER NROT3#                         No. elements in current grou     SX17  24
INTEGER PROD(20)#                      Product of 2 symops              SX17  25
INTEGER SORT(48)#                      New ordering of symops           SX17  26
REAL    SUM#                                                            SX17  27
REAL    CODE,VAL#                      Encoding improper fractions      SX17  28
#                                                                       SX17  29
chardata:(FRAC,      1/61/41/3   1/2   2/33/45/6      )#                SX17  30
chardata:(XYZ,'-x-y-z+x+y+z')#                                          SX17  31
chardata:(HEAD," Space group ")#                                        SX17  32
chardata:(WARN,'WARNING: space group not in IT Vol A')#                 SX17  33
chardata:(WARN1,' WARNING: symops not checked for consistency')#        SX17  34
chardata:(AXIS,'abc')#                                                  SX17  35
chardata:(SX050,' Symops on the bdf:')#                                 SX17  36
chardata:(SX051," Lattice type           centrosymmetric     P")#       SX17  37
chardata:(SX052,PIRFABCPIRFABC)#                                        SX17  38
chardata:(SX053," matrix    column 1        column 2        column $#   SX17  39
3       translation")#                                                  SX17  40
chardata:(SX054," symop   r11 r21 r31     r12 r22 r32     r13 r23 $#    SX17  41
r33      t1  t2  t3")#                                                  SX17  42
chardata:(SX055,"noncentrosymmetric")#                                  SX17  43
chardata:(SX056, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY $#       SX17  44
CELMOL CELCON FORMFX FORMGN DATDEF END EXPER CELLDR ORIENT $#           SX17  45
PROTDT SCALE MAXHKL CELLDS CRYSTA )#                                    SX17  46
chardata:(SX057,' Crystal axes                             ')#          SX17  47
chardata:(SX058,"triclinic   monoclinic  orthorhombictetragonal  $#     SX17  48
trigonal    rhombohedralhexagonal   cubic       ")#                     SX17  49
chardata:(SX059," Total symops                ")#                       SX17  50
realdata:(FMT,[40313.,120313.,160313.,200313.,280313.,320313.,360313.,# SX17  51
440313.,480313.,520313.,600313.,640313.,680313.])#                      SX17  52
realdata:(FMUL,[1.,2.,3.,4.,2.,2.,2.])#                                 SX17  53
intdata:(IDEN,[12,0,0,0,0,12,0,0,0,0,12,0,0,0,0,12])#                   SX17  54
intdata:(LATES,[3,6,15,24,18,30,27])#                                   SX17  55
intdata:(LATSS,[1,1,7,13,13,25,22])#                                    SX17  56
intdata:(TLAT,[0,0,0,6,6,6,4,8,8,8,4,4,0,0,0,0,6,6,6,0,6,6,6,#          SX17  57
0,0,0,0,6,0,6])#                                                        SX17  58
intdata:(DENOM,[12,6,4,3,12,2,12,3,4,6,12, 1])#                         SX17  59
datastuff:#                                                             SX17  60
#                                                                       SX17  61
# SCAN SGNAME AND IDENTIFY CRYSTAL SYSTEM                               SX17  62
# ---------------------------------------                               SX17  63
#                                                                       SX17  64
IF(SGN==yes:)#                         If sname available               SX17  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX17  66
N1=SROT(1); N2=SROT(2); N3=SROT(3)#    Get rotations                    SX17  67
A1=SAXS(2); A2=SAXS(3); A3=SAXS(4)#    Get axes                         SX17  68
IF(N1<2&N2<2&N3<2)       NCRYS=1#      Crystal system triclinic         SX17  69
IF(N1==6)                NCRYS=7#      Crystal system hexagonal         SX17  70
IF(N1==2&N2==0&N3==0)    NCRYS=2#      Crystal system monoclinic        SX17  71
IF(N1==2&N2==2&N3 <2)    NCRYS=3#      Crystal system orthorhombic      SX17  72
IF(N1==3&A1==4)          NCRYS=6#      Crystal system rhombohedral      SX17  73
IF(N1==3&A1!=4)          NCRYS=5#      Crystal system trigonal          SX17  74
IF(N2==3\N3==3)          NCRYS=8#      Crystal system cubic             SX17  75
IF(N1==4&N3!=3)          NCRYS=4#      Crystal system tetragonal        SX17  76
IF(A1==0) A1=3#                        Default axis is z                SX17  77
N1=MOD(A1,3)+1;  N2=MOD(N1,3)+1#       Get associated axes              SX17  78
IF(NCRYS==2&(CELLP(N1+6)-90.)>small:) iquit:(SX1731)# Monoclinic ?      SX17  79
IF(NCRYS==2&(CELLP(N2+6)-90.)>small:) iquit:(SX1731)# Monoclinic ?      SX17  80
IF(NCRYS==4&CELLP(N1)-CELLP(N2)>small:) iquit:(SX1732)# Tetragonal ?    SX17  81
IF(NCRYS==7&CELLP(N1)-CELLP(N2)>small:) iquit:(SX1733)# Hexagonal  ?    SX17  82
IF(NCRYS==6&CELLP(1)-CELLP(2)>small:) iquit:(SX1734)# Rhombohedral ?    SX17  83
IF(NCRYS==6&CELLP(1)-CELLP(3)>small:) iquit:(SX1734)# Rhombohedral ?    SX17  84
CAVAR(1)=1.0;CAVAR(2)=1.0#             Set sigvol covariances           SX17  85
CAVAR(3)=1.0;CAVAR(4)=1.0#             Set sigvol covariances           SX17  86
IF ((NCRYS==4)\(NCRYS==5)\(NCRYS==7))# Tetragonal, trigonal, hexagona   SX17  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX17  88
CAVAR(N1)=2.0;CAVAR(N2)=2.0#                                            SX17  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX17  90
ELSEIF (NCRYS==7)#                     Rhombohedral                     SX17  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX17  92
CAVAR(1)=3.0;CAVAR(2)=3.0;CAVAR(3)=3.0#                                 SX17  93
CAVAR(4)=3.0#                                                           SX17  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX17  95
ELSEIF (NCRYS==8)#                     Cubic                            SX17  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX17  97
CAVAR(1)=3.0;CAVAR(2)=3.0;CAVAR(3)=3.0#                                 SX17  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX17  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX17 100
#                                                                       SX17 101
# TREAT A =CELMOL= LINE                                                 SX17 102
# ---------------------                                                 SX17 103
#                                                                       SX17 104
IF(LINID==8)#                          *celmol* line                    SX17 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX17 106
ZMOL=-MAX(0.,BUFIN(1))#                Extract the moles/cell value     SX17 107
readline:(SX056,NSX056)#               Read a celcon line               SX17 108
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX17 109
#                                                                       SX17 110
#   NOW TEST SYMOPS FOR INTEGRITY                                       SX17 111
#   -----------------------------                                       SX17 112
#                                                                       SX17 113
DO I=1,NSYM#                           Loop over symops                 SX17 114
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX17 115
SMAT(16,I)=12;  SORT(I)=0;  GROUP(I)=0# Initialize group(i)             SX17 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX17 117
DO J=1,NSYM#                           Loop over symops                 SX17 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX17 119
IDFLAG=0#                              Count identical elements         SX17 120
DO I=1,16#                             Loop over matrix elements        SX17 121
IF(SMAT(I,J)==IDEN(I)) IDFLAG=IDFLAG+1# Increment count                 SX17 122
IF(IDFLAG==16) BREAK#                  Identity matrix                  SX17 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX17 124
IF(IDFLAG!=16) iquit:(SX1701)#         No identity matrix               SX17 125
SORT(1)=J#                             Store it first                   SX17 126
GROUP(J)=1#                            Flag matrix ordered              SX17 127
#                                                                       SX17 128
# FIND ROTATION MATRICES WITH SAME PATTERN OF ZEROS                     SX17 129
# -------------------------------------------------                     SX17 130
#                                                                       SX17 131
NROT1=1#                               Initialize count                 SX17 132
DO J=1,NSYM#                           Loop over symops                 SX17 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX17 134
IF(GROUP(J)!=0) NEXT#                  Matrix not ordered yet           SX17 135
IDFLAG=0#                              Count identical elements         SX17 136
DO I=1,12#                             Loop over rotation elements      SX17 137
IF(IABS(SMAT(I,J))==IDEN(I)) IDFLAG=IDFLAG+1# Increment count           SX17 138
IF(IDFLAG!=12) NEXT#                   Identical rotation matrix        SX17 139
NROT1=NROT1+1#                         Increment count                  SX17 140
SORT(NROT1)=J#                         New position                     SX17 141
GROUP(J)=1#                            Flag matrix ordered              SX17 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX17 143
#                                                                       SX17 144
# SORT THE REST OF THE MATRICES                                         SX17 145
# FIND ROTATION MATRICES WITH SAME PATTERNS OF ZEROS                    SX17 146
# --------------------------------------------------                    SX17 147
#                                                                       SX17 148
NROT2=NROT1#                           Total count of matrices          SX17 149
IGROUP=1#                              Flag rotation groups             SX17 150
DO J=1,NSYM#                           Loop over symops                 SX17 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX17 152
IF(GROUP(J)!=0) NEXT#                  Matrix not ordered yet           SX17 153
NROT2=NROT2+1#                         Count matrix                     SX17 154
SORT(NROT2)=J#                         New position                     SX17 155
IGROUP=IGROUP+1#                       New rotation group               SX17 156
NROT3=1#                               Elements of this rotation gr     SX17 157
GROUP(J)=IGROUP#                       Flag matrix ordered              SX17 158
KK=J+1#                                Start of next loop               SX17 159
DO K=KK,NSYM#                          Loop over rest of symops         SX17 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX17 161
IF(GROUP(K)!=0) NEXT#                  Matrix not ordered yet           SX17 162
IDFLAG=0#                              Count identical elements         SX17 163
DO I=1,12#                             Loop over rotation elements      SX17 164
IF(IABS(SMAT(I,J))==IABS(SMAT(I,K))) IDFLAG=IDFLAG+1# Increment cou     SX17 165
IF(IDFLAG!=12) NEXT#                   Identical rotation matrices      SX17 166
NROT2=NROT2+1#                         Count matrix                     SX17 167
SORT(NROT2)=K#                         New position                     SX17 168
GROUP(K)=IGROUP#                       Flag matrix ordered              SX17 169
NROT3=NROT3+1#                         Increment count                  SX17 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX17 171
IF(NROT3!=NROT1) iquit:(SX1703)#       Unequal rotation groups          SX17 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX17 173
#                                      Now do the delayed write out of  SX17 174
CALL SX19#                             Lrcell: (since ncrys is needed   SX17 175
#                                      For sigvol calculation           SX17 176
#                                                                       SX17 177
# WRITE PACKET 1 OF LOGICAL RECORD LRSYMM:                              SX17 178
# ----------------------------------------                              SX17 179
#                                                                       SX17 180
writepkt:(2,lrsymm:,12,IP)#            **** writepkt ****               SX17 181
QX(IP+1)=FLOAT(LTYP)#                  Lattice type                     SX17 182
QX(IP+2)=FLOAT(ICNT)#                  Centrosymmetricity               SX17 183
QX(IP+3)=FLOAT(NSYM)*FMUL(LTYP)#       Number equiv. positions          SX17 184
QX(IP+4)=FLOAT(NSYM)#                  Number of symops                 SX17 185
QX(IP+5)=FLOAT(NROT1)#                 Size of rotation group(s)        SX17 186
QX(IP+6)=FMUL(LTYP)#                   Multiplicity factor              SX17 187
IF(ICNT==0)#                           If centrosymmetric               SX17 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX17 189
QX(IP+1)=QX(IP+1)+7.0#                 Adjust code for lattice          SX17 190
QX(IP+3)=2.0*QX(IP+3)#                 Adjust symops for centrosymmet   SX17 191
QX(IP+6)=2.0*QX(IP+6)#                 Adjust multiplicity              SX17 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX17 193
QX(IP+7)=0.#                           Used later by cedar              SX17 194
IF(ZMOL>(-.1)) ZMOL=QX(IP+3)#          Assume 1 mole/asymm unit         SX17 195
ELSE           ZMOL=-ZMOL#             Value from input line            SX17 196
QX(IP+8)=ZMOL#                         Moles/cell                       SX17 197
QX(IP+9)=FLOAT(NCRYS)#                 Crystal system number            SX17 198
QX(IP+10)=FLOAT(A1)#                   Unique axis number               SX17 199
QX(IP+11)=0.#                          Not used yet                     SX17 200
QX(IP+12)=0.#                          Not used yet                     SX17 201
#                                                                       SX17 202
#    LIST THE SYMOPS AS X,Y,Z                                           SX17 203
#    ------------------------                                           SX17 204
#                                                                       SX17 205
LINRM=6#                               Force lattice header             SX17 206
IF(LAX==no:)#                                                           SX17 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX17 208
movechar:(HEAD,1,CHROT,1,NHEAD,0)#     Put sgname into op buffer        SX17 209
movechar:(STRG,1,CHROT,25,17,0)#       Put sgname into op buffer        SX17 210
movechar:(MAUG,1,CHROT,42,15,0)#       Put sgname into op buffer        SX17 211
movechar:(ITNM,1,CHROT,57,15,0)#       Put sgname into op buffer        SX17 212
DO I=25,80; IF(CHROT(I^I)=='_') CHROT(I^I)=' '# Replace _ with blank    SX17 213
IF(ITNM(1^1)=='0') movechar:(WARN,1,CHROT,42,NWARN,0)# Give warning     SX17 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX17 215
ELSE movechar:(WARN1,1,CHROT,1,NWARN1,0)# No symmetry checking          SX17 216
writeline:(0,0,0,1,3)#                 Print sgname                     SX17 217
#                                                                       SX17 218
movechar:(SX058,NCRYS*12-11,SX057,25,12,0)# Crystal system              SX17 219
IF(NCRYS==2\NCRYS==4\NCRYS==5\NCRYS==7)# For special axes               SX17 220
movechar:(AXIS,A1,SX057,40,1,0)#       Insert axis symbol               SX17 221
ELSE movechar:(' ',1,SX057,40,1,0)#    Insert blank                     SX17 222
IF(NCRYS>0)writeline:(1,SX057,NSX057,3,3)# Write message                SX17 223
movechar:(SX052,LTYP,SX051,45,1,0)#    Lattice character                SX17 224
IF(ICNT==1) movechar:(SX055,1,SX051,25,18,0)# Non-centrosymmetric       SX17 225
ELSE        movechar:(SX055,4,SX051,25,15,0)# Centrosymmetric           SX17 226
writeline:(0,SX051,NSX051,3,3)#        Write message                    SX17 227
ncodefld:(QX,IP+3,SX059,260313.,1)#    Format total symops              SX17 228
writeline:(0,SX059,NSX059,3,3)#        Print total symops               SX17 229
#                                                                       SX17 230
LINRM=6#                               Force symop header               SX17 231
writeline:(1,SX050,NSX050,3,3)#        Symop header                     SX17 232
DO N=1,NSYM#                           Loop over symops                 SX17 233
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX17 234
ncodefld:(FLOAT(N),1,CHROT,50513.,1)#  Insert symop number              SX17 235
K=10#                                  Reset char op pointer            SX17 236
IF (LAX==no:)JJ=SORT(N)#               Output in sorted order           SX17 237
ELSE         JJ=N#                     Output in input order            SX17 238
DO L=1,3#                              Loop over symop matrix           SX17 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX17 240
M=SMAT(L+12,JJ)#                       Point to translation             SX17 241
J=MOD(M+3600,12)#                      Get transln element              SX17 242
#IF(J>0) CHROT(K^K+2)=FRAC(J*3+1^J*3+3)# STORE TRANSL FRACTION          SX17 243
CODE=FLOAT(K+2)*10000.+213.#           Write denominator                SX17 244
VAL=FLOAT(M/12)#                       Default value                    SX17 245
IF(J>0)#                               Non-integral                     SX17 246
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX17 247
ncodefld:(FLOAT(DENOM(J)),1,CHROT,CODE,1)# Integral                     SX17 248
CHROT(K+1^K+1)='/'#                    Write division                   SX17 249
VAL=FLOAT(M*DENOM(J)/12)#              Add fractional num of denoms     SX17 250
CODE=FLOAT(K)*10000.+513.#             Dont' overwrite fraction         SX17 251
ncodefld:(VAL,1,CHROT,CODE,1)#         Encode the total number          SX17 252
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX17 253
ELSEIF(M!=0) ncodefld:(VAL,1,CHROT,CODE,1)# Integral                    SX17 254
K=K+3#                                 Incr op pointer                  SX17 255
DO M=1,3#                              Loop along row elements          SX17 256
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX17 257
J=SMAT(L+M*4-4,JJ)#                    Point to next element            SX17 258
IF(J==0) NEXT#                         Skip zero elements               SX17 259
J=J/4+M*2+2#                           Get char pointer                 SX17 260
CHROT(K^K+1)=XYZ(J^J+1); K=K+2#        Extract xyz string               SX17 261
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX17 262
IF(L<3) CHROT(K^K)=',';  K=L*15+10#    Place comma between elements     SX17 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX17 264
writeline:(0,0,0,1,3)#                 Print the symop                  SX17 265
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX17 266
#                                                                       SX17 267
# CHECK FOR DUPLICATE ROTATION MATRICES                                 SX17 268
# -------------------------------------                                 SX17 269
#                                                                       SX17 270
IF(LAX==no:)#                                                           SX17 271
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX17 272
DO J=1,NSYM#                           Loop over symops                 SX17 273
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SX17 274
DO I=13,16#                            Loop over translation elemen     SX17 275
IF(SMAT(I,J)<0) SMAT(I,J)=SMAT(I,J)+12# Make positive                   SX17 276
KK=J+1#                                Start of next loop               SX17 277
DO K=KK,NSYM#                          Loop over rest of symops         SX17 278
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SX17 279
IDFLAG=0#                              Count identical elements         SX17 280
DO I=1,12#                             Loop over rotation elements      SX17 281
IF(SMAT(I,J)==SMAT(I,K)) IDFLAG=IDFLAG+1# Increment count               SX17 282
IF(IDFLAG>=12) iquit:(SX1704)#         Identical rotation matrices      SX17 283
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SX17 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SX17 285
#                                                                       SX17 286
# CHECK THAT THE SYMOPS FORM A GROUP                                    SX17 287
# ----------------------------------                                    SX17 288
#                                                                       SX17 289
LATS=LATSS(LTYP)#                                                       SX17 290
LATE=LATES(LTYP)#                                                       SX17 291
DO I=1,NSYM#                           Loop over symops                 SX17 292
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SX17 293
DO J=1,NSYM#                           Loop over symops                 SX17 294
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SX17 295
DO K=1,4#                              Loop over columns of #2          SX17 296
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SX17 297
PROD(K)=SMAT(K,J)*SMAT(1,I)+SMAT(K+4,J)*SMAT(2,I)$#                     SX17 298
                             +SMAT(K+8,J)*SMAT(3,I)#                    SX17 299
PROD(K+4)=SMAT(K,J)*SMAT(5,I)+SMAT(K+4,J)*SMAT(6,I)$#                   SX17 300
                               +SMAT(K+8,J)*SMAT(7,I)#                  SX17 301
PROD(K+8)=SMAT(K,J)*SMAT(9,I)+SMAT(K+4,J)*SMAT(10,I)$#                  SX17 302
                               +SMAT(K+8,J)*SMAT(11,I)#                 SX17 303
PROD(K+12)=SMAT(K,J)*SMAT(13,I)+SMAT(K+4,J)*SMAT(14,I)$#                SX17 304
            +SMAT(K+8,J)*SMAT(15,I)+SMAT(K+12,J)*SMAT(16,I)#            SX17 305
PROD(K)=PROD(K)/12#                                                     SX17 306
PROD(K+4)=PROD(K+4)/12#                                                 SX17 307
PROD(K+8)=PROD(K+8)/12#                                                 SX17 308
PROD(K+12)=PROD(K+12)/12#                                               SX17 309
IF(PROD(K+12)<0) PROD(K+12)=PROD(K+12)+12# Make positive                SX17 310
PROD(K+16)=12-PROD(K+12)#              Negative for centrosymmetric     SX17 311
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SX17 312
#                                                                       SX17 313
IMATCH=0#                              No match initially               SX17 314
DO K=1,NSYM#                           Loop over symops                 SX17 315
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SX17 316
KKK=13#                                For noncentrosymmetric           SX17 317
IDFLAG=0#                              Count identical elements         SX17 318
DO L=1,12#                             Loop over rotation elements      SX17 319
IF(SMAT(L,K)==PROD(L)) IDFLAG=IDFLAG+1# Increment count                 SX17 320
IF(IDFLAG<12)#                         No match                         SX17 321
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SX17 322
IF(ICNT!=0) NEXT#                      Skip if noncentrosymmetric       SX17 323
IDFLAG=0#                              Test for negatives               SX17 324
DO L=1,12#                             Loop over rotation elements      SX17 325
IF(SMAT(L,K)==(-PROD(L))) IDFLAG=IDFLAG+1# Increment count              SX17 326
KKK=17#                                Negative translation vector      SX17 327
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SX17 328
IF(IDFLAG==12)#                        Match                            SX17 329
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SX17 330
FOR(L=LATS;L<=LATE;L=L+3)#             ????                             SX17 331
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SX17 332
IF((SMAT(13,K)==MOD(PROD(KKK)+TLAT(L),12))&$#                           SX17 333
   (SMAT(14,K)==MOD(PROD(KKK+1)+TLAT(L+1),12))&$#                       SX17 334
   (SMAT(15,K)==MOD(PROD(KKK+2)+TLAT(L+2),12)))# Whew                   SX17 335
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SX17 336
IMATCH=1#                              Flag match                       SX17 337
BREAK#                                 Break out                        SX17 338
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SX17 339
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SX17 340
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SX17 341
IF(IMATCH==1) BREAK#                   Break again                      SX17 342
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SX17 343
IF(IMATCH==0) iquit:(SX1702)#          Quit if no match                 SX17 344
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SX17 345
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SX17 346
#                                                                       SX17 347
#   CHECK THE REAL METRIC TENSOR AGAINST EACH OF THE SYMMMETRY          SX17 348
#   OPERATIONS IN TURN.  THE TRANSFORMED METRIC TENSOR SHOULD BE        SX17 349
#   EQUAL (WITHIN ROUNDING ERRORS) TO THE ORIGINAL METRIC IF THE        SX17 350
#   LATTICE SYMMETRY AS REPRESENTED BY THE METRIC TENSOR NSCAT A        SX17 351
#   SUPERGROUP OF THE SYMMETRY OPERATIONS.                              SX17 352
#   NEW METRIC TENSOR = SYMOP (TRANSPOSED) * OLD METRIC TENSOR * SYMOP  SX17 353
#                                                                       SX17 354
##if(nsym<1)#  for debugging >>>>>>>>>>>                                SX17 355
DO N=1,NSYM#                           Loop over symops                 SX17 356
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SX17 357
DO INEW=0,8#                           Loop over elements of new metr   SX17 358
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SX17 359
SUM=0.0#                               Accumulate value of new metric   SX17 360
I=4*(INEW/3);J=4*MOD(INEW,3)#          Row and column offsets of old    SX17 361
#                                      To point into smat array         SX17 362
DO IOLD=0,8#                           Loop over elements of old metr   SX17 363
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SX17 364
K=I+IOLD/3;L=J+MOD(IOLD,3)#            Add in row and column offsets    SX17 365
#                                      New gs (in sum) for smat array   SX17 366
SUM=SUM+REAL(SMAT(K+1,N))*REAL(SMAT(L+1,N))*GS(IOLD+1)# Multiply        SX17 367
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SX17 368
ifne:(GS(INEW+1),SUM/144.0,0.03)iquit:(SX1705)# Too much difference     SX17 369
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SX17 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SX17 371
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX17 372
#                                                                       SX17 373
# WRITE SYMOPS TO FILE                                                  SX17 374
# --------------------                                                  SX17 375
#                                                                       SX17 376
writeline:(1,SX053,NSX053,3,4); LINRM=2#                                SX17 377
DO J=1,NSYM#                           Loop over symops                 SX17 378
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SX17 379
JJ=SORT(J)#                            Get sorted symop                 SX17 380
BUFOT(1)=FLOAT(JJ)#                    Encode order                     SX17 381
DO I=2,4 ;   BUFOT(I)=FLOAT(SMAT(I-1,JJ)/12)#                           SX17 382
DO I=5,7 ;   BUFOT(I)=FLOAT(SMAT(I,JJ)/12)#                             SX17 383
DO I=8,10 ;  BUFOT(I)=FLOAT(SMAT(I+1,JJ)/12)#                           SX17 384
DO I=11,13 ; BUFOT(I)=FLOAT(SMAT(I+2,JJ))#                              SX17 385
ncodefld:(BUFOT,1,CHROT,FMT,13)#                                        SX17 386
writeline:(0,SX054,NSX054,1,4)#        Print matrix elements            SX17 387
#                                                                       SX17 388
writepkt:(2,lrsymm:,12,IP)#            **** writepkt ****               SX17 389
DO I=11,13 ; BUFOT(I)=BUFOT(I)/12.0#   Convert from twelfths            SX17 390
DO I=1,12 ; QX(IP+I)=BUFOT(I+1)#       Store the symops                 SX17 391
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SX17 392
#                                                                       SX17 393
#    WRITE OUT SPACE GROUP NAME                                         SX17 394
#    --------------------------                                         SX17 395
#                                                                       SX17 396
writepkt:(2,lrsgnm:,mxwd40c:,IP)#      **** writepkt ****               SX17 397
movector:(STRG,1,QX(IP+1),1,40,0)#     Store hall space group name      SX17 398
writepkt:(2,lrsgnm:,mxwd40c:,IP)#      **** writepkt ****               SX17 399
movector:(MAUG,1,QX(IP+1),1,40,0)#     Store h-m space group name       SX17 400
writepkt:(2,lrsgnm:,mxwd40c:,IP)#      **** writepkt ****               SX17 401
movector:(ITNM,1,QX(IP+1),1,40,0)#     Store int tab sg id code         SX17 402
#                                                                       SX17 403
RETURN#                                                                 SX17 404
END#                                                                    SX17 405
systemheader:(SX18)#                   Sort the sietz matrices          SX18   1
# ################################################################## #  SX18   2
#                                                                    #  SX18   3
#                               SX18                                 #  SX18   4
#                                                                    #  SX18   5
# ################################################################## #  SX18   6
SUBROUTINE SX18#                                                        SX18   7
include:(AACOMN)#                                                       SX18   8
include:(SXCOMN)#                                                       SX18   9
##                                                                      SX18  10
## This routine sorts the Sietz matrices of the form...                 SX18  11
##                                                                      SX18  12
##                 r11 r12 r13 t1                                       SX18  13
##                 r21 r22 r23 t2                                       SX18  14
##                 r31 r32 r33 t3                                       SX18  15
##                  0   0   0  12                                       SX18  16
##                                                                      SX18  17
##    where r's are 12, 0 or -12, t's are fractions mod 12.             SX18  18
##                                                                      SX18  19
## SMAT is a linear array order r11 r21 r31 0 r12.... t2 t3 12.         SX18  20
##                                                                      SX18  21
## The sort order is r11 r22 r33 r12 r13 r21 r23 r31 r32 t1 t2 t3       SX18  22
##                                                                      SX18  23
## Note the kluge that ensures that transl (0,0,t3) precedes (t1,t2,0)  SX18  24
##                                                                      SX18  25
#                                                                       SX18  26
INTEGER I,J,K,M,N,S#                                                    SX18  27
INTEGER ISORT(200)#                                                     SX18  28
intdata:(PAK,[1,3,9,27,81,243,729,2187,6561,164025,4100625,102515625])# SX18  29
intdata:(DIV,[12,12,12,12,12,12,12,12,12,1,1,1])#                       SX18  30
intdata:(ORD,[1,6,11,5,9,2,10,3,7,13,14,15])#                           SX18  31
datastuff:#                                                             SX18  32
#                                                                       SX18  33
DO I=1,NSYM#                           Loop over sietz matrices         SX18  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX18  35
##WRITE(6,'(16i5)') (SMAT(J,I), J=1,16)#                                SX18  36
ISORT(I)=0#                            Reset sort index                 SX18  37
DO M=1,12#                             Loop over active elements        SX18  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX18  39
J=ORD(M)#                              Get the order of elements        SX18  40
K=SMAT(J,I)/DIV(M)#                    Extract matrix element           SX18  41
IF(K<0) N=2#                           For -ve r elements               SX18  42
ELSE    N=K#                           For others                       SX18  43
ISORT(I)=ISORT(I)+N*PAK(M)#            Calculate the sort index         SX18  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX18  45
IF(SMAT(13,I)+SMAT(14,I)==0&SMAT(15,I)>0)# Test for 0,0,t3 condition    SX18  46
#ISORT(I)=ISORT(I)-98415000*SMAT(15,I)# Ensure 0,0,t3 above t1,t2,0
ISORT(I)=ISORT(I)-98414999*SMAT(15,I)# Ensure 0,0,t3 above t1,t2,0
##WRITE(6,'(i20)') ISORT(I)#                                            SX18  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX18  49
#                                                                       SX18  50
#   SORT SIETZ MATRICES ON T1 T2 T3 R11 R12 R13 R21 R22.... R33         SX18  51
#                                                                       SX18  52
DO I=1,NSYM#                           Loop sietz matrices              SX18  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX18  54
N=I#                                   Set starting value               SX18  55
DO J=I+1,NSYM#                         Loop sietz matrices              SX18  56
IF(ISORT(N)>ISORT(J)) N=J#             Store value if j<n               SX18  57
ISORT(N)=ISORT(I)#                     Save the sort index              SX18  58
DO K=1,16#                                                              SX18  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX18  60
S=SMAT(K,I); SMAT(K,I)=SMAT(K,N); SMAT(K,N)=S# Swap elements            SX18  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX18  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX18  63
##DO I=1,NSYM; WRITE(6,'(16i5)') (SMAT(J,I), J=1,16)#                   SX18  64
#                                                                       SX18  65
RETURN#                                                                 SX18  66
END#                                                                    SX18  67
systemheader:(SX19)#                   Write messages & bdf lrcell      SX19   1
# ################################################################## #  SX19   2
#                                                                    #  SX19   3
#                               SX19                                 #  SX19   4
#                                                                    #  SX19   5
# ################################################################## #  SX19   6
SUBROUTINE SX19#                                                        SX19   7
include:(AACOMN)#                                                       SX19   8
include:(SXCOMN)#                                                       SX19   9
#                                                                       SX19  10
INTEGER I#                             Loop index                       SX19  11
INTEGER IP#                            Output packet pointer            SX19  12
#                                                                       SX19  13
chardata:(SX011," Cell dimensions    a         b         c       $#     SX19  14
alpha      beta     gamma")#                                            SX19  15
chardata:(SX012,"                    a*        b*        c*      $#     SX19  16
alpha*     beta*    gamma*")#                                           SX19  17
chardata:(SX014," Metric tensor for Contravariant vectors $#            SX19  18
DIRECT SPACE")#                                                         SX19  19
chardata:(SX016," Metric tensor for covariant vectors $#                SX19  20
RECIPROCAL SPACE")#                                                     SX19  21
#                                                                       SX19  22
chardata:(SX018," Transform fractional coords to Cartesian coords.")#   SX19  23
chardata:(SX019," Transform hkl to orthogonal pseudo-hkl")#             SX19  24
chardata:(SX01A," Cell volume")#                                        SX19  25
#                                                                       SX19  26
realdata:(FMT,[240942.,340942.,440942.,540942.,640942.,740942.])#       SX19  27
realdata:(FMTA,[241241.,381241.,521241.])#                              SX19  28
#                                                                       SX19  29
datastuff:#                                                             SX19  30
#                                                                       SX19  31
#                                                                       SX19  32
# WRITE PACKET 1 OF LOGICAL RECORD LRCELL:                              SX19  33
# CONTAINING DIRECT CELL CONSTANTS                                      SX19  34
# --------------------------------                                      SX19  35
#                                                                       SX19  36
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19  37
LINRM=10#                              Must be 10 lines left            SX19  38
writeline:(1,SX011,NSX011,3,3)#        Header                           SX19  39
ncodefld:(CELLP,1,CHROT,FMT,3)#        Encode a,b,c                     SX19  40
ncodefld:(CELLP,7,CHROT,FMT(4),3)#     Encode angles                    SX19  41
writeline:(0,0,0,1,3)#                 Write line                       SX19  42
DO I=7,9 ; CELLP(I)=CELLP(I)/360.#     Degrees to cycles                SX19  43
DO I=1,9 ; QX(IP+I)=CELLP(I)#          Write to buffer                  SX19  44
#                                                                       SX19  45
# WRITE PACKET 2 OF LOGICAL RECORD LRCELL:                              SX19  46
# CONTAINING STANDARD DEVIATIONS OF ITEMS IN PACKET 1                   SX19  47
# ---------------------------------------------------                   SX19  48
#                                                                       SX19  49
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19  50
ncodefld:(CELLS,1,CHROT,FMT,3)#        Encode s.d. of a,b,c             SX19  51
ncodefld:(CELLS,7,CHROT,FMT(4),3)#     Encode s.d. of angles            SX19  52
writeline:(0,0,0,1,3)#                 Write line                       SX19  53
DO I=7,9 ; CELLS(I)=CELLS(I)/360.#     Degrees to cycles                SX19  54
DO I=1,9 ; QX(IP+I)=CELLS(I)#          Write to buffer                  SX19  55
#                                                                       SX19  56
CELVOL=CELLP(1)*CELLP(2)*CELLP(3)*$#   Calc cell volume                 SX19  57
       SQRT(1.0+2.0*CELLP(4)*CELLP(5)*CELLP(6)$#                        SX19  58
       -CELLP(4)**2-CELLP(5)**2-CELLP(6)**2)#                           SX19  59
SIGVOL=CELVOL*SQRT(CAVAR(1)*(CELLS(1)/CELLP(1))**2$# Sigma cell volum   SX19  60
                  +CAVAR(2)*(CELLS(2)/CELLP(2))**2$# Sigma cell volum   SX19  61
                  +CAVAR(3)*(CELLS(3)/CELLP(3))**2$# Sigma cell volum   SX19  62
+CAVAR(4)*(CELLP(1)*CELLP(2)*CELLP(3)/CELVOL)**4$# Sigma cell volume    SX19  63
*(CELLS(4)**2*(CELLP(4)-CELLP(5)*CELLP(6))**2$#                         SX19  64
 +CELLS(5)**2*(CELLP(5)-CELLP(4)*CELLP(6))**2$#                         SX19  65
 +CELLS(6)**2*(CELLP(6)-CELLP(5)*CELLP(4))**2))#                        SX19  66
#                                                                       SX19  67
# WRITE PACKET 3 OF LOGICAL RECORD LRCELL:                              SX19  68
# CONTAINING RECIPROCAL CELL CONSTANTS                                  SX19  69
# ------------------------------------                                  SX19  70
#                                                                       SX19  71
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19  72
#                                                                       SX19  73
writeline:(1,SX012,NSX012,3,3)#        Heading                          SX19  74
ncodefld:(RCELLP,1,CHROT,FMT,3)#       Encode a*,b*,c*                  SX19  75
ncodefld:(RCELLP,7,CHROT,FMT(4),3)#    Encode angles*                   SX19  76
writeline:(0,0,0,1,3)#                 Write line                       SX19  77
DO I=7,9 ; RCELLP(I)=RCELLP(I)/360.#   Degrees to cycles                SX19  78
DO I=1,9 ; QX(IP+I)=RCELLP(I)#         Write to buffer                  SX19  79
movechar:(SX01A,1,CHROT,1,NSX01A,0)#   Volume heading                   SX19  80
ncodefld:(CELVOL,1,CHROT,301032.,1)#   Encode volume                    SX19  81
ncodefld:(SIGVOL,1,CHROT,401032.,1)#   Encode volume sigma              SX19  82
writeline:(1,0,0,1,3)#                 Write volume                     SX19  83
#                                                                       SX19  84
# WRITE PACKET 4 OF LOGICAL RECORD LRCELL:                              SX19  85
# CONTAINING THE TRANSFORMATION MATRIX                                  SX19  86
# ------------------------------------                                  SX19  87
#                                                                       SX19  88
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19  89
#                                                                       SX19  90
writeline:(1,SX018,NSX018,3,4)#        Heading                          SX19  91
DO I=1,3#                              Loop over matrix rows            SX19  92
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX19  93
ncodefld:(FN,I  ,CHROT,FMT(1),1)#      Encode a row                     SX19  94
ncodefld:(FN,I+3,CHROT,FMT(2),1)#      Encode a row                     SX19  95
ncodefld:(FN,I+6,CHROT,FMT(3),1)#      Encode a row                     SX19  96
writeline:(0,0,0,1,4)#                 Write line                       SX19  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX19  98
DO I=1,9 ; QX(IP+I)=FN(I)#             Write to buffer                  SX19  99
#                                                                       SX19 100
# WRITE PACKET 5 OF LOGICAL RECORD LRCELL:                              SX19 101
# CONTAINING THE INVERSE TRANSFORMATION MATRIX                          SX19 102
# --------------------------------------------                          SX19 103
#                                                                       SX19 104
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19 105
#                                                                       SX19 106
DO I=1,9 ; QX(IP+I)=FNI(I)#            Write to buffer                  SX19 107
writeline:(1,SX019,NSX019,3,4)#        Heading                          SX19 108
DO I=1,3#                              Loop over matrix rows            SX19 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX19 110
ncodefld:(FNI,I  ,CHROT,FMT(1),1)#     Encode a row                     SX19 111
ncodefld:(FNI,I+3,CHROT,FMT(2),1)#     Encode a row                     SX19 112
ncodefld:(FNI,I+6,CHROT,FMT(3),1)#     Encode a row                     SX19 113
writeline:(0,0,0,1,4)#                 Write line                       SX19 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX19 115
#                                                                       SX19 116
# WRITE PACKET 6 OF LOGICAL RECORD LRCELL:                              SX19 117
# MISCELLANEOUS CELL AND VOLUME DATA                                    SX19 118
# ------------------------------                                        SX19 119
#                                                                       SX19 120
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19 121
QX(IP+1)=CELVOL#                       Cell volume                      SX19 122
QX(IP+2)=SIGVOL#                       Cell volume sigma                SX19 123
DO I=3,9; QX(IP+I)=0.0#                Zeroize rest of pkt              SX19 124
QX(IP+5)=100.0#                        Set goodness of fit to initi     SX19 125
#                                                                       SX19 126
# WRITE PACKET 7 OF LOGICAL RECORD LRCELL:                              SX19 127
# CONTAINING THE METRIC TENSOR                                          SX19 128
# ----------------------------------------                              SX19 129
#                                                                       SX19 130
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19 131
writeline:(1,SX014,NSX014,3,4)#        Write header                     SX19 132
FOR(I=1;I<8;I=I+3)#                    Loop over matrix rows            SX19 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX19 134
ncodefld:(GS,I,CHROT,FMTA,3)#          Encode a row                     SX19 135
writeline:(0,0,0,1,4)#                 Write line                       SX19 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX19 137
DO I=1,9 ; QX(IP+I)=GS(I)#             Write to buffer                  SX19 138
#                                                                       SX19 139
# WRITE PACKET 8 OF LOGICAL RECORD LRCELL:                              SX19 140
# CONTAINING THE INVERSE METRIC TENSOR                                  SX19 141
# ------------------------------------                                  SX19 142
#                                                                       SX19 143
writepkt:(2,lrcell:,9,IP)#             **** writepkt ****               SX19 144
writeline:(1,SX016,NSX016,3,4)#        Heading                          SX19 145
FOR(I=1;I<8;I=I+3)#                    Loop over matrix rows            SX19 146
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX19 147
ncodefld:(GSI,I,CHROT,FMTA,3)#         Encode a row                     SX19 148
writeline:(0,0,0,1,4)#                 Write the row                    SX19 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX19 150
DO I=1,9 ; QX(IP+I)=GSI(I)#            Write to buffer                  SX19 151
writeline:(0,0,0,1,3)#                 Force blank spacer               SX19 152
#                                                                       SX19 153
#                                                                       SX19 154
RETURN#                                                                 SX19 155
END#                                                                    SX19 156
systemheader:(SX20)#                   Process & store atom type data   SX20   1
# ################################################################## #  SX20   2
#                                                                    #  SX20   3
#                               SX20                                 #  SX20   4
#                                                                    #  SX20   5
# ################################################################## #  SX20   6
SUBROUTINE SX20#                                                        SX20   7
include:(AACOMN)#                                                       SX20   8
include:(SXCOMN)#                                                       SX20   9
#                                                                       SX20  10
REAL ATWT(105)#                        Atomic weight table              SX20  11
INTEGER IEL,KEY(4)#                    Atomic number                    SX20  12
INTEGER ICHGE#                         Atomic charge                    SX20  13
INTEGER JPOINT#                                                         SX20  14
INTEGER I,J,K,L,M,N,M2#                                                 SX20  15
INTEGER IGOT,IP,STEP2A#                                                 SX20  16
string:(NAME,8)#                                                        SX20  17
string:(ELNAM,315)#                    Element symbol table             SX20  18
REAL STOLT(200),SFT(200),STOL#         Temporary storage for s.f.       SX20  19
REAL ATRADI(105)#                                                       SX20  20
REAL TEMP#                                                              SX20  21
#                                                                       SX20  22
chardata:(NUM,'0123456789 -+')#                                         SX20  23
chardata:(SX60,'International Tables Vol IV Table 2.6   ')#             SX20  24
chardata:(SX61,' Atom type     sinT/lambda   scatfac   Reference')#     SX20  25
chardata:(SX62,'Int Tables Vol IV Tables 2.2B and 2.3.1 ')#             SX20  26
chardata:(SX64, LABEL CELL CELLSD SGNAME SPACEG LATICE SYMTRY $#        SX20  27
CELMOL CELCON FORMFX FORMGN DATDEF END EXPER CELLDR ORIENT $#           SX20  28
PROTDT SCALE MAXHKL CELLDS CRYSTA )#                                    SX20  29
chardata:(SX66,' Cromer-Mann coefficients input ...')#                  SX20  30
chardata:(SX67, SCATTERING FACTOR        SHOWS RISE OF $#               SX20  31
MORE THAN TWO PERCENT)#                                                 SX20  32
chardata:(SX68,' No scattering factor data for          ')#             SX20  33
chardata:(SX6C,H  HE LI BE B  C  N  O  F  NE NA MG AL SI P  S  CL $#    SX20  34
AR K  CA SC TI V  CR MN FE CO NI CU ZN GA GE AS SE BR )#                SX20  35
chardata:(SX6D,KR RB SR Y  ZR NB MO TC RU RH PD AG CD IN SN SB TE $#    SX20  36
I  XE CS BA LA CE PR ND PM SM EU GD TB DY HO ER TM YB )#                SX20  37
chardata:(SX6E,LU HF TA W  RE OS IR PT AU HG TL PB BI PO AT RN FR $#    SX20  38
RA AC TH PA U  NP PU AM CM BK CF ES FM MD NO LR RF ?? )#                SX20  39
chardata:(SX6G," WARNING sf name XXXXXXXX not in element table")#       SX20  40
realdata:(FMT,[251042.,361032.])#                                       SX20  41
datastuff:#                                                             SX20  74

#                                                                       SX20  75
movechar:(SX6C,1,ELNAM,1,105,0)#       Transfer element symbols         SX20  76
movechar:(SX6D,1,ELNAM,106,105,0)#     Transfer element symbols         SX20  77
movechar:(SX6E,1,ELNAM,211,105,0)#     Transfer element symbols         SX20  78
#                                                                       SX20  84
#    INITIALIZE LRSCAT:                                                 SX20  85
#    ------------------                                                 SX20  86
#                                                                       SX20  87
NSCAT=0;     FFTAB=' ';  STOP3A=0#     Set start of atom type data      SX20  88
STEP2=600;  STEP2A=500;  STOP2=MARK2#  Mark2 is for atom type           SX20  89
incrqx:(MARK3,MARK2+17*STEP2,SX1001)#  Mark3 is for c-m coeffs          SX20  90
DO I=MARK2+1,MARK3; QX(I)=voidflg:#    Void the scat array              SX20  91
QX(MARK2+ 1)=1.#                       Idnum atoms per unit cell        SX20  92
QX(MARK2+ 2)=2.#                       Idnum atomic weight              SX20  93
QX(MARK2+ 3)=3.#                       Idnum atomic number              SX20  94
QX(MARK2+ 4)=4.#                       Idnum electron count             SX20  95
QX(MARK2+ 5)=5.#                       Idnum bond radius                SX20  96
QX(MARK2+ 6)=6.#                       Idnum contact radius             SX20  97
QX(MARK2+ 7)=7.#                       Idnum flag lrref: ff stored      SX20  98
QX(MARK2+ 9)=10.#                      Idnum neutron scat length        SX20  99
QX(MARK2+10)=11.#                      Idnum atom type symbol (8 ch)    SX20 100
QX(MARK2+11)=11.#                      Idnum atom type symbol (8 ch)    SX20 101
DO I=1,9;  QX(MARK2+I+11)=FLOAT(I+11)# Idnum cromer mann coeffs         SX20 102
DO I=1,25; QX(MARK2+I+20)=FLOAT(I+20)# Idnum real dispersion f'         SX20 103
DO I=1,25; QX(MARK2+I+60)=FLOAT(I+60)# Idnum imag dispersion f"         SX20 104
DO I=1,mxwd40c:;  QX(MARK2+I+89)=95.#  Idnum scat fact ref (40ch)       SX20 105
DO I=MARK2+STEP2,MARK3,STEP2#                                           SX20 106
movector:(BLANK,1,QX(I+90),1,40,1)#    Blank ff source reference        SX20 107
N=100;   M=NINT(SINT/0.01)#            Get scat fact count & interval   SX20 108
DO I=MARK2+STEP2,MARK3,STEP2#          Loop over character strings      SX20 109
movector:(BLANK,1,QX(I+90),1,40,1)#    Blank ff source reference        SX20 110
DO I=1,NSFTB#                          Loop over scatt factors          SX20 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX20 112
QX(MARK2+I+99)=FLOAT(N); N=N+M#        Idnum scat factors               SX20 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX20 114
#                                                                       SX20 115
#    ENTER LRSCAT: DATA IF UPDATE                                       SX20 116
#    ----------------------------                                       SX20 117
#                                                                       SX20 118
IF(UPD==yes:)#                         If in update mode read lrscat    SX20 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX20 120
DO I=1,STEP2A#                         Loop over possible items         SX20 121
ifnv:(QX(MARK2+I)) IWNT(I)=NINT(QX(MARK2+I))# Store idnum requests      SX20 122
ELSE               IWNT(I)=0#          Loop over possible items         SX20 123
KEY(1)=0; KEY(2)=STEP2A; KEY(3)=0; KEY(4)=0# Set search keys            SX20 124
indexpkt:(1,lrscat:,PSIZ,IP,0,KEY,IWNT,IREL)# Locate data items         SX20 125
M2=STEP2A; DO I=M2,STEP2; IREL(I)=0#   Start of transfer directory      SX20 126
IF(IP>0) DO I=1,PSIZ#                  Loop over directory packet       SX20 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX20 128
J=NINT(QX(IP+I))#                      Extract idnum                    SX20 129
DO K=1,STEP2A; IF(J==IWNT(K)) BREAK#   Exit if matches                  SX20 130
IF(K<=STEP2A) NEXT#                    This was requested               SX20 131
M2=M2+1;  QX(MARK2+M2)=QX(IP+I)#       Add directory item to list       SX20 132
IREL(M2)=I#                            Store position                   SX20 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX20 134
FOR(J=MARK2+STEP2;J>0;J=J+STEP2)#      Loop over scattering factors     SX20 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX20 136
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Read next scat fact packet       SX20 137
IF(IP<=0) BREAK#                       Exit after last scat factor      SX20 138
NSCAT=NSCAT+1#                         Count the scattering factors     SX20 139
movertoc:(QX(IP+IREL(10)),1,FFTAB,NSCAT*8-7,8,0)# Load scat fac table   SX20 140
DO I=1,STEP2#                          Transfer all lrscat items        SX20 141
IF(IREL(I)>0) ifnv:(QX(IP+IREL(I))) $# Transfer non-void data item      SX20 142
movereal:(QX,IP+IREL(I),QX,J+I,1,0)#   Transfer data item               SX20 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX20 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX20 145
#                                                                       SX20 146
#    READ CELCON LINES                                                  SX20 147
#    -----------------                                                  SX20 148
#                                                                       SX20 149
WHILE(LINID==9)#                       Loop over celcon lines           SX20 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX20 151
IF(BUFIN(1)>=voidflg:) iquit:(SX2007)# Must be character string         SX20 152
stringlim:(1,J,K)#                     Pick up scattering factor name   SX20 153
NAME=CHRIP(J^K)#                       Store sf name                    SX20 154
label:(NAME,J,K,FFTAB,N)#              Check if already present         SX20 155
M=0#
IF(N==0)M=1#                           New so load atomtype data
IF(N>0&UPD==no:) iquit:(SX2008)#       Duplicate atom type name         SX20 156
ELSE IF(N==0)    N=NSCAT+1#            Set scat fact pointer            SX20 157
IF(N>16)         iquit:(SX2010)#       Atom types exceed 16             SX20 158
FFTAB(N*8-7^N*8)=NAME#                 Store new sf name                SX20 159
K=MARK2+N*STEP2; NSCAT=MAX(NSCAT,N)#   Point to sf array                SX20 160
movector:(BLANK,1,QX(K+10),1,mxchwd:,0)# Blank atom type symbol         SX20 161
movector:(BLANK,1,QX(K+11),1,mxchwd:,0)# Blank atom type symbol         SX20 162
movector:(NAME,1,QX(K+10),1,8,0)#      Store atom type symbol           SX20 163
DO I=2,7; ifnm:(BUFIN(I)) QX(K+I-1)=BUFIN(I)# Store input values        SX20 164
ifnm:(BUFIN( 8)) QX(K+21)=BUFIN( 8)+1000.# F' with flag                 SX20 165
ifnm:(BUFIN( 9)) QX(K+61)=BUFIN( 9)+1000.# F'' with flag                SX20 166
ifnm:(BUFIN(10))#                      Neutron scat factor entered      SX20 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX20 168
IF(IRAD==1\IRAD==0) IRAD=1#            Set as neutron radiation         SX20 169
ELSE                iquit:(SX2018)#    Radiation conflict               SX20 170
QX(K+9)=BUFIN(10)#                     Neutron scattering length        SX20 171
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX20 172
IF(M==1)#                              check for new cif data request
$(
DO I=2,7; ifvo:(BUFIN(I)) REQCIF=yes:# get new atom data from cif
IF(IRAD!=1)#                           check for f' f'' corrections
$(
ifvo:(BUFIN( 9))REQCIF=yes:#           no - so load em
ifvo:(BUFIN( 8))REQCIF=yes:#           no - so load em
$)
else ifvo:(BUFIN(10)) REQCIF=yes:#     load neutron 
$)
readline:(SX64,NSX64)#                 Get next input line              SX20 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX20 174
#
STOP2=MARK2+(NSCAT+1)*STEP2#           End of atom type data            SX20 175
IF(IRAD==0) IRAD=3#                    Default is xradiation            SX20 176
#IF(IRAD==3)#                                                           SX20 177
#$(#                                   0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX20 178
#WAV=QX(MARK4+STEP4+2)#                GET THE WAVELENGTH               SX20 179
#IFEQ:(WAV,0.7106,0.1)      IRAD=3#    MO RAD                           SX20 180
#ELSE IFEQ:(WAV,1.5418,0.1) IRAD=4#    CU RAD                           SX20 181
#ELSE IFEQ:(WAV,0.5608,0.1) IRAD=5#    AG RAD                      ^^
#ELSE                       IRAD=6#    SYNC RAD                         SX20 183
#$)#                                   0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX20 184

#                                                                       SX20 251
#    PROCESS FORMFX OR FORMGN LINES                                     SX20 252
#    ----------------------------------                                 SX20 253
#                                                                       SX20 254
WHILE(LINID==10\LINID==11)#            Loop formfx and formgn           SX20 255
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX20 256
IF(IRAD==1) iquit:(SX2017)#            Do not enter neutron data        SX20 257
stringlim:(1,J,K)#                     Pick up scattering factor na     SX20 258
NAME=CHRIN(J^K)#                       Store sf name                    SX20 259
label:(NAME,I,I,FFTAB,L)#              Identify sf name                 SX20 260
IF(L==0) iquit:(SX2003)#               Die if no match was found        SX20 261
JPOINT=MARK2+L*STEP2#                  Point to scatfac list            SX20 262
#                                                                       SX20 263
IF(LINID==10)#                         *********** formfx **********    SX20 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX20 265
IGOT=1#                                Set count of formfx for atom     SX20 266
movechar:(NAME,1,CHROT,3,8,0)#         Move name                        SX20 267
ncodefld:(BUFIN,2,CHROT,FMT,2)#        Encode data                      SX20 268
ifne:(BUFIN(2),0.) iquit:(SX2001)#     First st/l must be zero          SX20 269
STOLT(IGOT)=BUFIN(2)#                  Move sin theta/lambda            SX20 270
SFT(IGOT)=  BUFIN(3)#                  Move first s.f. entry            SX20 271
IF(BUFIN(4)<voidflg:)#                 If any comment-pick it up        SX20 272
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX20 273
stringlim:(4,J,K)#                     Find comments                    SX20 274
K=MIN0(CHRMAX-J,40)#                   Calculate rest of line lengt     SX20 275
movechar:(CHRIP,J,CHROT,38,K,0)#       Copy to output                   SX20 276
movector:(CHRIP,J,QX(JPOINT+90),1,K,0)# Store ff source                 SX20 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX20 278
writeline:(1,SX61,NSX61,2,4)#          Write the heading and line       SX20 279
REPEAT#                                Loop over formfx lines           SX20 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX20 281
readline:(SX64,NSX64)#                 Read next line                   SX20 282
IF(LINID!=10) BREAK#                   Exit if new scatfac              SX20 283
stringlim:(1,J,K)#                     Pick up scattering factor na     SX20 284
NAME=CHRIN(J^K)#                       Store sf name                    SX20 285
label:(NAME,I,I,FFTAB,M)#              Identify sf name                 SX20 286
IF(M!=L) BREAK#                        Exit if new scatfac              SX20 287
IGOT=IGOT+1#                           Increment count of entries       SX20 288
IF(IGOT>200) iquit:(SX2002)#           Die if too many entries to       SX20 289
STOLT(IGOT)=BUFIN(2)#                  Store next stol entry            SX20 290
SFT(IGOT)  =BUFIN(3)#                  Store sf entry                   SX20 291
IF(STOLT(IGOT)<=STOLT(IGOT-1))iquit:(SX2005)# Stol must increase        SX20 292
IF((SFT(IGOT)*0.98)>SFT(IGOT-1))#      Test sf form                     SX20 293
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SX20 294
movechar:(NAME,1,SX67,20,8,0)#         Move sf name                     SX20 295
writeline:(1,SX67,NSX67,3,3)#          And complain                     SX20 296
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SX20 297
movechar:(NAME,1,CHROT,3,8,0)#         Move name                        SX20 298
ncodefld:(BUFIN,2,CHROT,FMT,2)#        Encode data                      SX20 299
ifch:(BUFIN(4))#                       If any comment-pick it up        SX20 300
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SX20 301
stringlim:(4,J,K)#                     Find comments                    SX20 302
K=MIN0(CHRMAX-J,40)#                   Calculate rest of line lengt     SX20 303
movechar:(CHRIN,J,CHROT,38,K,0)#       Copy to output                   SX20 304
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SX20 305
writeline:(0,SX61,NSX61,1,4)#                                           SX20 306
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX20 307
#                                                                       SX20 308
writeline:(1,SX61,NSX61,2,4)#          Print heading for generated      SX20 309
J=JPOINT+100;      STOL=0.#            Atom type storage pointer        SX20 310
DO I=1,NSFTB#                          Loop over scatfac entries        SX20 311
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SX20 312
CALL SX21(STOL,STOLT,SFT,QX(J),IGOT)#  Call four point interpol         SX20 313
IF(I==1)QX(J)=ANINT(QX(J))#            Integer f for s=0                SX20 314
movechar:(NAME,1,CHROT,3,8,0)#         Copy name to output              SX20 315
ncodefld:(STOL,1,CHROT,FMT,1)#         Encode sint/lambda               SX20 316
ncodefld:(QX(J),1,CHROT,FMT(2),1)#     Encode the f(j)                  SX20 317
writeline:(0,SX61,NSX61,1,4)#          Write the line                   SX20 318
STOL=STOL+SINT#                        Incr sin theta / lambda          SX20 319
J=J+1#                                 Incr ff table pointer            SX20 320
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SX20 321
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX20 322
#                                                                       SX20 323
ELSE IF(LINID==11)#                    *********** formgn **********    SX20 324
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SX20 325
J=JPOINT;    STOL=0.#                  Pick up pointer                  SX20 326
writeline:(1,SX66,NSX66,2,3)#          Write cromer heading             SX20 327
CHRIN(1^6)=' '#                        Blank out formgn code            SX20 328
writeline:(0,CHRIN,CHRMAX,3,3)#        Echo input image                 SX20 329
writeline:(1,SX61,NSX61,2,4)#          Print heading for generated      SX20 330
movector:(SX62,1,QX(J+90),1,40,0)#     Store source as c-m coeffs       SX20 331
J=JPOINT+11#                           Point to c-m values              SX20 332
DO I=1,9#                              Loop all c-m coeffs              SX20 333
ifnm:(BUFIN(I+1)) QX(J+I)=BUFIN(I+1)#  Store cromer mann coeffs         SX20 334
ELSE              iquit:(SX2006)#      C-m coeffs missing               SX20 335
J=JPOINT+100#                          Point to sf tables               SX20 336
DO I=1,NSFTB#                          Loop over sf values              SX20 337
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SX20 338
QX(J)=0.0#                             Zero the s.f.                    SX20 339
DO K=1,7,2#                            By cromer expansion              SX20 340
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SX20 341
QX(J)=QX(J)+BUFIN(K+1)*$#              Expand cromer-mann coef          SX20 342
EXP(-AMIN1(75.,BUFIN(K+2)*STOL**2))#   Expand cromer-mann coef          SX20 343
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SX20 344
QX(J)=QX(J)+BUFIN(10)#                 Add last coeff                   SX20 345
movechar:(NAME,1,CHROT,3,8,0)#         Copy name to output              SX20 346
ncodefld:(STOL,1,CHROT,FMT,1)#         Encode sint/lambda               SX20 347
ncodefld:(QX(J),1,CHROT,FMT(2),1)#     Encode the f(j)                  SX20 348
writeline:(0,SX61,NSX61,1,4)#          Write the line                   SX20 349
STOL=STOL+SINT#                        Incr sin theta on lambda         SX20 350
J=J+1#                                 Incr ff table pointer            SX20 351
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SX20 352
readline:(SX64,NSX64)#                 Load the next input line         SX20 353
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SX20 354
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX20 355
#
RETURN#                                                                 SX20 380
END#                                                                    SX20 381
systemheader:(SX21)#                   4-point interpol. sf curve       SX21   1
# ################################################################## #  SX21   2
#                                                                    #  SX21   3
#                               SX21                                 #  SX21   4
#                                                                    #  SX21   5
# ################################################################## #  SX21   6
SUBROUTINE SX21(ARG,T1,T2,RESULT,NTAB)##                                SX21   7
#                                                                       SX21   8
REAL ARG,RESULT,T1(*),T2(*),PROD#                                       SX21   9
INTEGER I,J,K,L,NTAB#                                                   SX21  10
#                                                                       SX21  11
# FOUR POINT INTERPOLATION SUBROUTINE SET TO USE THE                    SX21  12
# MIDDLE INTERVAL EXCEPT AT THE ENDS OF THE TABLE.                      SX21  13
# ARG NSCAT COMPARED TO TABLE VALUES IN T1 AND RESULT                   SX21  14
# NSCAT GENERATED FROM FUNCTION OF T1 IN T2.                            SX21  15
#                                                                       SX21  16
I=3;   K=NTAB-2#                       Set start/end of search          SX21  17
WHILE((ARG>T1(I))&(I<K)) I=I+1#        Loop over table 1 entries        SX21  18
I=I-2;   L=I+3#                        Set start of interpolation       SX21  19
RESULT=0.0#                                                             SX21  20
DO K=I,L#                              Loop over all points             SX21  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX21  22
PROD=1.0#                              Set up product term              SX21  23
DO J=I,L#                              Loop over all points             SX21  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX21  25
IF(K==J) NEXT#                         Forget coincident ones           SX21  26
PROD=PROD*(ARG-T1(J))/(T1(K)-T1(J))#                                    SX21  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX21  28
RESULT=RESULT+PROD*T2(K)#              Accumulate interpolation         SX21  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX21  30
#                                                                       SX21  31
RETURN#                                                                 SX21  32
END#                                                                    SX21  33
#
systemheader:(SX30)#                   Store lrexpl and lrdset data     SX30   1
######################################################################  SX30   2
#                                                                    #  SX30   3
#                               SX30                                 #  SX30   4
#                                                                    #  SX30   5
######################################################################  SX30   6
SUBROUTINE SX30#                                                        SX30   7
include:(AACOMN)#                                                       SX30   8
include:(SXCOMN)#                                                       SX30   9
#                                                                       SX30  10
INTEGER I,J,K,L,STEP5A,STEP4A,M5,M4#                                    SX30  11
INTEGER II,IP,KEY(4)#                                                   SX30  12
REAL SCALE,SIG,VOL,WAV#                                                 SX30  13
#                                                                       SX30  14
chardata:(SX1, DATDEF END EXPER CELLDR ORIENT PROTDT $#                 SX30  15
SCALE MAXHKL CELLDS CRYSTA )#                                           SX30  16
chardata:(NUM,0 1 2 3 4 5 6 7 8 9 10111213141516171819202122232425)#    SX30  17
chardata:(SX2," Radiation wavelength")#                                 SX30  18
chardata:(SX3,"neutrons electronsMoKa xrayCuKa xray$#                   SX30  19
AgKa xraySync xray")#                                                   SX30  20
realdata:(FMT,[360313.,300852.])#                                       SX30  21
datastuff:#                                                             SX30  22
#                                                                       SX30  23
#    INITIALISE LRDDEF:                                                 SX30  24
#    ------------------                                                 SX30  25
#                                                                       SX30  26
DSNAME(1^12)='PARENT'#                 First data set is parent         SX30  27
DO I=2,25; DSNAME(I*12-11^I*12)='DERIVATIVE'//NUM(I*2-1^I*2)# Others    SX30  28
IF(UPD==yes:)#                         Are we updating the bdf?         SX30  29
DO I=1,25#                             Loop over data sets              SX30  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX30  31
readwpkt:(1,lrddef:,PSIZ,IP,0)#        Read the next lrddef packet      SX30  32
IF(IP<=0) BREAK#                       Exit when all through            SX30  33
movertoc:(QX(IP+1),1,DSNAME,I*12-11,12,0)# Store the dset definition    SX30  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX30  35
#                                                                       SX30  36
#    INITIALISE LREXPL:                                                 SX30  37
#    ------------------                                                 SX30  38
#                                                                       SX30  39
MARK4=MARK3#                           Start of lrexpl data packet      SX30  40
STEP4=500;   STEP4A=225#               Space for lrexpl data            SX30  41
incrqx:(STOP4,MARK4+STEP4*26,SX3020)#  Enough for all data sets         SX30  42
DO I=MARK4+1,STOP4; QX(I)=voidflg:#    Void all data                    SX30  43
DO I=1,25;          ISCALE(I)=1#       Default number of scales         SX30  44
QX(MARK4+ 1)=1.#                       Idnum data set number            SX30  45
QX(MARK4+ 2)=2.#                       Idnum weighted mean wavelength   SX30  46
QX(MARK4+ 3)=3.#                       Idnum wavelength 1               SX30  47
QX(MARK4+ 4)=4.#                       Idnum wavelength 2               SX30  48
QX(MARK4+ 5)=5.#                       Idnum wavelength 3               SX30  49
QX(MARK4+ 6)=6.#                       Idnum rel weight wavelength 1    SX30  50
QX(MARK4+ 7)=7.#                       Idnum rel weight wavelength 2    SX30  51
QX(MARK4+ 8)=8.#                       Idnum rel weight wavelength 3    SX30  52
QX(MARK4+10)=10.#                      Idnum linear absorption coeffi   SX30  53
QX(MARK4+12)=12.#                      Idnum hkl sort order             SX30  54
QX(MARK4+13)=13.#                      Idnum cell dim a                 SX30  55
QX(MARK4+14)=14.#                      Idnum cell dim b                 SX30  56
QX(MARK4+15)=15.#                      Idnum cell dim c                 SX30  57
QX(MARK4+16)=16.#                      Idnum cos alpha                  SX30  58
QX(MARK4+17)=17.#                      Idnum cos beta                   SX30  59
QX(MARK4+18)=18.#                      Idnum cos gamma                  SX30  60
QX(MARK4+19)=19.#                      Idnum alpha  in cycles           SX30  61
QX(MARK4+20)=20.#                      Idnum beta   in cycles           SX30  62
QX(MARK4+21)=21.#                      Idnum gamma  in cycles           SX30  63
QX(MARK4+22)=22.#                      Idnum cell volume                SX30  64
QX(MARK4+23)=23.#                      Idnum sigma cell dim a           SX30  65
QX(MARK4+24)=24.#                      Idnum sigma cell dim b           SX30  66
QX(MARK4+25)=25.#                      Idnum sigma cell dim c           SX30  67
QX(MARK4+26)=26.#                      Idnum sigma alpha  in cycles     SX30  68
QX(MARK4+27)=27.#                      Idnum sigma beta   in cycles     SX30  69
QX(MARK4+28)=28.#                      Idnum sigma gamma  in cycles     SX30  70
QX(MARK4+29)=29.#                      Idnum sigma cell volume          SX30  71
DO J=1,9; QX(MARK4+J+40)=FLOAT(J+40)#  Idnum orient. matrix ub11-ub33   SX30  72
QX(MARK4+81)=81.#                      Idnum temperature measurement    SX30  73
QX(MARK4+82)=82.#                      Idnum pressure of measurement    SX30  74
QX(MARK4+85)=85.#                      Idnum measured density           SX30  75
QX(MARK4+86)=86.#                      Idnum sigma measured density     SX30  76
QX(MARK4+87)=87.#                      Idnum calculated density         SX30  77
QX(MARK4+88)=88.#                      Idnum sigma calculated density   SX30  78
QX(MARK4+94)=94.#                      Idnum type of radiation used     SX30  79
QX(MARK4+100)=100.#                    Idnum number of scale groups     SX30  80
DO J=1,64; QX(MARK4+J+100)=FLOAT(J+100)# Idnum scale factors            SX30  81
QX(MARK4+201)=501.#                    Idnum min h meas data set        SX30  82
QX(MARK4+202)=502.#                    Idnum max h meas data set        SX30  83
QX(MARK4+203)=503.#                    Idnum min k meas data set        SX30  84
QX(MARK4+204)=504.#                    Idnum max k meas data set        SX30  85
QX(MARK4+205)=505.#                    Idnum min l meas data set        SX30  86
QX(MARK4+206)=506.#                    Idnum max l meas data set        SX30  87
QX(MARK4+207)=507.#                    Idnum min theta meas data set    SX30  88
QX(MARK4+208)=508.#                    Idnum max theta meas data set    SX30  89
QX(MARK4+209)=551.#                    Idnum crystal max size           SX30  90
QX(MARK4+210)=552.#                    Idnum crystal mid size           SX30  91
QX(MARK4+211)=553.#                    Idnum crystal min size           SX30  92
DO I=1,5; QX(MARK4+211+I)=560.#        Idnum crystal colour (20ch)      SX30  93
DO I=1,5; QX(MARK4+216+I)=561.#        Idnum crystal shape (20ch)       SX30  94
#                                                                       SX30  95
DO I=1,25#                             Store defaults for 25 data set   SX30  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX30  97
J=MARK4+I*STEP4#                       Point to start of each data se   SX30  98
IF(IRAD==1) QX(J+2)=1.0#               Default neutron radiation        SX30  99
IF(IRAD==2) QX(J+2)=0.01#              Default electron radiation       SX30 100
IF(IRAD==3) QX(J+2)=0.71073#           Default xray radiation is moka   SX30 101
IF(IRAD==4) QX(J+2)=1.54179#           Default xray radiation is cuka   SX30 102
IF(IRAD==5) QX(J+2)=0.56083#           Default xray radiation is agka   SX30 103
IF(IRAD> 5) QX(J+2)=1.00000#           Default xray radiation is sync   SX30 104
DO K=1,9; QX(J+K+12)=CELLP(K)#         Default cell parameters          SX30 105
QX(J+22)=CELVOL#                       Default cell volume              SX30 106
DO K=1,3; QX(J+K+22)=CELLS(K)#         Default sigma cell dim           SX30 107
DO K=1,3; QX(J+K+25)=CELLS(K+6)#       Default sigma cell angles        SX30 108
QX(J+29)=SIGVOL#                       Default sigma cell volume        SX30 109
QX(J+81)=293.#                         Default temperature in kelvin    SX30 110
QX(J+94)=FLOAT(IRAD)#                  Radiation 1/2/3/4/5/6            SX30 111
QX(J+100)=1.#                          Default scale groups             SX30 112
QX(J+101)=1.#                          Default scale 1                  SX30 113
movector:(SX2,1,QX(J+212),1,20,1)#     Blank crystal colour/shape       SX30 114
movector:(SX2,1,QX(J+217),1,20,1)#     Blank crystal colour/shape       SX30 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX30 116
QX(MARK4+STEP4+1)=1.#                  Must include dataset 1           SX30 117
#                                                                       SX30 118
IF(UPD==yes:)#                         Are we in update mode?           SX30 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX30 120
DO I=1,STEP4A#                         Loop over possible items         SX30 121
ifnv:(QX(MARK4+I)) IWNT(I)=NINT(QX(MARK4+I))# Store idnum requests      SX30 122
ELSE               IWNT(I)=0#          Cancel idnum request             SX30 123
KEY(1)=0; KEY(2)=STEP4A; KEY(3)=0; KEY(4)=0# Set search keys            SX30 124
indexpkt:(1,lrexpl:,PSIZ,IP,0,KEY,IWNT,IREL)# Locate data items         SX30 125
M4=STEP4A; DO I=M4,STEP4; IREL(I)=0#   Start of transfer directory      SX30 126
IF(IP>0) DO I=1,PSIZ#                  Loop over directory packet       SX30 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX30 128
J=NINT(QX(IP+I))#                      Extract idnum                    SX30 129
DO K=1,STEP4A; IF(J==IWNT(K)) BREAK#   Exit if matches                  SX30 130
IF(K<=STEP4A) NEXT#                    This was requested               SX30 131
M4=M4+1;  QX(MARK4+M4)=QX(IP+I)#       Add directory item to list       SX30 132
IREL(M4)=I#                            Store position                   SX30 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX30 134
REPEAT#                                Loop over lrexpl packets         SX30 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX30 136
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Read next lrexpl packet          SX30 137
IF(IP<=0) BREAK#                       Exit if all through              SX30 138
IF(IREL(1)>0) I=NINT(QX(IP+IREL(1)))#  Point to data set value          SX30 139
ELSE          I=1#                     Assume data set is one           SX30 140
K=MARK4+I*STEP4#                       Point to data set packet         SX30 141
DO I=1,STEP4#                          Transfer all lrexpl items        SX30 142
IF(IREL(I)>0) ifnv:(QX(IP+IREL(I))) $# Transfer non-void data item      SX30 143
movereal:(QX,IP+IREL(I),QX,K+I,1,0)#                                    SX30 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX30 145
#                                      For data set 1 take "new" cell   SX30 146
J=MARK4+STEP4#                         Point to start of each data se   SX30 147
DO K=1,9; QX(J+K+12)=CELLP(K)#         Default cell parameters          SX30 148
QX(J+22)=CELVOL#                       Default cell volume              SX30 149
DO K=1,3; QX(J+K+22)=CELLS(K)#         Default sigma cell dim           SX30 150
DO K=1,3; QX(J+K+25)=CELLS(K+6)#       Default sigma cell angles        SX30 151
QX(J+29)=SIGVOL#                       Default sigma cell volume        SX30 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX30 153
#                                                                       SX30 154
#    INITIALISE LRDSET:                                                 SX30 155
#    ------------------                                                 SX30 156
#                                                                       SX30 157
MARK5=STOP4#                           Start of lrdset data packet      SX30 158
STEP5=200;   STEP5A=100#               Space for lrdset data            SX30 159
incrqx:(STOP5,MARK5+STEP5*26,SX3020)#  Enough for all data sets         SX30 160
DO I=MARK5+1,STOP5; QX(I)=voidflg:#    Void all data                    SX30 161
QX(MARK5+ 1)=1.#                       Idnum data set number            SX30 162
QX(MARK5+ 2)=2.#                       Idnum overall u                  SX30 163
QX(MARK5+ 3)=3.#                       Idnum flack x parameter          SX30 164
QX(MARK5+ 4)=11.#                      Idnum max |h|                    SX30 165
QX(MARK5+ 5)=12.#                      Idnum max |k|                    SX30 166
QX(MARK5+ 6)=13.#                      Idnum max |l|                    SX30 167
QX(MARK5+ 7)=14.#                      Idnum min sin t/lambda           SX30 168
QX(MARK5+ 8)=15.#                      Idnum max sin t/lambda           SX30 169
QX(MARK5+ 9)=30.#                      Idnum rel scale, ds to parent    SX30 170
QX(MARK5+10)=31.#                      Idnum rel del u, ds to parent    SX30 171
QX(MARK5+11)=32.#                      Idnum closure error              SX30 172
QX(MARK5+12)=33.#                      Idnum closure error, anomalous   SX30 173
QX(MARK5+13)=71.#                      Idnum min h unique data set      SX30 174
QX(MARK5+14)=72.#                      Idnum max h unique data set      SX30 175
QX(MARK5+15)=73.#                      Idnum min k unique data set      SX30 176
QX(MARK5+16)=74.#                      Idnum max k unique data set      SX30 177
QX(MARK5+17)=75.#                      Idnum min l unique data set      SX30 178
QX(MARK5+18)=76.#                      Idnum max l unique data set      SX30 179
QX(MARK5+19)=77.#                      Idnum min theta unique data se   SX30 180
QX(MARK5+20)=78.#                      Idnum max theta unique data se   SX30 181
QX(MARK5+21)=79.#                      Idnum d resol high               SX30 182
QX(MARK5+22)=80.#                      Idnum d resol low                SX30 183
QX(MARK5+23)=81.#                      Idnum number reflns unique set   SX30 184
QX(MARK5+24)=82.#                      Idnum number reflns rcode 1      SX30 185
QX(MARK5+25)=83.#                      Idnum number reflns rcode 2      SX30 186
QX(MARK5+26)=84.#                      Idnum number reflns rcode 3      SX30 187
QX(MARK5+27)=85.#                      Idnum number reflns rcode 4      SX30 188
QX(MARK5+28)=86.#                      Idnum number reflns rcode 5      SX30 189
QX(MARK5+29)=87.#                      Idnum rcode criterion            SX30 190
#                                                                       SX30 191
DO I=1,25#                             Store defaults for 25 data set   SX30 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX30 193
J=MARK5+I*STEP5#                       Point to start of each data se   SX30 194
QX(J+2)=0.035#                         Default overall u                SX30 195
QX(J+3)=0.5#                           Default flack x parameter        SX30 196
QX(J+4)=99.#                           Default max |h|                  SX30 197
QX(J+5)=99.#                           Default max |k|                  SX30 198
QX(J+6)=99.#                           Default max |l|                  SX30 199
QX(J+7)=0.#                            Default min s                    SX30 200
QX(J+8)=2.#                            Default max s                    SX30 201
QX(J+9)=1.#                            Default relative scale           SX30 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX30 203
QX(MARK5+STEP5+1)=1.#                  Must include dataset 1           SX30 204
#                                                                       SX30 205
IF(UPD==yes:)#                         Are we in update mode?           SX30 206
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX30 207
DO I=1,STEP5A#                         Loop over possible items         SX30 208
ifnv:(QX(MARK5+I)) IWNT(I)=NINT(QX(MARK5+I))# Store idnum requests      SX30 209
ELSE               IWNT(I)=0#          Loop over possible items         SX30 210
KEY(1)=0; KEY(2)=STEP5A; KEY(3)=0; KEY(4)=0# Set search keys            SX30 211
indexpkt:(1,lrdset:,PSIZ,IP,0,KEY,IWNT,IREL)# Locate data items         SX30 212
M5=STEP5A; DO I=M5,STEP5; IREL(I)=0#   Start of transfer directory      SX30 213
IF(IP>0) DO I=1,PSIZ#                  Loop over directory packet       SX30 214
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX30 215
J=NINT(QX(IP+I))#                      Extract idnum                    SX30 216
DO K=1,STEP5A; IF(J==IWNT(K)) BREAK#   Exit if matches                  SX30 217
IF(K<=STEP5A) NEXT#                    This was requested               SX30 218
M5=M5+1;  QX(MARK5+M5)=QX(IP+I)#       Add directory item to list       SX30 219
IREL(M5)=I#                            Store position                   SX30 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX30 221
REPEAT#                                Loop over lrdset packets         SX30 222
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX30 223
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Read next lrexpl packet          SX30 224
IF(IP<=0) BREAK#                       Exit if all through              SX30 225
IF(IREL(1)>0) I=NINT(QX(IP+IREL(1)))#  Point to data set value          SX30 226
ELSE          I=1#                     Assume data set is one           SX30 227
K=MARK5+I*STEP5#                       Point to data set packet         SX30 228
DO I=1,STEP5#                          Transfer all lrdset items        SX30 229
IF(IREL(I)>0) ifnv:(QX(IP+IREL(I))) $# Transfer non-void data item      SX30 230
movereal:(QX,IP+IREL(I),QX,K+I,1,0)#   Transfer data item               SX30 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX30 232
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX30 233
#                                                                       SX30 234
#    ENTER LINES DATDEF AND BEYOND .....                                SX30 235
#    -----------------------------                                      SX30 236
#                                                                       SX30 237
LINID=LINID-11;   VOL=-1.#             Start line ids at datdef         SX30 238
WHILE(LINID>0)#                        Loop over input lines            SX30 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SX30 240
IF(LINID==2) BREAK#                    Quit looking when end line       SX30 241
#                                                                       SX30 242
IF(LINID==1)#                          ********** datdef **********     SX30 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX30 244
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract data set number          SX30 245
ELSE             I=1#                  Store default data set numbe     SX30 246
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 247
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 248
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 249
IF(BUFIN(2)>=voidflg:) iquit:(SX3002)# Dont take junk for names         SX30 250
stringlim:(2,J,K)#                     Get character string address     SX30 251
DSNAME(I*12-11^I*12)=CHRIN(J^K)#       Store data set name              SX30 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX30 253
#                                                                       SX30 254
ELSE IF(LINID==3)#                     ********* exper *************    SX30 255
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX30 256
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract data set number          SX30 257
ELSE             I=1#                  Store default data set number    SX30 258
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 259
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 260
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 261
ifne:(QX(K+2),BUFIN(2),0.0001)REQCIF=yes:# if new wavelength use atomtyp
ifne:(QX(K+2),BUFIN(2),0.0001)#        Test if new wavelength           SX30 262
FOR(L=MARK2+STEP2;L<STOP2;L=L+STEP2)#  Loop over scatt factors          SX30 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX30 264
IF(QX(L+I+20)<500.) QX(L+I+20)=voidflg:# Reset to force new values      SX30 265
IF(QX(L+I+60)<500.) QX(L+I+60)=voidflg:# Reset to force new values      SX30 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX30 267
DO L=2,8; ifnm:(BUFIN(L)) QX(K+L)=BUFIN(L)# Save supplied quantity      SX30 268
ifnm:(BUFIN( 9)) QX(K+85)=BUFIN( 9)#   Measured density                 SX30 269
ELSE             QX(K+85)=voidflg:#    Signal density not there         SX30 270
ifnm:(BUFIN(10)) QX(K+10)=BUFIN(10)#   Absorption coeff                 SX30 271
ifnm:(BUFIN(11)) QX(K+81)=BUFIN(11)+273.# Temp of measurement in k      SX30 272
ifnm:(BUFIN(12)) QX(K+12)=BUFIN(12)#   Sort order hkl                   SX30 273
ifnm:(BUFIN(13)) QX(K+82)=BUFIN(13)#   Pressure of measurement          SX30 274
ifnm:(BUFIN(14)) QX(K+94)=BUFIN(14)#   Type of rad 1/2/3/4/5/6          SX30 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX30 276
#                                                                       SX30 277
ELSE IF(LINID==4)#                     ************ celldr *********    SX30 278
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SX30 279
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract dataset number           SX30 280
ELSE             I=1#                  Default dataset number           SX30 281
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 282
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 283
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 284
DO L=1,3#                              Loop over input fields           SX30 285
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SX30 286
ifnm:(BUFIN(L+1)) QX(K+L+12)=BUFIN(L+1)# Store input cell dim           SX30 287
ifnm:(BUFIN(L+4)) QX(K+L+18)=BUFIN(L+4)/360.# Store angle as cycle      SX30 288
ELSE              QX(K+L+18)=0.25#     Default is 90 degrees            SX30 289
QX(K+L+15)=COS(QX(K+L+18)*6.283185)#   Store cosines as well            SX30 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SX30 291
DO L=1,9; CELLP(I)=QX(K+L+12)#         Store cell dimensions            SX30 292
VOL=CELLP(1)*CELLP(2)*CELLP(3)*$#      Calc cell volume                 SX30 293
       SQRT(1.0+2.0*CELLP(4)*CELLP(5)*CELLP(6)$# Cell volume            SX30 294
       -CELLP(4)**2-CELLP(5)**2-CELLP(6)**2)# Cell volume               SX30 295
QX(K+20)=VOL#                          Store cell volume                SX30 296
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SX30 297
#                                                                       SX30 298
ELSE IF(LINID==9)#                     ************ cellds *********    SX30 299
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SX30 300
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract dataset number           SX30 301
ELSE             I=1#                  Default dataset number           SX30 302
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 303
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 304
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 305
DO L=1,3#                              Loop over input fields           SX30 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SX30 307
ifnm:(BUFIN(L+1)) QX(K+L+22)=BUFIN(L+1)# Store input cell dim           SX30 308
ELSE              QX(K+L+22)=0.#       Default is zero                  SX30 309
ifnm:(BUFIN(L+4)) QX(K+L+25)=BUFIN(L+4)/360.# Store angle as cycle      SX30 310
ELSE              QX(K+L+25)=0.#       Default is zero                  SX30 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SX30 312
DO L=1,3; CELLS(I)=QX(K+L+22)#         Store cell sigmas                SX30 313
IF(VOL<0.) VOL=CELVOL#                 Ensure cell volume available     SX30 314
SIG=VOL*SQRT(CAVAR(1)*(CELLS(1)/CELLP(1))**2$# Sigma cell volume        SX30 315
            +CAVAR(2)*(CELLS(2)/CELLP(2))**2$# Sigma cell volume        SX30 316
            +CAVAR(3)*(CELLS(3)/CELLP(3))**2$# Sigma cell volume        SX30 317
+CAVAR(4)*(CELLP(1)*CELLP(2)*CELLP(3)/CELVOL)**4$# Sigma cell volume    SX30 318
*(CELLS(4)**2*(CELLP(4)-CELLP(5)*CELLP(6))**2$#                         SX30 319
 +CELLS(5)**2*(CELLP(5)-CELLP(4)*CELLP(6))**2$#                         SX30 320
 +CELLS(6)**2*(CELLP(6)-CELLP(5)*CELLP(4))**2))#                        SX30 321
QX(K+27)=SIG#                          Store cell volume                SX30 322
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SX30 323
#                                                                       SX30 324
ELSE IF(LINID==5)#                     ********** orient **********     SX30 325
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SX30 326
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract datset number            SX30 327
ELSE             I=1#                  Default dataset number           SX30 328
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 329
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 330
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 331
DO L=1,9; QX(K+L+40)=BUFIN(L+1)#       Store orient matrix              SX30 332
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SX30 333
#                                                                       SX30 334
ELSE IF(LINID==6)#                     *********** protdt ***********   SX30 335
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SX30 336
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract dataset number           SX30 337
ELSE             I=1#                  Default dataset number           SX30 338
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 339
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 340
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 341
ifnm:(BUFIN(2)) QX(J+2)=BUFIN(2)#      Store uovl                       SX30 342
DO L=1,4; ifnm:(BUFIN(L+2)) QX(J+L+8)=BUFIN(L+2)# Store protein data    SX30 343
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SX30 344
#                                                                       SX30 345
ELSE IF(LINID==7)#                     ********* scale *************    SX30 346
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SX30 347
FOR(L=1;L<=mxfdim:;L=L+3)#             Loop over whole input line       SX30 348
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SX30 349
ifvo:(BUFIN(L)) BREAK#                 Exit when void                   SX30 350
IF(BUFIN(L)>small:) SCALE=BUFIN(L)#    Extract input scale              SX30 351
ELSE                SCALE=1.0#         Set default value to 1.0         SX30 352
IF(BUFIN(L+1)>0.1) II=MIN0(NINT(BUFIN(L+1)),64)# Extract group number   SX30 353
ELSE               II=1#               Default scale group number       SX30 354
IF(BUFIN(L+2)>0.1) I=NINT(BUFIN(L+2))# Extract dataset number           SX30 355
ELSE               I=1#                Default dataset number           SX30 356
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 357
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 358
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 359
ISCALE(I)=MAX0(ISCALE(I),II)#          Find max no. scale factors       SX30 360
QX(K+100)=FLOAT(ISCALE(I))#            Set scale group                  SX30 361
QX(K+100+II)=SCALE#                    Store scale value                SX30 362
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SX30 363
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SX30 364
#                                                                       SX30 365
ELSE IF(LINID==8)#                     ************ maxhkl *********    SX30 366
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SX30 367
IF(BUFIN(6)>0.1) I=NINT(BUFIN(6))#     Extract dataset number           SX30 368
ELSE             I=1#                  Set default dataset number       SX30 369
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 370
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 371
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 372
DO L=1,5; ifnm:(BUFIN(L)) QX(J+L+3)=BUFIN(L)# Store input quantity      SX30 373
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SX30 374
#                                                                       SX30 375
ELSE IF(LINID==9)#                     ************ cellds *********    SX30 376
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SX30 377
IF(BUFIN(1)>0.1) I=NINT(BUFIN(1))#     Extract dataset number           SX30 378
ELSE             I=1#                  Default dataset number           SX30 379
IF(I>25) iquit:(SX3001)#               Max data sets exceeded           SX30 380
K=MARK4+I*STEP4;  J=MARK5+I*STEP5#     Set lrexpl & lrdset pointers     SX30 381
QX(K+1)=FLOAT(I); QX(J+1)=FLOAT(I)#    Store data set number            SX30 382
DO L=1,3#                              Loop over input fields           SX30 383
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SX30 384
ifnm:(BUFIN(L+1)) QX(K+L+22)=BUFIN(L+1)# Store input cell dim           SX30 385
ELSE              QX(K+L+22)=0.#       Default is zero                  SX30 386
ifnm:(BUFIN(L+4)) QX(K+L+25)=BUFIN(L+4)/360.# Store angle as cycle      SX30 387
ELSE              QX(K+L+25)=0.#       Default is zero                  SX30 388
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SX30 389
DO L=1,3; CELLS(I)=QX(K+L+22)#         Store cell sigmas                SX30 390
IF(VOL<0.) VOL=CELVOL#                 Ensure cell volume available     SX30 391
SIG=VOL*SQRT(CAVAR(1)*(CELLS(1)/CELLP(1))**2$# Sigma cell volume        SX30 392
            +CAVAR(2)*(CELLS(2)/CELLP(2))**2$# Sigma cell volume        SX30 393
            +CAVAR(3)*(CELLS(3)/CELLP(3))**2$# Sigma cell volume        SX30 394
+CAVAR(4)*(CELLP(1)*CELLP(2)*CELLP(3)/CELVOL)**4$# Sigma cell volume    SX30 395
*(CELLS(4)**2*(CELLP(4)-CELLP(5)*CELLP(6))**2$#                         SX30 396
 +CELLS(5)**2*(CELLP(5)-CELLP(4)*CELLP(6))**2$#                         SX30 397
 +CELLS(6)**2*(CELLP(6)-CELLP(5)*CELLP(4))**2))#                        SX30 398
QX(K+27)=SIG#                          Store cell volume                SX30 399
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SX30 400
#                                                                       SX30 401
ELSE IF(LINID==10)#                    ************ crystal*********    SX30 402
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SX30 403
I=MARK4+STEP4+208#                     Point to data set 1              SX30 404
ifnm:(BUFIN(3)) QX(I+1)=BUFIN(3)#      Crystal max size                 SX30 405
ifnm:(BUFIN(4)) QX(I+2)=BUFIN(4)#      Crystal mid size                 SX30 406
ifnm:(BUFIN(5)) QX(I+3)=BUFIN(5)#      Crystal min size                 SX30 407
stringlim:(1,J,K)#                     Get crystal colour               SX30 408
ifch:(BUFIN(1))movector:(CHRIP,J,QX(I+4),1,K-J,0)# Save the colour      SX30 409
stringlim:(2,J,K)#                     Get crystal shape                SX30 410
ifch:(BUFIN(2))movector:(CHRIP,J,QX(I+9),1,K-J,0)# Save the shape       SX30 411
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SX30 412
#                                                                       SX30 413
readline:(SX1,NSX1)#                   Keep reading input lines         SX30 414
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SX30 415
#                                                                       SX30 416
IF(IRAD>2)#                            These are xrays; what type?      SX30 417
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SX30 418
WAV=QX(MARK4+STEP4+2)#                 Get the wavelength               SX30 419
IF     (ABS(WAV-0.7106)<.01) IRAD=3#    Mo rad                    
ELSE IF(ABS(WAV-1.5418)<.01) IRAD=4#    Cu rad                   
ELSE IF(ABS(WAV-0.5608)<.01) IRAD=5#    Ag rad                   
ELSE                   IRAD=6#         Sync rad                         SX30 423
QX(MARK4+STEP4+94)=FLOAT(IRAD)#        Store rad type for data set 1    SX30 424
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SX30 425
#                                                                       SX30 426
#    CHECK STORED ATOM TYPE DATA                                        SX30 427
#    ---------------------------                                        SX30 428
writeline:(0,0,0,1,3)#                 Insert line spacer               SX30 429
movechar:(SX2,1,CHROT,1,NSX2,0)#       Insert radiation header          SX30 430
movechar:(SX3,IRAD*9-8,CHROT,45,9,0)#  Insert radiation header          SX30 431
FOR(L=MARK4+STEP4;L<STOP4;L=L+STEP4)#  Loop over experimental data      SX30 432
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SX30 433
ifvo:(QX(L+1)) NEXT#                   Skip void data sets              SX30 434
ncodefld:(QX,L+1,CHROT,FMT,2)#         Format dataset and wavelength    SX30 435
writeline:(0,0,0,1,3)#                 Print dataset and wavelength     SX30 436
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SX30 437
#                                                                       SX30 438
RETURN#                                                                 SX30 439
END#                                                                    SX30 440
systemheader:(SX35)#                   Populate atomic property data
################################################################        SX41   2
#                                                              #        SX41   3
#                            SX35                              #        SX41   4
#                                                              #        SX41   5
################################################################        SX41   6
SUBROUTINE SX35#                       Read elemental data from a cif
include:(AACOMN)#                                                       SX41   8
include:(SXCOMN)#                                                       SX41   9

INTEGER LNBLNK#                        Function returning int           PB00  11
LOGICAL F1,F2,F3,F4,F5#  
REAL FP,FPP,MUA,NEUTSCF,EMU(25)
REAL A1,A2,A3,A4,B1,B2,B3,B4,C
REAL C0,C1,C2,C3
REAl CM(9)
REAL WLEN
REAL WAVE(4),FPI(4),FPPI(4),MUAI(4)
INTEGER ICNTMU(2),ICNTDSP(2)#          Source flags
string:(itemwave,50)
string:(itemmua,50)
string:(itemfp,50)
string:(itemfpp,50)
string:(edge,20)
chardata:(NUM,'0123456789 -+')#                                         SX20  23
INTEGER I,J,K,L,M,N,NS#                Index integers                   SX26  11
REAL STOL,F,S#                         St/l, ff, s**2                   SX26  12
REAL Z#      
#                                                                       SX31  12
#                                                                       PB00  10
INTEGER NBLK#                                                           PB00  13
string:(ELSYM,8)#                                                       PB00  16
string:(NAME,24)#                                                       PB00  16
string:(FRMREF1,50);string:(FRMREF2,50)
string:(MUAREF1,50);string:(MUAREF2,50)
string:(DSPREF1,50);string:(DSPREF2,50)
string:(EDGREF,50)
chardata:(SX351," Please acknowledge the following sources $#
of anomalous dispersion data")# 
chardata:(SX352," Please acknowledge the following sources $#
of absorption attenuation data")# 
chardata:(SX6A,'International Tables Vol IV Table 2.6   ')#             SX20  24
chardata:(SX61,' Atom type     sinT/lambda   scatfac   Reference')#     SX20  25
chardata:(SX62,'Int Tables Vol IV Tables 2.2B and 2.3.1 ')#             SX20  26
chardata:(SX1," Atom   sinT/L      scat fact      Z=XXX e=XXX ")#       SX26  14
chardata:(SX68,' No scattering factor data for          ')#             SX20  33
chardata:(SX130," Neutron b")#                                          SX31  13
chardata:(SX131," Expected Cell Contents-")#                            SX31  14
chardata:(SX132," Number  Type   At.Wt.  At.No.  Electrons  Bond R. $#  SX31  15
Cont.R.      f     f   ")#                                              SX31  16
chardata:(SX133," Calculated density        megagrams per $#            SX31  17
cubic metre")#                                                          SX31  18
chardata:(SX134," Molecular content of cell          ")#                SX31  19
chardata:(SX135," WARNING- Calculated density may be too low$#          SX31  20
-- Check CELCON input.")#                                               SX31  21
chardata:(SX136," WARNING- Calculated density may be too high$#         SX31  22
-- Check CELCON input.")#                                               SX31  23
chardata:(SX137," WARNING- cell contents suggest molecular content $#   SX31  24
may be too high.")#                                                     SX31  25
realdata:(FMT2,[70613.,220622.,280413.,370413.,490632.,570632.,#        SX31  26
660632.,660632.,660632.,720632.])#                                      SX31  27
chardata:(SX401,' Calculated absorption coef (/mm) =          ')#       SX40  13
realdata:(FMT,[400313.,460313.])#                                       SX26  16
datastuff:#                                                             PB00  22
#                                                                       PB00  24
# READ IN THE CIF FILE WITH CIFTBX                                      PB00  25
# --------------------------------                                      PB00  26
#                                                                       PB00  27
#
DO I=1,NSCAT;ifne:(QX(MARK2+I*STEP2+3),0.,0.001)# ignor Z=0 dummy site
ifvo:(QX(MARK2+I*STEP2+100))REQCIF=yes:# check scat facs
IF(REQCIF!=yes:)GOTO 999#              Byparse very slow cif reading
#
APPEND_=.FALSE.#                       Overwrite any existing           PB00  34
F1=INIT_(iofm1:, 0, ioda1:, ioprt:)#   Set device numbers               PB00  35
F1=DICT_(' ','close')#                 Close any existing dictionarie   PB00  36
IF(!OCIF_(atomtyp:))  iquit:(CF5060)#  Open atomtype.cif
#                                                                       PB00  60
# PARSE CIF FOR DATA BLOCKS AND GET ATOM TYPE INFO
# ------------------------------------------------------------          PB00  62
#
Do I=1,25;EMU(I)=0.0#                  Set mu to zero                   SX41  58
DO I=1,2# 
$(ICNTMU(I)=0;ICNTDSP(I)=0$)#
IACNT=0
FOR(NBLK=0;DATA_(' ');NBLK=NBLK+1)#    Check each data block in cif     PB00  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PB00  69
upcase:(BLOC_,BLOC_,7)#
IF(BLOC_=='GLOBAL ')
$(
FRMREF1=' ';FRMREF2=' '
MUAREF1=' ';MUAREF2=' '
DSPREF1=' ';DSPREF2=' '
EDGREF=' '
F1=CHAR_('_atom_type_scat.Cromer_Mann_reference',FRMREF1)#
F1=CHAR_('_atom_type_scat.hi_ang_Fox_reference',FRMREF2)#
F1=CHAR_('_atom_type_scat.absorption_edge_reference',EDGREF)#
F1=CHAR_('_atom_type_scat.absorption_coef_reference',MUAREF2)#
F1=CHAR_('_atom_type_scat.dispersion_reference',DSPREF2)#
F1=CHAR_('_atom_type_scat.specific_cross_section_reference',MUAREF1)#
F1=CHAR_('_atom_type_scat.specific_dispersion_reference',DSPREF1)#
$)
#
# DECIDE IF WE NEED THIS ATOMTYPE ELEMENT DATA
# --------------------------------------------
#
IF(!CHAR_('_atom_type.element_symbol',ELSYM))NEXT# skip-no symbol here
upcase:(ELSYM,ELSYM,2)
IF(ELSYM(2^2)==' ')IAC=1
ELSE               IAC=2
DO I=1,NSCAT
$(
ION=0
K=MARK2+I*STEP2#
movertoc:(QX(K+10),1,NAME,1,8,0)
upcase:(name,NAME,8)
label:(NAME,J,L,FFTAB,M)
IF(L==1&IAC==1)IF(ELSYM(1^1)==NAME(1^1))BREAK# 1char symbol match
               ELSE NEXT
IF(L==2&IAC==2)IF(ELSYM(1^2)==NAME(1^2))BREAK# 2char symbol match
               ELSE NEXT
IF(L>2&IAC==2)IF(ELSYM(1^2)!=NAME(1^2))NEXT# no -match
#                Search for digit, blnk, + or -   SX20 196
ION=1#                                Looks like its ionized
IF(INDEX(NUM,NAME(2^2))!=0)IF(IAC==1&(ELSYM(1^1)==NAME(1^1)))BREAK
IF(INDEX(NUM,NAME(3^3))!=0)IF(IAC==2&(ELSYM(1^2)==NAME(1^2)))BREAK
$)
# could also run a test for atomic number match instead of symbol
IF(I>NSCAT)NEXT#                       this cif element not needed
NS=I
# 
#  DETERMINE IONIC STATE OF ELEMENT
#  --------------------------------
#
IF(ION==1)#                            get required ionic state
$(
ICHGE=0#                               Reset abs(charge)                SX20 193
DO I=1,8#                              Loop over sf name                SX20 194
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX20 195
J=INDEX(NUM,NAME(I^I))#                Search for digit, blnk, + or -   SX20 196
IF(J>0) BREAK#                         Exit when detected               SX20 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX20 198
IF(J!=11)#                             If not a blank                   SX20 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SX20 200
L=INDEX(NUM,NAME(I+1^I+1))#            Get digit                        SX20 201
IF(L==0\L<11\(J<11&L==11)) iquit:(SX2014)# Illegal sf name              SX20 202
IF(J>10&L>11)              iquit:(SX2015)# Illegal sf name              SX20 203
IF(J<11)  ICHGE=J-1;  ELSE ICHGE=1#    Store charge magnitude           SX20 204
IF(J==12) ICHGE=-1#                    Store excess one electron        SX20 205
IF(L==12) ICHGE=-ICHGE#                Apply negative sign              SX20 206
NAME(I^8)=' '#                         Blank off charge                 SX20 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SX20 208
$)
#
F1=NUMB_('_atom_type.atomic_number',ATN,sig)# atomic number
F1=NUMB_('_atom_type.atomic_mass',ATMASS,sig)# molar atomic mass
F1=NUMB_('_atom_type.radius_bond',RAD,sig)# atomic radii
f1=NUMB_('_atom_type_scat.hi_ang_Fox_c0',c0,sig)# 
f1=NUMB_('_atom_type_scat.hi_ang_Fox_c1',c1,sig)# 
f1=NUMB_('_atom_type_scat.hi_ang_Fox_c2',c2,sig)# 
f1=NUMB_('_atom_type_scat.hi_ang_Fox_c3',c3,sig)# 
#
#   CHARGE DEPENDENT PROPERTIES
#   ---------------------------
#
ECNT=0.0
REPEAT
$(
IF(!NUMB_('_atom_type.electron_count',ECNT,sig))BREAK
ifne:(ECNT,ATN+FLOAT(ICHGE)) NEXT#    Atomic charge matches
f1=NUMB_('_atom_type_scat.Cromer_Mann_a1',CM(1),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_b1',CM(2),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_a2',CM(3),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_b2',CM(4),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_a3',CM(5),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_b3',CM(6),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_a4',CM(7),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_b4',CM(8),sig) 
f1=NUMB_('_atom_type_scat.Cromer_Mann_c' ,CM(9),sig) 
BREAK
$)
#
#  SAVE RELEVENT IONIC DATA
#  ------------------------
#
IEL=1#
IF(QX(K+1)<0.)   QX(K+1)=0.#           Store no. of atoms per cell      SX20 217
IF(QX(K+2)>0.);#                       Atomic weight already in         SX20 218
ELSE IF(IEL==0)  QX(K+2)=0.#           Dummy atom                       SX20 219
ELSE             QX(K+2)=ATMASS#       Use value from sf name           SX20 220
IF(QX(K+3)<=0.)  QX(K+3)=ATN#          Atomic number from sf name       SX20 221
IF(QX(K+4)<=0.)  QX(K+4)=ATN-FLOAT(ICHGE)# No. electrons from sf name   SX20 222
IF(IEL==0)       TEMP=0.0#             No element name found            SX20 224
ELSE IF(ICHGE!=0)TEMP=RAD+.2-.7*SIGN(1.,FLOAT(ICHGE))# Ion      SX20 225
ELSE             TEMP=RAD#     Set neutral atom radius          SX20 226
IF(QX(K+5)<=0.2) QX(K+5)=TEMP#         Set default bond radius          SX20 227
IF(QX(K+6)<=0.2) QX(K+6)=TEMP+1.25#    Set default contact radius       SX20 228
QX(K+7)=0.#                            No interp. sf on lfrefl          SX20 229
#
#  SAVE NEUTRON FORM FACTOR
#  ------------------------
#
IF(IRAD==1) ifvo:(QX(K+9))#            If neutron scat length needed    SX20 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SX20 231
f1=NUMB_('_atom_type_scat.length_neutron',NEUTSCF,sig)# 
QX(K+9)=NEUTSCF#                       Store neutron scat length        SX20 232
movector:(SX6A,1,QX(K+90),1,40,0)#     Neutron ff source reference      SX20 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SX20 234
#
#   WAVELENGTH DEPENDENT PROPERTIES VARY FOR EACH DATA SET
#   ------------------------------------------------------
#
# for multiple data sets, this is very inefficient.
# a better way would be sort ascending wavelengths
# and make a single pass over the CIF data block
# But multi data blocks are used so rarely that I doubt its worth it.
#
FOR(ID=MARK4+STEP4;ID<STOP4;ID=ID+STEP4)# Loop over experimental data 
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SX30 433
ifvo:(QX(ID+1)) NEXT#                  Skip void data sets              SX30 434
LDSET=NINT(QX(ID+1))#                  1-25
WAV=QX(ID+2)#                          GET THE WAVELENGTH               SX20 179
IF(IRAD<=2)NEXT#                       what about electrons?
IRAD=6#
mua=voidflg:
fp =voidflg:
fpp=voidflg:
REPEAT
$(
f1=NUMB_('_atom_type_scat.specific_source_wavelength',WLEN,sig)
IF(!F1) BREAK
ifne:(WAV,WLEN,0.01)
$(
IF(LOOP_)NEXT#
BREAK
$)
ifeq:(WAV,0.7106,0.01)      IRAD=3#    MO RAD                           SX20 180
ELSE ifeq:(WAV,1.5418,0.01) IRAD=4#    CU RAD                           SX20 181
ELSE ifeq:(WAV,0.5608,0.01) IRAD=5#    AG RAD                           SX20 182
f1=NUMB_('_atom_type_scat.specific_dispersion_real',fp,sig)# f'
f2=NUMB_('_atom_type_scat.specific_dispersion_imag',fpp,sig)# f'
f3=NUMB_('_atom_type_scat.specific_cross_section',mua,sig)# sigma
if(f1)ICNTDSP(1)=1#                    set flag
if(f3)ICNTMU(1)=1#                     set flag
ifnv:(mua) MUA=MUA/ATMASS*6.02214199 # redo the avogadro thing
break
$)
#
# check for proximity of absorption edge - and report it!
#
#                                     along with the source!
LOOPS=1#
REPEAT
$(
f1=NUMB_('_atom_type_scat.absorption_edge_wave', WLEN,sig)# 
IF(!F1)BREAK#
f2=NUMB_('_atom_type_scat.absorption_edge_wave_fine',fine,sig)#
if (f1&f2&WAV>fine&WAV<fine+0.0280)#   wavelength in fine range
$(
f3=CHAR_('_atom_type_scat.absorption_edge',edge)
write(6,*) 'WARNING: ',ELSYM,edge(1^5),' edge at ',WLEN
write(6,*) '  Reference:   ',EDGREF
IF(LOOPS==2)NEXT# use first !!!??
itemwave='_atom_type_scat.wavelength_'//EDGE(1^2)//'_edge_fine'
itemmua='_atom_type_scat.absorption_coef_'//EDGE(1^2)//'_edge_mua'
itemfp='_atom_type_scat.dispersion_real_'//EDGE(1^2)//'_edge'
itemfpp='_atom_type_scat.dispersion_imag_'//EDGE(1^2)//'_edge'
LOOPS=2
$)
IF(!LOOP_)BREAK
$)
#
#  LETS INTERPOLATE FROM THE TABULATED VALUES
#  ------------------------------------------
#
IF(LOOPS==1)ifnv:(mua)ifnv:(fp)ifnv:(fpp)NEXT# next data set
DO L=1,LOOPS#                          loop for fine and coarse data
$(
IF(LOOPS==1\L==2)#                     Coarse data
$(
itemwave='_atom_type_scat.wavelength_coarse'
itemmua ='_atom_type_scat.absorption_coef_mua'
itemfp  ='_atom_type_scat.dispersion_real'
itemfpp ='_atom_type_scat.dispersion_imag'
$)
PCNT=0#
REPEAT
$(
IF(!NUMB_(itemwave,A,sig))BREAK
PCNT=PCNT+1
DO I=1,3#                            Shift previous back
$(
WAVE(I)=WAVE(I+1)#
MUAI(I)=MUAI(I+1);FPI(I)=FPI(I+1);FPPI(I)=FPPI(I+1)#
$)
WAVE(I)=A#                           fourth value
F3=NUMB_(itemmua,MUAi(I),sig)
F4=NUMB_(itemfp,fpi(I),sig)
F5=NUMB_(itemfpp,fppi(I),sig)
IF(WAVE(2)<=WAV&WAVE(3)>=WAV&PCNT>3)BREAK# got 4 points
IF(WAVE(1)<=WAV&WAVE(2)>=WAV&PCNT>3)BREAK# got 4 points
IF(!LOOP_)BREAK
$)
#
IF(PCNT>4)# skip method
$(
ifvo:(mua)IF(F3)
$(ICNTMU(2)=1; CALL SX21(WAV,WAVE,MUAI,MUA,4)$)# four point interpolate
ifvo:(fp )IF(F4)
$(ICNTDSP(2)=1; CALL SX21(WAV,WAVE,fpi, fp ,4)$)# four point interpolate
ifvo:(fpp)IF(F5)
$(ICNTDSP(2)=1; CALL SX21(WAV,WAVE,fppi,fpp,4)$)# four point interpolate
$)
IF(L==2)BREAK#
LOOP_=.FALSE.#                         Force to restart loop
$)
$)
#
#  WE HAVE NOW EXTRACTED ALL RELEVANT DATA FROM atomtype.cif
#  ---------------------------------------------------------
#
ifvo:(MUA)MUA=0.0#
EMU(LDSET)=EMU(LDSET)+MUA*QX(K+1)*ATMASS# Add up absorption coef 
#                                                                       SX31  81
#   PUT MISSING F' AND F'' INTO LRSCAT:                                 SX31  82
#   -----------------------------------                                 SX31  83
#                                                                       SX31  84
IF(IRAD>2)#                            Only if xray data                SX31  85
$(
L=K+LDSET+20;    M=K+LDSET+60#         Point to f' and f''              SX31  96
IF(QX(L)>500.) QX(L)=QX(L)-1000.#      Remove the flag from f'          SX31  97
IF(QX(M)>500.) QX(M)=QX(M)-1000.#      Remove the flag from f''         SX31  98
ifvo:(QX(L)) QX(L)=fp#                 stash f'
ifvo:(QX(M)) QX(M)=fpp#                stash f''
$)
#                                                                       SX26  18
#    SAVE FORM FACTOR DATA
#    ---------------------                                              SX26  20
#                                                                       SX26  21
L=K+100#                               Point to first ff (s=0)          SX26  25
ifvo:(QX(L))#                          Skip if ff present
IF(IRAD!=1)#                           If not neutron data              SX20 360
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SX20 361
#                                                                       SX26  18
#    SAVE CROMER MANN COEFFICIENTS
#    -----------------------------
#                                                                       SX26  21
J=K+10#                                Pointer-1 to c-M coeff 
DO I=1,9; QX(J+1+I)=CM(I)#             Store c-m coeffs                 SX26  32
ncodefld:(QX,K+3,SX1,FMT,2)#           Format z and no. electrons       SX26  33
writeline:(1,0,0,1,4)#                 Force list header                SX26  34
LINRM=4;  STOL=0.;      Z=QX(K+3)#     Zero st/l value                  SX26  35
#                                                                       SX26  36
M=INT(2./SINT)+2#                      Get highest s permitted          SX26  22
DO N=1,NSFTB#                          Loop over ff table               SX27  87
$(
S=STOL*STOL;     F=0.#                 Get (sin t /lambda) squared      SX26  39
IF(N<=M)
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX26  38
IF(IRAD>2)#                            For x-radiation                  SX26  41
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX26  42
F=QX(J+10)#                            Initialize ff value              SX26  43
DO I=2,8,2#                            Loop over c-m coeffs             SX26  44
F=F+QX(J+I)*EXP(-MIN(75.,QX(J+I+1)*S))# Xray scattering factor          SX26  45
IF(N==1)F=ANINT(F)#                    Integer for s=0                  SX26  46
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX26  47
#                                                                       SX26  48
ELSE#                                  For electron radiation           SX26  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX26  50
ifeq:(Z,QX(K+4))#                      For neutral atoms                SX26  51
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX26  52
DO I=2,8,2#                            Loop over c-m coeffs             SX26  53
F=F+QX(J+I)*(1.-EXP(-MIN(75.,QX(J+I+1)*S)))# Improved mott expression   SX26  54
ifne:(STOL,0.) F=F/S#                  For non-zero angle               SX26  55
ELSE#                                  For zero angle                   SX26  56
DO I=2,8,2; F=F+QX(J+I)*QX(J+I+1)#     Electron scatt factor            SX26  57
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX26  58
ELSE#                                  For ionized atoms                SX26  59
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX26  60
F=Z-QX(J+10)#                          Start ff value                   SX26  61
DO I=2,8,2#                            Loop over c-m coeffs             SX26  62
F=F-QX(J+I)*EXP(-MIN(75.,QX(J+I+1)*S))# Mott ff expression              SX26  63
ifne:(STOL,0.) F=F/S#                  For non-zero angle               SX26  64
ELSE           F=F/.0001#              Allow for singularity            SX26  65
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX26  66
F=0.023924*F#                          Scale electron scatt factor      SX26  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX26  68
ifeq:(STOL,0.) CHROT(35^)=FRMREF1#     Insert source    
$)
#
#  HIGH ANGLE FOX DATA
#  -------------------
#
IF(N>=M)#                              Overlap on boundary ...
$(
IF(N==M) SCAL=F#                       Get scale to low s data          SX27  91
F=EXP(C0+(C1+(C2+C3*STOL)*STOL)*STOL)# Calculate form factor            SX27  89
IF(IRAD==2) F=0.023924*(Z-F)/(STOL*STOL)# Electron scatt factor         SX27  90
IF(N==M) SCAL=SCAL/F#                  Get scale to low s data          SX27  91
F=F*SCAL#                              Store ff                         SX27  92
IF(N==M) CHROT(35^)=FRMREF2#           Insert source   
$)
#                                                                       SX26  69
IF(prtstat:>3)#                        Print ff if priority > 3         SX26  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX26  71
movertoc:(QX(K+10),1,CHROT,2,8,0)#     Insert ff name                   SX26  73
ncodefld:(STOL,1,CHROT,140942.,1)#     Format st/l value                SX26  74
ncodefld:(F,1,CHROT,290942.,1)#        Format ffact value               SX26  75
writeline:(0,SX1,NSX1,1,4)#            Write ff values                  SX26  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX26  77
QX(L)=F;    L=L+1#                     Store & incr ff table            SX26  78
STOL=STOL+SINT#                        Incr & square st/l               SX26  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX26  80
movector:(FRMREF1(1^24)//FRMREF2(10^26),1,QX(K+90),1,40,0)# save source 
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX26  82
#
#   END OF CIF DATA BLOCK FOR ELEMENT
#   ---------------------------------
#
IACNT=IACNT+1
IF(IACNT>=NSCAT)BREAK#                 Got all needed atom types
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PB00  90
IF(NBLK==0)          iquit:(CF5065)#   No data blocks present           PB00  91
#
#  FINISHED READING THE ATOMTYPE.CIF
#  ---------------------------------
#                                                                       SX20 367
CALL PURGE_#                           Reset the cif tool box           PB00  92
999 CONTINUE#                          cif reading byparse
#
#  CHECK FOR ALL SCATTERING FACTORS
#  --------------------------------
#                                                                       SX20 367
L=no:#                                 Set as no ff's missing           SX20 368
DO I=1,NSCAT#                          Loop atom types                  SX20 369
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SX20 370
J=MARK2+I*STEP2#                       Point to atom type data          SX20 371
ifnv:(QX(J+100)) NEXT#                 Skip if determined               SX20 372
movertoc:(QX(J+10),1,SX68,32,8,0)#     Insert atom type symbol          SX20 373
writeline:(1,SX68,NSX68,3,3)#          Tell user ff missing             SX20 374
ifne:(QX(J+3),0.0,0.001) L=yes:#       Flag problems unless dummy site
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SX20 376
IF(L==yes:) iquit:(SX2012)#            Ff is missing                    SX20 377
#                                                                       SX20 236
#    CANCEL UNUSED LRSCAT: IDNUMS                                       SX20 237
#    ----------------------------                                       SX20 238
#                                                                       SX20 239
IF(IRAD!=1) QX(MARK2+9)=voidflg:#      Remove the neutron id number     SX20 240
IF(IRAD<=2)#                           For neutrons and electrons       SX20 241
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SX20 242
DO I=1,25; QX(MARK2+I+20)=voidflg:#    Cancel dispersion f'             SX20 243
DO I=1,25; QX(MARK2+I+60)=voidflg:#    Cancel dispersion f''            SX20 244
IF(IRAD==1)#                           If neutron data                  SX20 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SX20 246
DO I=1,9;     QX(MARK2+I+11)=voidflg:# Cancel cromer mann coeffs        SX20 247
DO I=1,NSFTB; QX(MARK2+I+99)=voidflg:# Cancel scat factors              SX20 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SX20 249
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SX20 250
#                                                                       SX31 120
#   PRINT CELL CONTENTS                                                 SX31 121
#   -------------------                                                 SX31 122
#                                                                       SX31 123
IF(NSCAT>0)#                           If celcon lines entered          SX31 124
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX31 125
LINRM=8#                               Force content header             SX31 126
SX132(66^66)=''''; SX132(72^73)=''''''# Insert quotes                   SX31 127
IF(IRAD==1) SX132(62^71)=SX130#        Insert neutron header            SX31 128
IF(IRAD==2) SX132(62^71)=' '#          For electrons blank              SX31 129
CHROT=' '#                             
movechar:(SX131,NSX131,CHROT,2,NSX131-2,2)# Insert header underline     SX31 130
writeline:(1,SX131,NSX131-1,2,3)#      Write s.f. name heading          SX31 131
writeline:(0,SX132,NSX132,3,3)#        Write atom type heading          SX31 132
N=0;      PRVOID=no:#                  Suspect moles/cell flag          SX31 133
CELMAS=0.0#
FOR(K=MARK2+STEP2;K<STOP2;K=K+STEP2)#  Loop over ff list                SX31 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX31 135
ifeq:(QX(K+3),0.0,0.001) NEXT#         skip dummy sites
movertoc:(QX(K+10),1,CHROT,10,8,0)#    Insert ff names                  SX31 136
ncodefld:(QX,K+1,CHROT,FMT2, 8)#       Format atom type data            SX31 137
CELMAS=CELMAS+QX(K+1)*QX(K+2)#         Get unit cell mass               SX20 223
IF(QX(K+21)>500.) QX(K+21)=QX(K+21)-1000.# Remove the flag from f' 
IF(QX(K+61)>500.) QX(K+61)=QX(K+61)-1000.# Remove the flag from f' 
IF(IRAD>=3)#                           For xray data                    SX31 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX31 139
ncodefld:(QX,K+21,CHROT,FMT2( 9),1)#   Format f'                        SX31 140
ncodefld:(QX,K+61,CHROT,FMT2(10),1)#   Format f"                        SX31 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX31 142
IF(IRAD==1) ncodefld:(QX,K+9,CHROT,700832.,1)# For neutron data         SX31 143
writeline:(0,0,0,1,3)#                 Write list of s.f. atom type     SX31 144
IF(QX(K+1)<ZMOL) N=1#                  Flag as suspect moles/cell       SX31 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX31 146
ncodefld:(ZMOL,1,SX134,360512.,1)#     Format moles/cell                SX31 147
writeline:(1,SX134,NSX134,3,3)#        Print moles/cell                 SX31 148
IF(N>0)writeline:(1,SX137,NSX137,3,3)# Tell user moles/cell suspect     SX31 149
#                                                                       SX31 150
#   PRINT DENSITIES                                                     SX31 151
#   ---------------                                                     SX31 152
#                                                                       SX31 153
BUFOT(1)=(CELMAS/CELVOL)*1.6605#       Calculate the unit cell dens     SX31 154
ncodefld:(BUFOT,1,SX133,260632.,1)#    Format calculated density        SX31 155
writeline:(1,SX133,NSX133,3,3)#        Print calculated density         SX31 156
QX(MARK4+STEP4+87)=BUFOT(1)#           Store calculated density ds 1    SX31 157
QX(MARK4+STEP4+88)=BUFOT(1)*SIGVOL/CELVOL# Sigma calc. density ds 1     SX31 158
IF(BUFOT(1)<1.)writeline:(1,SX135,NSX135,2,3)# Warning density low      SX31 159
IF(((QX(MARK4+STEP4+85)==0.&BUFOT(1)>2.)\$#                             SX31 160
(QX(MARK4+STEP4+85)>0.&BUFOT(1)>1.1*QX(MARK4+STEP4+85))))#              SX31 161
writeline:(1,SX136,NSX136,2,3)#        Warning density high             SX31 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX31 163
#                                                                       SX20 236
#    ABSORBPTION FACTOR
#    ------------------
#                                                                       SX20 239
FOR(ID=MARK4+STEP4;ID<STOP4;ID=ID+STEP4)# Loop over experimental data 
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SX30 433
ifvo:(QX(ID+1)) NEXT#                  Skip void data sets              SX30 434
LDSET=NINT(QX(ID+1))#                  1-25
IF(REQCIF==yes:)QX(ID+10)=EMU(1)/CELVOL/6.02214199# Mu in /mm  
# if mass/volume has changed disproportionately this is wrong.
# ideally atomic mu values would be archived for recalculation
# but possibly need 25 values for 25 data sets and there is no room
# in lrscat record. 
ncodefld:(QX,ID+10,SX401,450832.,1)#   Format abs coeff      
writeline:(1,SX401,NSX401,2,3)#        Print the abs coeff              SX40  63
$)
#
#    ACKNOWLEDGEMENTS
#    ----------------
#
CHROT=' '
IF(REQCIF==yes:)#                      skip otherwise - already stated
$(
writeline:(1,SX351,NSX351,3,3)#        Anomalous dispersion
DO I=1,2#                              two possible sources
$(
IF(I==1&ICNTDSP(I)==1) CHROT(20^)=DSPREF1
IF(I==2&ICNTDSP(I)==1) CHROT(20^)=DSPREF2
IF(ICNTDSP(I)==1) writeline:(0,CHROT,80,3,3)# Anomalous dispersion
$)
CHROT=' '
writeline:(1,SX352,NSX352,3,3)#        Anomalous dispersion
DO I=1,2#                              two possible sources
$(
IF(I==1&ICNTMU(I)==1) CHROT(20^)=MUAREF1
IF(I==2&ICNTMU(I)==1) CHROT(20^)=MUAREF2
IF(ICNTMU(I)==1) writeline:(0,CHROT,80,3,3)# Anomalous dispersion
$)
CHROT=' '#
$)
#                                                                       SX31 164
RETURN#                                                                 SX31 165
END#                                                                    SX31 166
systemheader:(SX40)#                   Build last records for start     SX40   1
######################################################################  SX40   2
#                                                                    #  SX40   3
#                               SX40                                 #  SX40   4
#                                                                    #  SX40   5
######################################################################  SX40   6
SUBROUTINE SX40#                                                        SX40   7
include:(AACOMN)#                                                       SX40   8
include:(SXCOMN)#                                                       SX40   9
#                                                                       SX40  10
INTEGER I,J,K,L,M,N#                                                    SX40  11
INTEGER IP#                                                             SX40  12
datastuff:#                                                             SX40  14
#                                                                       SX40  15
#    COUNT NUMBER OF DATA SETS                                          SX40  16
#    -------------------------                                          SX40  17
#                                                                       SX40  18
N=0#                                   Start data set count             SX40  19
DO I=1,25#                             Loop over possible datasets      SX40  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SX40  21
J=MARK4+I*STEP4#                       Point to each data set           SX40  22
ifnv:(QX(J+1)) N=MAX(N,NINT(QX(J+1)))# Get max ds number present        SX40  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SX40  24
#                                                                       SX40  25
#   OUTPUT LRSCAT:                                                      SX40  26
#   --------------                                                      SX40  27
#                                                                       SX40  28
M=7#                                   Start count of data items        SX40  29
DO I=N,24; QX(MARK2+I+21)=voidflg:#    Switch off unused datasets       SX40  30
DO I=N,24; QX(MARK2+I+61)=voidflg:#    Switch off unused datasets       SX40  31
DO I=8,STEP2; ifnv:(QX(MARK2+I)) M=M+1# Loop over each item             SX40  32
DO J=0,NSCAT#                          Loop over dir + data             SX40  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SX40  34
writepkt:(2,lrscat:,M,IP)#             Get packet dir pointer           SX40  35
L=0;   K=MARK2+J*STEP2#                Start count of data items        SX40  36
DO I=1,STEP2#                          Loop data items                  SX40  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SX40  38
IF(I>7) ifvo:(QX(MARK2+I)) NEXT#       Skip if idnum void               SX40  39
L=L+1; QX(IP+L)=QX(K+I)#               Store active idnums/data         SX40  40
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SX40  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SX40  42
#                                                                       SX40  43
#    OUTPUT LRDDEF:                                                     SX40  44
#    --------------                                                     SX40  45
#                                                                       SX40  46
DO I=1,N#                              Loop over actual data sets       SX40  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SX40  48
writepkt:(2,lrddef:,mxwd12c:,IP)#      Get output pointer for write     SX40  49
movector:(DSNAME,12*I-11,QX(IP+1),1,12,0)# Output dataset name          SX40  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SX40  51
#                                                                       SX40  52
#   OUTPUT LREXPL:                                                      SX40  53
#   --------------                                                      SX40  54
#                                                                       SX40  55
M=2;   J=0#                            Start count of data items        SX40  56
DO I=1,25; J=MAX(ISCALE(I),J)#         Get max number scales            SX40  57
DO I=101+J,164; QX(MARK4+I)=voidflg:#  Switch off unused scale groups   SX40  58
DO I=3,STEP4; ifnv:(QX(MARK4+I)) M=M+1# Loop over each item             SX40  59
DO J=0,N#                              Loop over dir + data             SX40  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SX40  65
writepkt:(2,lrexpl:,M,IP)#             Get packet dir pointer           SX40  66
L=0;   K=MARK4+J*STEP4#                Start count of data items        SX40  67
DO I=1,STEP4#                          Loop data items                  SX40  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SX40  69
IF(I>2) ifvo:(QX(MARK4+I)) NEXT#       Skip if idnum void               SX40  70
L=L+1; QX(IP+L)=QX(K+I)#               Store active idnums/data         SX40  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SX40  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SX40  73
#                                                                       SX40  74
#   OUTPUT LRDSET:                                                      SX40  75
#   --------------                                                      SX40  76
#                                                                       SX40  77
M=12#                                  Start count of data items        SX40  78
DO I=13,STEP5; ifnv:(QX(MARK5+I)) M=M+1# Loop over each item            SX40  79
DO J=0,N#                              Loop over dir + data             SX40  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SX40  81
writepkt:(2,lrdset:,M,IP)#             Get packet dir pointer           SX40  82
L=0;   K=MARK5+J*STEP5#                Start count of data items        SX40  83
DO I=1,STEP5#                          Loop data items                  SX40  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SX40  85
IF(I>12) ifvo:(QX(MARK5+I)) NEXT#      Skip if idnum void               SX40  86
L=L+1; QX(IP+L)=QX(K+I)#               Store active idnums/data         SX40  87
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SX40  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SX40  89
#                                                                       SX40  90
IF(UPD==yes:) copyfile:(1,2,incr:(lrdset:),endrecord:)# Finish off      SX40  91
ELSE          writepkt:(2,endrecord:,1,IP)# Finish off the file         SX40  92
#                                                                       SX40  93
RETURN#                                                                 SX40  94
END#                                                                    SX40  95
pmacro:([no:])#                        Purge xtal system macros         SX41  72
